using System;
using System.Data;
using System.Data.OleDb;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for CCompanies.
	/// </summary>
	public class CCompanies
	{
		private static OleDbDataAdapter mDaCompanies;

		public static void FillData(dsCompanies dsCompanies1,
									bool Housing,
									bool Endowment,		
									bool Indemnity,
									bool Valuer,
									bool SecondCharge,
									bool Creditor,
									bool EstateAgent,
									bool InvoiceSource,
									bool Employer)
		{
			DataAdapter.SelectCommand.Parameters["ValidForHousingAssociation"].Value = Housing;
			DataAdapter.SelectCommand.Parameters["ValidForEndowmentCompany"].Value = Endowment;
			DataAdapter.SelectCommand.Parameters["ValidForIndemnityCompany"].Value = Indemnity;
			DataAdapter.SelectCommand.Parameters["ValidForValuer"].Value = Valuer;
			DataAdapter.SelectCommand.Parameters["ValidForSecondCharge"].Value = SecondCharge;
			DataAdapter.SelectCommand.Parameters["ValidForCreditor"].Value = Creditor;
			DataAdapter.SelectCommand.Parameters["ValidForEstateAgent"].Value = EstateAgent;
			DataAdapter.SelectCommand.Parameters["ValidForInvoiceSource"].Value = InvoiceSource;
			DataAdapter.SelectCommand.Parameters["ValidForEmployer"].Value = Employer;
			DataAdapter.Fill(dsCompanies1, "Companies");
		}

		public static dsCompanies GetRowFromShortName(string ShortName)
		{
			dsCompanies temp = new dsCompanies();
			OleDbDataAdapter daTemp = new OleDbDataAdapter();
			daTemp.SelectCommand = new OleDbCommand();
			daTemp.SelectCommand.CommandText = "Select * From Companies Where ShortName = '" + ShortName + "'";
			cMyDB.FillDS(temp,"Companies",daTemp);
			return temp;
		}

		public static OleDbDataAdapter DataAdapter
		{
			get
			{
				if (mDaCompanies==null)
				{
					// 
					// daCompanies
					// 
					mDaCompanies = new OleDbDataAdapter();
					mDaCompanies.DeleteCommand = new OleDbCommand();
					mDaCompanies.InsertCommand = new OleDbCommand();
					mDaCompanies.SelectCommand = new OleDbCommand();
					mDaCompanies.UpdateCommand = new OleDbCommand();
					// 
					// cmdInsertCompanies
					// 
					mDaCompanies.InsertCommand.CommandText = @"INSERT INTO Companies(Address, Created, CreateUser, Email, FullName, LastUpdated, LastUser, Notes, PostCode, ShortName, TelephoneNo, ValidForCreditor, ValidForEmployer, ValidForEndowmentCompany, ValidForEstateAgent, ValidForHousingAssociation, ValidForIndemnityCompany, ValidForInvoiceSource, ValidForSecondCharge, ValidForValuer) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
					mDaCompanies.InsertCommand.Connection = cMyDB.NewConnection();
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Address", System.Data.OleDb.OleDbType.VarWChar, 255, "Address"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Email", System.Data.OleDb.OleDbType.VarWChar, 255, "Email"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("FullName", System.Data.OleDb.OleDbType.VarWChar, 50, "FullName"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("PostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PostCode"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ShortName", System.Data.OleDb.OleDbType.VarWChar, 10, "ShortName"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneNo", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneNo"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForCreditor", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForCreditor"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEmployer", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEmployer"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEndowmentCompany", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEndowmentCompany"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEstateAgent", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEstateAgent"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForHousingAssociation", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForHousingAssociation"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForIndemnityCompany", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForIndemnityCompany"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForInvoiceSource", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForInvoiceSource"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForSecondCharge", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForSecondCharge"));
					mDaCompanies.InsertCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForValuer", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForValuer"));
					// 
					// cmdUpdateCompanies
					// 
					mDaCompanies.UpdateCommand.CommandText = @"UPDATE Companies SET Address = ?, Created = ?, CreateUser = ?, Email = ?, FullName = ?, LastUpdated = ?, LastUser = ?, Notes = ?, PostCode = ?, ShortName = ?, TelephoneNo = ?, ValidForCreditor = ?, ValidForEmployer = ?, ValidForEndowmentCompany = ?, ValidForEstateAgent = ?, ValidForHousingAssociation = ?, ValidForIndemnityCompany = ?, ValidForInvoiceSource = ?, ValidForSecondCharge = ?, ValidForValuer = ? WHERE (ShortName = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
					mDaCompanies.UpdateCommand.Connection = mDaCompanies.InsertCommand.Connection;
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Address", System.Data.OleDb.OleDbType.VarWChar, 255, "Address"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.Date, 0, "Created"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Email", System.Data.OleDb.OleDbType.VarWChar, 255, "Email"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("FullName", System.Data.OleDb.OleDbType.VarWChar, 50, "FullName"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("PostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PostCode"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ShortName", System.Data.OleDb.OleDbType.VarWChar, 10, "ShortName"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("TelephoneNo", System.Data.OleDb.OleDbType.VarWChar, 15, "TelephoneNo"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForCreditor", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForCreditor"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEmployer", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEmployer"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEndowmentCompany", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEndowmentCompany"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEstateAgent", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForEstateAgent"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForHousingAssociation", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForHousingAssociation"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForIndemnityCompany", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForIndemnityCompany"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForInvoiceSource", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForInvoiceSource"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForSecondCharge", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForSecondCharge"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForValuer", System.Data.OleDb.OleDbType.Boolean, 2, "ValidForValuer"));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ShortName", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShortName", System.Data.DataRowVersion.Original, null));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
					mDaCompanies.UpdateCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated1", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
					// 
					// cmdDeleteCompanies
					// 
					mDaCompanies.DeleteCommand.CommandText = "DELETE FROM Companies WHERE (ShortName = ?) AND (LastUpdated = ? OR LastUpdated I" +
						"S NULL AND ? IS NULL)";
					mDaCompanies.DeleteCommand.Connection = mDaCompanies.InsertCommand.Connection;
					mDaCompanies.DeleteCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ShortName", System.Data.OleDb.OleDbType.VarWChar, 10, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "ShortName", System.Data.DataRowVersion.Original, null));
					mDaCompanies.DeleteCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
					mDaCompanies.DeleteCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("OriginalLastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
					// 
					// cmdSelectCompanies
					// 
					mDaCompanies.SelectCommand.CommandText = @"SELECT Address, Created, CreateUser, Email, FullName, LastUpdated, LastUser, Notes, PostCode, ShortName, TelephoneNo, ValidForCreditor, ValidForEmployer, ValidForEndowmentCompany, ValidForEstateAgent, ValidForHousingAssociation, ValidForIndemnityCompany, ValidForInvoiceSource, ValidForSecondCharge, ValidForValuer FROM Companies WHERE (ValidForCreditor AND ?) OR (ValidForEmployer AND ?) OR (ValidForEndowmentCompany AND ?) OR (ValidForEstateAgent AND ?) OR (ValidForHousingAssociation AND ?) OR (ValidForIndemnityCompany AND ?) OR (ValidForInvoiceSource AND ?) OR (ValidForSecondCharge AND ?) OR (ValidForValuer AND ?)";
					mDaCompanies.SelectCommand.Connection = mDaCompanies.InsertCommand.Connection;
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForCreditor", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEmployer", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEndowmentCompany", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForEstateAgent", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForHousingAssociation", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForIndemnityCompany", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForInvoiceSource", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForSecondCharge", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));
					mDaCompanies.SelectCommand.Parameters.Add(new System.Data.OleDb.OleDbParameter("ValidForValuer", System.Data.OleDb.OleDbType.Boolean, 2, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, "false"));

					mDaCompanies.RowUpdated += new OleDbRowUpdatedEventHandler(daCompanies_RowUpdated);
				}
				return mDaCompanies;
			}
		}

		private static void daCompanies_RowUpdated(object sender, OleDbRowUpdatedEventArgs e)
		{
			if (e.RecordsAffected == 0)
			{
				if (e.Errors is DBConcurrencyException)
				{
					dsCompanies current = GetRowFromShortName(e.Row["ShortName"].ToString());

					if (current.Companies.Rows.Count > 0)	
					{
						RecordConflict rcFrm = new RecordConflict();
						rcFrm.Compare(current.Companies.Rows[0], e.Row);

						rcFrm.ShowDialog();

						if (rcFrm.DialogResult != System.Windows.Forms.DialogResult.OK)
							e.Status = UpdateStatus.SkipCurrentRow;

						rcFrm.Dispose();

						if (e.Status != UpdateStatus.SkipCurrentRow)
						{
							current.Companies.Rows[0].BeginEdit();
							foreach (DataColumn dc in current.Companies.Columns)
							{
								current.Companies.Rows[0][dc.ColumnName] = e.Row[dc.ColumnName];
							}
							current.Companies.Rows[0].EndEdit();
							DataAdapter.Update(current, "Companies");
							e.Status = UpdateStatus.Continue;
						}
					}
					current.Dispose();
				}
			}
		} 

		public static void AddCompany(bool Housing,
									bool Endowment,		
									bool Indemnity,
									bool Valuer,
									bool SecondCharge,
									bool Creditor,
									bool EstateAgent,
									bool InvoiceSource,
									bool Employer)
		{
			frmCompanies frm = new frmCompanies();
			frm.NewCompany(  Housing,
							 Endowment,		
							 Indemnity,
							 Valuer,
							 SecondCharge,
							 Creditor,
							 EstateAgent,
							 InvoiceSource,
							 Employer);
			frm.ShowDialog();
		}

		public static void EditCompany(string ShortName)
		{
			frmCompanies frm = new frmCompanies();
			frm.EditCompany(ShortName);
			frm.ShowDialog();
		}

		public static bool DeleteCompany(string ShortName, object LastUpdated)
		{
			bool ItemDeleted = false; 
			bool DeleteCancelled = false;
			int noOfDependents = (int)cMyDB.GetResult("Select count(FieldName) from LookupFields Where LookupID = 'Companies'");
			object retval;
			
			if (System.Windows.Forms.MessageBox.Show("Are you sure you want to delete the selected company from the database. NOTE, this will completely delete the company and will affect all users.", "Confirm Delete",System.Windows.Forms.MessageBoxButtons.YesNo) == System.Windows.Forms.DialogResult.No)
				DeleteCancelled = true;
            
			if (!DeleteCancelled)
			{
				Processing p = new Processing();
				try
				{
					retval = cMyDB.GetResult("Select LastUpdated from Companies Where ShortName = '" + ShortName + "'");

					if (retval == null || !retval.Equals(LastUpdated))
						throw new Exception("The company you are trying to delete has been modified by another user and will not be deleted. Review the updated list contents, if you still want to delete the entry you will be able to.");

					if (noOfDependents > 0)
					{
						p.progress.Minimum = 1;
						p.progress.Maximum = noOfDependents;
						p.Caption = "Checking the database for dependent values.";
						p.Show();
						p.Refresh();
						DataTable dependents = cMyDB.GetDataTable("Select LookupId,FieldName,TableName from LookupFields Where LookupID = 'Companies'");
						string sql = null;

						for (int i = p.progress.Minimum; i<(p.progress.Maximum + 1) ; i++)
						{
							p.progress.Value = i;

							sql = "SELECT " + dependents.Rows[i-1][1].ToString() + " FROM " + dependents.Rows[i-1][2].ToString() + " WHERE " + dependents.Rows[i-1][1].ToString() + " = '" + ShortName + "'";
							if (!cMyDB.IsEmpty(sql))
							{
								System.Windows.Forms.MessageBox.Show("The selected company is in use by cases in the database and cannot be deleted.", "Delete Cancelled");
								DeleteCancelled = true;
								break;
							}
						}
					}
					if (!DeleteCancelled)
					{
						p.Caption = "Updating Database";
						p.progress.Minimum = 1;
						p.progress.Maximum = 1;
						p.progress.Value = 1;

						OleDbCommand cmd = new OleDbCommand();
						cmd.CommandText = "Delete From Companies Where ShortName = '" + ShortName + "'";
						cMyDB.Execute(cmd);
						ItemDeleted = true;
					}
				}
				catch (Exception e)
				{
					System.Windows.Forms.MessageBox.Show("This item could not be deleted. " + e.Message, "Error");
				}
				finally
				{
					p.Close();
				}
			}
			return ItemDeleted;
		}

		public static void CleanUp()
		{
			mDaCompanies.Dispose();
		}
	}
}
