using System;
using System.Data;
using System.Drawing;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for DTPBinding.
	/// </summary>
	public class DTPBinding : Binding
	{	
		public DTPBinding(string PropertyName, Object DataSource , string DataMember)
			: base(PropertyName, DataSource, DataMember)
		{
		}

		protected override void OnFormat(ConvertEventArgs cevent)
		{
			if(cevent.DesiredType!= typeof(bool)) return;

			DateTimePicker dtp = this.Control as DateTimePicker;
			if(dtp == null)
				return;
			if(cevent.Value==null || cevent.Value==DBNull.Value) 
			{
				cevent.Value = false;
			}
			else 
			{
				dtp.Value = (DateTime) cevent.Value;
				cevent.Value = true;
			}
			base.OnFormat(cevent);
		}

		protected override void OnParse(ConvertEventArgs cevent)
		{
			if(cevent.DesiredType!=typeof(DateTime)) return;

			DateTimePicker dtp = this.Control as DateTimePicker;
			if(dtp == null)
				return;
			if(dtp.Checked)
				cevent.Value = dtp.Value;
			else
				cevent.Value = DBNull.Value;
			base.OnParse(cevent);
		}
	}
}
