using System;
using System.Data;
using System.Data.OleDb;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for DebtBaseForm.
	/// </summary>
	public class DebtBaseForm : System.Windows.Forms.Form
	{
		public Crownwood.Magic.Controls.TabControl tabControl1;
		public Crownwood.Magic.Controls.TabPage tabGeneral;
		public System.Windows.Forms.Label lblStatus;
		public UtilityLibrary.WinControls.ButtonEx cmdOK;
		public UtilityLibrary.WinControls.ButtonEx cmdCancel;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		protected OleDbDataAdapter mDa;
		protected DataSet mDs;
		protected string mTableName;
		protected bool Adding = false;

		public DebtBaseForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//			
			this.tabGeneral.BindingContext = this.BindingContext;			
		}
		
		protected OleDbDataAdapter daMain
		{
			get
			{
				return mDa;
			}
			set
			{
				mDa = value;
				mDa.SelectCommand.Connection = cMyDB.NewConnection();
				mDa.UpdateCommand.Connection = mDa.SelectCommand.Connection;
				mDa.InsertCommand.Connection = mDa.SelectCommand.Connection;
				mDa.DeleteCommand.Connection = mDa.SelectCommand.Connection;
				mDa.RowUpdated += new OleDbRowUpdatedEventHandler(this.daMain_RowUpdated);
			}
		}
		public virtual void AddNew(Int32 CaseID)
		{
			DataRow dr = mDs.Tables[mTableName].NewRow();
			dr.BeginEdit();
			dr["CaseID"] = CaseID;
			dr["Created"]= DateTime.Now;
			dr["CreateUser"] = CSession.User.Username;
			dr.EndEdit();
			mDs.Tables[mTableName].Rows.Add(dr);
			Adding = true;
		}
		public virtual void Edit(Int32 ID)
		{
			mDa.SelectCommand.Parameters["ID"].Value = ID;
			mDa.Fill(mDs, mTableName); 
			if (!mDs.Tables[mTableName].Rows[0]["LastUpdated"].Equals(DBNull.Value))
				this.lblStatus.Text = "Last Updated " + ((DateTime)mDs.Tables[mTableName].Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (mDs.Tables[mTableName].Rows[0]["LastUser"] + "");
		}
		public void Delete(Int32 ID)
		{
			mDa.SelectCommand.Parameters["ID"].Value = ID;
			mDa.Fill(mDs, mTableName);
			DataRow dr = mDs.Tables[mTableName].Rows[0];
			dr.Delete();
			mDa.Update(mDs, mTableName);
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
					if (mDa != null)
					{
						mDa.SelectCommand.Connection.Dispose();
						mDa.Dispose();
					}
					if (mDs != null)
						mDs.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabControl1 = new Crownwood.Magic.Controls.TabControl();
			this.tabGeneral = new Crownwood.Magic.Controls.TabPage();
			this.lblStatus = new System.Windows.Forms.Label();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.tabControl1.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabGeneral});
			this.tabControl1.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabControl1.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabControl1.Name = "tabControl1";
			this.tabControl1.PositionTop = true;
			this.tabControl1.SelectedIndex = 0;
			this.tabControl1.SelectedTab = this.tabGeneral;
			this.tabControl1.Size = new System.Drawing.Size(326, 201);
			this.tabControl1.TabIndex = 26;
			this.tabControl1.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabGeneral});
			// 
			// tabGeneral
			// 
			this.tabGeneral.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.tabGeneral.Location = new System.Drawing.Point(0, 25);
			this.tabGeneral.Name = "tabGeneral";
			this.tabGeneral.Size = new System.Drawing.Size(326, 176);
			this.tabGeneral.TabIndex = 3;
			this.tabGeneral.Title = "General";
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(4, 209);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(166, 27);
			this.lblStatus.TabIndex = 28;
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(173, 212);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.Size = new System.Drawing.Size(68, 23);
			this.cmdOK.TabIndex = 27;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(248, 212);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(70, 23);
			this.cmdCancel.TabIndex = 29;
			this.cmdCancel.Text = "Cancel";
			// 
			// DebtBaseForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(326, 242);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "DebtBaseForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "DebtBaseForm";
			this.tabControl1.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		protected void OKProc(DataSet ds, OleDbDataAdapter da, string tableName)
		{
			this.BindingContext[ds, tableName].EndCurrentEdit();
			if (ds.Tables[tableName].Rows[0].RowState != DataRowState.Unchanged)
			{
				ds.Tables[tableName].Rows[0]["LastUpdated"] = DateTime.Now;
				ds.Tables[tableName].Rows[0]["LastUser"] = CSession.User.Username;
				da.Update(ds, tableName);
			}
		}

		virtual protected void cmdOK_Click(object sender, System.EventArgs e)
		{
			OKProc(mDs,mDa,mTableName);
		}

		private void daMain_RowUpdated(object sender, System.Data.OleDb.OleDbRowUpdatedEventArgs e)
		{
			if (e.RecordsAffected == 0)
			{
				DataSet ds = new DataSet();
				mDa.SelectCommand.Parameters["ID"].Value = e.Row["ID"];
				mDa.Fill(ds);
				if (ds.Tables[0].Rows.Count > 0)
					CUtil.RowUpdatedHandler(e, ds, mDa);
				else
				{
					MessageBox.Show("This item has been deleted by another user, your changes could not be saved.","Update Error");
					e.Status = UpdateStatus.SkipCurrentRow;
				}
				ds.Dispose();
			}
		}
	}
}
