using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for EndowmentListManager.
	/// </summary>
	public class EndowmentListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmEndowments();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select EndowmentCompany, PolicyNo, SumAssured, SurrenderValue, SurrenderDate, ID From EndowmentPolicies Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				temp = lvw.Items.Add(dr["EndowmentCompany"] + String.Empty);
				temp.SubItems.Add(dr["PolicyNo"] + String.Empty);
				if (!dr["SumAssured"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["SumAssured"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				if (!dr["SurrenderValue"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["SurrenderValue"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				if (!dr["SurrenderDate"].Equals(DBNull.Value))
					temp.SubItems.Add("Yes");
				else
					temp.SubItems.Add("No");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Company",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Policy Number",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Sum Assured",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Right);
			lvw.Columns.Add("Surrender Value",lvw.ClientSize.Width / 5, System.Windows.Forms.HorizontalAlignment.Right);
			lvw.Columns.Add("Sur'd",lvw.ClientSize.Width * 3 / 20, System.Windows.Forms.HorizontalAlignment.Left);			
		}
	}
}
