using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for LoginForm.
	/// </summary>
	public class LoginForm : System.Windows.Forms.Form
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.Label label2;
		public System.Windows.Forms.TextBox txtPassword;
		private System.Windows.Forms.Button cmdCancel;
		private System.Windows.Forms.Button cmdOk;
		public System.Windows.Forms.ComboBox cboUser;
		private System.Windows.Forms.Button cmdChangePassword;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public LoginForm()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			DataTable dt = cMyDB.GetDataTable("Select Username, ID from Users");
			cboUser.DataSource = dt;
			cboUser.DisplayMember = "Username";
			cboUser.ValueMember = "ID";
			if (cboUser.Items.Count > 0)
				cboUser.SelectedIndex = 0;
			cboUser.Select();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cboUser = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.txtPassword = new System.Windows.Forms.TextBox();
			this.label2 = new System.Windows.Forms.Label();
			this.cmdCancel = new System.Windows.Forms.Button();
			this.cmdOk = new System.Windows.Forms.Button();
			this.cmdChangePassword = new System.Windows.Forms.Button();
			this.SuspendLayout();
			// 
			// cboUser
			// 
			this.cboUser.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboUser.Location = new System.Drawing.Point(123, 14);
			this.cboUser.Name = "cboUser";
			this.cboUser.Size = new System.Drawing.Size(126, 21);
			this.cboUser.TabIndex = 0;
			this.cboUser.SelectedIndexChanged += new System.EventHandler(this.cboUser_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(20, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(88, 23);
			this.label1.TabIndex = 1;
			this.label1.Text = "User Name";
			// 
			// txtPassword
			// 
			this.txtPassword.Location = new System.Drawing.Point(123, 41);
			this.txtPassword.Name = "txtPassword";
			this.txtPassword.PasswordChar = '*';
			this.txtPassword.Size = new System.Drawing.Size(126, 20);
			this.txtPassword.TabIndex = 2;
			this.txtPassword.Text = "";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(20, 42);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(86, 23);
			this.label2.TabIndex = 3;
			this.label2.Text = "Password";
			// 
			// cmdCancel
			// 
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(206, 83);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.Size = new System.Drawing.Size(59, 23);
			this.cmdCancel.TabIndex = 4;
			this.cmdCancel.Text = "Cancel";
			this.cmdCancel.Click += new System.EventHandler(this.cmdCancel_Click);
			// 
			// cmdOk
			// 
			this.cmdOk.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOk.Location = new System.Drawing.Point(132, 83);
			this.cmdOk.Name = "cmdOk";
			this.cmdOk.Size = new System.Drawing.Size(60, 23);
			this.cmdOk.TabIndex = 5;
			this.cmdOk.Text = "OK";
			this.cmdOk.Click += new System.EventHandler(this.cmdOk_Click);
			// 
			// cmdChangePassword
			// 
			this.cmdChangePassword.Location = new System.Drawing.Point(10, 83);
			this.cmdChangePassword.Name = "cmdChangePassword";
			this.cmdChangePassword.Size = new System.Drawing.Size(106, 23);
			this.cmdChangePassword.TabIndex = 6;
			this.cmdChangePassword.Text = "Change Password";
			this.cmdChangePassword.Visible = false;
			this.cmdChangePassword.Click += new System.EventHandler(this.cmdChangePassword_Click);
			// 
			// LoginForm
			// 
			this.AcceptButton = this.cmdOk;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(275, 116);
			this.ControlBox = false;
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdChangePassword,
																		  this.cmdOk,
																		  this.cmdCancel,
																		  this.label2,
																		  this.txtPassword,
																		  this.label1,
																		  this.cboUser});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedSingle;
			this.Name = "LoginForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Login";
			this.TopMost = true;
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOk_Click(object sender, System.EventArgs e)
		{
			if (cboUser.SelectedIndex >= 0)
			{
				this.Hide();
			}
			else
			{
				MessageBox.Show("You must select a user name", "Input Error");
			}
		}

		private void cmdCancel_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void cmdChangePassword_Click(object sender, System.EventArgs e)
		{
			if(!CSession.ChangePassword((Int32)cboUser.SelectedValue))
			{
				this.txtPassword.Focus();
			}
		}

		private void cboUser_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (cboUser.SelectedIndex >= 0 )
				cmdChangePassword.Visible = true;
			else
				cmdChangePassword.Visible = false;
		}

	}
}
