using System;
using System.Data;
using System.Collections;

namespace DebtManagerTest
{
	/// <summary>
	/// This class holds the configuration data for all of the 
	/// lookup boxes. It prevents data access each time a new lookup box is 
	/// drawn
	/// </summary>
	public class LookupDataManager
	{
		static private bool loaded = false;
		static private Hashtable ht;
		
		static public void CleanUp()
		{
			ht = null;
		}		
		static private void GetDataSet()
		{
			LookupConfig lc;
			DataTable dt;
			DataTable dep;
			dt = cMyDB.GetDataTable("Select * From LookupDefinitions");
			ht = new Hashtable();
			for (int i = 0; i < dt.Rows.Count; i++)
			{
				lc = new LookupConfig((string)nz(dt.Rows[i][0],""),
					(string)nz(dt.Rows[i][1],""),(string)nz(dt.Rows[i][2],""),
					(string)nz(dt.Rows[i][3],""),(Boolean)dt.Rows[i][4],
					(Int32)nz(dt.Rows[i][5],-1),(string)nz(dt.Rows[i][6],""),
					(Boolean)dt.Rows[i][7],(Int32)nz(dt.Rows[i][8],-1),
					(string)nz(dt.Rows[i][9],""),(string)nz(dt.Rows[i][10],""),
					(string)nz(dt.Rows[i][11],""),(string)nz(dt.Rows[i][12],""),
					(string)nz(dt.Rows[i][13],""),(string)nz(dt.Rows[i][14],""),
					(Int32)nz(dt.Rows[i][15],0),(Int32)nz(dt.Rows[i][16],0),
					(Int32)nz(dt.Rows[i][17],0));
				dep = cMyDB.GetDataTable("Select * from lookupFields Where LookupID = '" + nz(dt.Rows[i][0],"") + "'");
				lc.Dependents = dep;
				ht.Add(lc.ID,lc);
				dep.Dispose();
			}
			dt.Dispose();
			lc = null;
			loaded = true;
		}
		static public LookupConfig GetConfig(string Lookup)
		{
			if (!loaded)
			{
				GetDataSet();
			}
			if (loaded)
			{
				if (ht.Contains(Lookup))
				{
					return (LookupConfig) ht[Lookup];
				}
				else 
				{
					return null;
				}
			}
			else
			{
				return null;
			}
		}
		static public object nz(object obj,object replacewith)
		{
			if (obj.GetType() != typeof(DBNull))
			{
				return obj;
			}
			else
			{
				return replacewith;
			}
		}
	}
}
