using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for MarketingReportListManager.
	/// </summary>
	public class MarketingReportListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmMarketingReports();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select ReportDate,ReductionRecommended, SuggestedPrice, AgentsComments, ID From MarketingReports Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["ReportDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["ReportDate"]).ToShortDateString() + "");
				else
					temp = lvw.Items.Add("Date Not Specified");
				if (!dr["SuggestedPrice"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["SuggestedPrice"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				temp.SubItems.Add(dr["AgentsComments"] + "");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Report Date",lvw.ClientSize.Width/4,System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Suggested Price",lvw.ClientSize.Width/4,System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Agents Comments",lvw.ClientSize.Width /2,System.Windows.Forms.HorizontalAlignment.Left);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
			{
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
			}
		}
	}
}
