using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for OfferListManager.
	/// </summary>
	public class OfferListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmOffers();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select OfferDate, b.Description as OffStatus, OfferAmount, PurchaserName, Offers.ID From Offers Left Join OfferStatusLookup as b on Offers.Status = b.ID Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["OfferDate"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["OfferDate"]).ToShortDateString() + "");
				else
					continue;
				//temp = lvw.Items.Add("Date Not Specified");
				temp.SubItems.Add(dr["OffStatus"] + String.Empty);
				if (!dr["OfferAmount"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["OfferAmount"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				temp.SubItems.Add(dr["PurchaserName"] + String.Empty);				
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Offer Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Status",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Amount Offered",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Purchaser",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
		}
	}
}
