using System;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for PercentageBinding.
	/// </summary>
	public class PercentageBinding : Binding
	{
		public PercentageBinding(string PropertyName, Object DataSource , string DataMember)
			: base(PropertyName, DataSource, DataMember)
		{
		}
		
		protected override void OnFormat(ConvertEventArgs cevent)
		{			
			if(cevent.DesiredType != typeof(string)) return;

			if(!cevent.Value.Equals(DBNull.Value))
				cevent.Value = ((Single) cevent.Value).ToString("#0.##%");
		}

		protected override void OnParse(ConvertEventArgs cevent)
		{	
			if(cevent.DesiredType != typeof(Single)) return;

			if (cevent.Value.ToString()!="")
			{
				if (cevent.Value.ToString().IndexOf('%') > 0)
				{
					cevent.Value = cevent.Value.ToString().Replace('%',' ');
					cevent.Value = (Single.Parse(cevent.Value.ToString(),System.Globalization.NumberStyles.Float, null))/100;
				}
				else
					cevent.Value = Single.Parse(cevent.Value.ToString(),System.Globalization.NumberStyles.Float, null);
			}
			else
				cevent.Value = DBNull.Value;
		}
	}
}
