using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Data.OleDb;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmDiarise.
	/// </summary>
	public class frmDiarise : System.Windows.Forms.Form
	{
		private Crownwood.Magic.Controls.TabControl tabs;
		private Crownwood.Magic.Controls.TabPage tpDetails;
		private Crownwood.Magic.Controls.TabPage tpNotes;
		private System.Windows.Forms.CheckBox chkAllUsers;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.TextBox txtDescription;
		private System.Windows.Forms.MonthCalendar dtActionDate;
		private System.Windows.Forms.Label label2;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboActionType;
		private System.Windows.Forms.ComboBox cboCases;
		private System.Windows.Forms.Label label1;
		private UtilityLibrary.WinControls.ButtonEx cmdCancel;
		private UtilityLibrary.WinControls.ButtonEx cmdOK;
		private System.Windows.Forms.TextBox txtNotes;
		private System.Windows.Forms.Label lblStatus;
		private DebtManagerTest.InterfaceComponents.dsDiary dsDiary1;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool Adding = false;

        public Int32 CaseID
		{
			get
			{
				if (dsDiary1.Diary.Count> 0)
				{
					if (dsDiary1.Diary[0].IsCaseIDNull())
						return -1;
					else
						return dsDiary1.Diary[0].CaseID;
				}
				return -1;
			}
		}

		public frmDiarise()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
		}

		private void PrepGeneral()
		{
			DataTable dtCases = cMyDB.GetDataTable("Select ID, AccountNumber From Cases");
			DataRow dr = dtCases.NewRow();
			dr.BeginEdit();
			dr["ID"] = -1;
			dr["AccountNumber"] = "All Cases";
			dr.EndEdit();
			dtCases.Rows.InsertAt(dr,0);
			foreach (DataRow dr2 in dtCases.Rows)
			{
				if(dr2[1].Equals(DBNull.Value))
					dr2[1] = "A/C Not Specified " + dr2[0].ToString();
			}		
			cboCases.DataSource = dtCases;
			cboCases.ValueMember = "ID";
			cboCases.DisplayMember = "AccountNumber";
		}

		public void PrepForEdit(Int32 DiaryID)
		{
			PrepGeneral();
			CDiary.MainAdapter.SelectCommand.Parameters["id"].Value = DiaryID;
			CDiary.MainAdapter.Fill(dsDiary1, "Diary");
			if (dsDiary1.Diary.Rows.Count < 1)
			{
				OleDbCommand cmd = new OleDbCommand("Select ID from Diary Where ID = ?");
				cmd.Parameters.Add(CUtil.NewParam("ID", OleDbType.Integer, DiaryID));
				if(cMyDB.IsEmpty(cmd))
				{
					MessageBox.Show("The item selected cannot be displayed, it has been deleted by another user.", "Data not available");
				}
				else
				{
					MessageBox.Show("The item selected cannot be displayed due to a data problem.", "Data not available");
				}
				cmd.Dispose();
				this.Close();
				return;
			}
			
			if (!dsDiary1.Diary.Rows[0]["ActionDate"].Equals(DBNull.Value))
			{
				this.dtActionDate.SelectionEnd = dsDiary1.Diary[0].ActionDate;
			}
			if (!dsDiary1.Diary.Rows[0]["LastUpdated"].Equals(DBNull.Value))
			{
				this.lblStatus.Text = "Last Updated " + ((DateTime)dsDiary1.Diary.Rows[0]["LastUpdated"]).ToShortDateString() + " By " + (dsDiary1.Diary.Rows[0]["LastUser"] + "");
			}
			if (dsDiary1.Diary.Rows[0]["UserID"].Equals(DBNull.Value))
			{
				this.chkAllUsers.Checked = true;
			}

			if (this.CaseID > 0)
				cboCases.SelectedValue = this.CaseID;
		}

		public void PrepForInsert()
		{
			PrepGeneral();
			InterfaceComponents.dsDiary.DiaryRow dr = dsDiary1.Diary.NewDiaryRow();
			dr.BeginEdit();
			dr.ActionDate = DateTime.Today;
			dr.ActionType = 0;
			dr.EndEdit();
			dsDiary1.Diary.AddDiaryRow(dr);
			Adding = true;
			//if (this.CaseID > 0)
			//	cboCases.SelectedValue = this.CaseID;
		}

		public void PrepForInsert(Int32 CaseID)
		{
			PrepForInsert();
			dsDiary1.Diary[0].BeginEdit();
			dsDiary1.Diary[0].CaseID = CaseID;
			dsDiary1.Diary[0].EndEdit();
			//quick fix for bug when there is only one case.
			//usually just use SelectedValue code
			if (cboCases.Items.Count > 2)
			{
				if (this.CaseID > 0)
					cboCases.SelectedValue = this.CaseID;
			}
			else
			{
				if (this.CaseID > 0)
					cboCases.SelectedIndex = 1;
			}
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.tabs = new Crownwood.Magic.Controls.TabControl();
			this.tpDetails = new Crownwood.Magic.Controls.TabPage();
			this.chkAllUsers = new System.Windows.Forms.CheckBox();
			this.label3 = new System.Windows.Forms.Label();
			this.txtDescription = new System.Windows.Forms.TextBox();
			this.dsDiary1 = new DebtManagerTest.InterfaceComponents.dsDiary();
			this.dtActionDate = new System.Windows.Forms.MonthCalendar();
			this.label2 = new System.Windows.Forms.Label();
			this.cboActionType = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.cboCases = new System.Windows.Forms.ComboBox();
			this.label1 = new System.Windows.Forms.Label();
			this.tpNotes = new Crownwood.Magic.Controls.TabPage();
			this.txtNotes = new System.Windows.Forms.TextBox();
			this.cmdCancel = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdOK = new UtilityLibrary.WinControls.ButtonEx();
			this.lblStatus = new System.Windows.Forms.Label();
			this.tabs.SuspendLayout();
			this.tpDetails.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsDiary1)).BeginInit();
			this.tpNotes.SuspendLayout();
			this.SuspendLayout();
			// 
			// tabs
			// 
			this.tabs.Controls.AddRange(new System.Windows.Forms.Control[] {
																			   this.tpDetails,
																			   this.tpNotes});
			this.tabs.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabs.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabs.Name = "tabs";
			this.tabs.PositionTop = true;
			this.tabs.SelectedIndex = 0;
			this.tabs.SelectedTab = this.tpDetails;
			this.tabs.Size = new System.Drawing.Size(405, 212);
			this.tabs.TabIndex = 8;
			this.tabs.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																				   this.tpDetails,
																				   this.tpNotes});
			// 
			// tpDetails
			// 
			this.tpDetails.Controls.AddRange(new System.Windows.Forms.Control[] {
																					this.chkAllUsers,
																					this.label3,
																					this.txtDescription,
																					this.dtActionDate,
																					this.label2,
																					this.cboActionType,
																					this.cboCases,
																					this.label1});
			this.tpDetails.Location = new System.Drawing.Point(0, 25);
			this.tpDetails.Name = "tpDetails";
			this.tpDetails.Size = new System.Drawing.Size(405, 187);
			this.tpDetails.TabIndex = 3;
			this.tpDetails.Title = "Diary Entry Details";
			// 
			// chkAllUsers
			// 
			this.chkAllUsers.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkAllUsers.Location = new System.Drawing.Point(232, 153);
			this.chkAllUsers.Name = "chkAllUsers";
			this.chkAllUsers.Size = new System.Drawing.Size(162, 24);
			this.chkAllUsers.TabIndex = 4;
			this.chkAllUsers.Text = "Show in diary for all users";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(220, 72);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(40, 23);
			this.label3.TabIndex = 14;
			this.label3.Text = "Details";
			this.label3.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// txtDescription
			// 
			this.txtDescription.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsDiary1, "Diary.Description"));
			this.txtDescription.Location = new System.Drawing.Point(263, 70);
			this.txtDescription.Multiline = true;
			this.txtDescription.Name = "txtDescription";
			this.txtDescription.Size = new System.Drawing.Size(131, 80);
			this.txtDescription.TabIndex = 3;
			this.txtDescription.Text = "";
			// 
			// dsDiary1
			// 
			this.dsDiary1.DataSetName = "dsDiary";
			this.dsDiary1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsDiary1.Namespace = "http://www.tempuri.org/dsDiary.xsd";
			// 
			// dtActionDate
			// 
			this.dtActionDate.BackColor = System.Drawing.SystemColors.Window;
			this.dtActionDate.Location = new System.Drawing.Point(13, 14);
			this.dtActionDate.MaxSelectionCount = 1;
			this.dtActionDate.Name = "dtActionDate";
			this.dtActionDate.TabIndex = 5;
			this.dtActionDate.TitleBackColor = System.Drawing.SystemColors.Control;
			this.dtActionDate.TitleForeColor = System.Drawing.SystemColors.MenuText;
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(223, 44);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(37, 23);
			this.label2.TabIndex = 11;
			this.label2.Text = "Action";
			this.label2.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// cboActionType
			// 
			this.cboActionType.AllowUpdates = true;
			this.cboActionType.ComboValue = null;
			this.cboActionType.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsDiary1, "Diary.ActionType"));
			this.cboActionType.DataBound = true;
			this.cboActionType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboActionType.ExtraRefreshes = true;
			this.cboActionType.Location = new System.Drawing.Point(263, 42);
			this.cboActionType.LookupID = "ActionType";
			this.cboActionType.Name = "cboActionType";
			this.cboActionType.Nullable = true;
			this.cboActionType.Size = new System.Drawing.Size(131, 21);
			this.cboActionType.TabIndex = 2;
			// 
			// cboCases
			// 
			this.cboCases.Location = new System.Drawing.Point(263, 15);
			this.cboCases.Name = "cboCases";
			this.cboCases.Size = new System.Drawing.Size(131, 21);
			this.cboCases.TabIndex = 1;
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(223, 18);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(37, 17);
			this.label1.TabIndex = 8;
			this.label1.Text = "Case";
			this.label1.TextAlign = System.Drawing.ContentAlignment.TopRight;
			// 
			// tpNotes
			// 
			this.tpNotes.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.txtNotes});
			this.tpNotes.Location = new System.Drawing.Point(0, 25);
			this.tpNotes.Name = "tpNotes";
			this.tpNotes.Selected = false;
			this.tpNotes.Size = new System.Drawing.Size(405, 187);
			this.tpNotes.TabIndex = 4;
			this.tpNotes.Title = "Notes";
			// 
			// txtNotes
			// 
			this.txtNotes.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsDiary1, "Diary.Notes"));
			this.txtNotes.Dock = System.Windows.Forms.DockStyle.Fill;
			this.txtNotes.Multiline = true;
			this.txtNotes.Name = "txtNotes";
			this.txtNotes.Size = new System.Drawing.Size(405, 187);
			this.txtNotes.TabIndex = 0;
			this.txtNotes.Text = "";
			// 
			// cmdCancel
			// 
			this.cmdCancel.CausesValidation = false;
			this.cmdCancel.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.cmdCancel.Location = new System.Drawing.Point(321, 218);
			this.cmdCancel.Name = "cmdCancel";
			this.cmdCancel.TabIndex = 11;
			this.cmdCancel.Text = "Cancel";
			// 
			// cmdOK
			// 
			this.cmdOK.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOK.Location = new System.Drawing.Point(237, 218);
			this.cmdOK.Name = "cmdOK";
			this.cmdOK.TabIndex = 10;
			this.cmdOK.Text = "OK";
			this.cmdOK.Click += new System.EventHandler(this.cmdOK_Click);
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(10, 218);
			this.lblStatus.Name = "lblStatus";
			this.lblStatus.Size = new System.Drawing.Size(198, 13);
			this.lblStatus.TabIndex = 11;
			// 
			// frmDiarise
			// 
			this.AcceptButton = this.cmdOK;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.cmdCancel;
			this.ClientSize = new System.Drawing.Size(405, 247);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel,
																		  this.tabs});
			this.FormBorderStyle = System.Windows.Forms.FormBorderStyle.FixedDialog;
			this.MaximizeBox = false;
			this.MinimizeBox = false;
			this.Name = "frmDiarise";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "New Diary Entry";
			this.tabs.ResumeLayout(false);
			this.tpDetails.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsDiary1)).EndInit();
			this.tpNotes.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		private void cmdOK_Click(object sender, System.EventArgs e)
		{
			//this.BindingContext[dsDiary1,"Diary"].EndCurrentEdit();
			try
			{
				dsDiary1.Diary[0].BeginEdit();
				if (!this.chkAllUsers.Checked)
				{
					dsDiary1.Diary.Rows[0]["UserID"] = CSession.User.UserID;
				}
				else
					dsDiary1.Diary.Rows[0]["UserID"] = DBNull.Value;

				if (!((Int32)cboCases.SelectedValue).Equals(-1))
					dsDiary1.Diary[0].CaseID = (Int32)cboCases.SelectedValue;
				else
					dsDiary1.Diary[0].SetCaseIDNull();

				dsDiary1.Diary.Rows[0]["ActionDate"] = this.dtActionDate.SelectionEnd;
				dsDiary1.Diary.Rows[0]["LastUpdated"] = DateTime.Now;
				dsDiary1.Diary.Rows[0]["LastUser"] = CSession.User.Username;
				
				if (Adding)
				{
					dsDiary1.Diary.Rows[0]["Created"] = DateTime.Now;
					dsDiary1.Diary.Rows[0]["CreateUser"] = CSession.User.Username;
				}
				dsDiary1.Diary[0].EndEdit();
				//this.BindingContext[dsDiary1,"Diary"].EndCurrentEdit();
				CDiary.MainAdapter.Update(dsDiary1, "Diary");
			}
			catch (Exception er)
			{
				MessageBox.Show(er.Message);
			}
		}
	}
}
