using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.IO;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	public class frmLetters : DebtManagerTest.DebtBaseForm
	{
		private System.Data.OleDb.OleDbDataAdapter daLetters;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand1;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand1;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand1;
		private DebtManagerTest.dsLetters dsLetters1;
		private System.Data.OleDb.OleDbDataAdapter daRecipients;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand2;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand2;
		private System.Data.OleDb.OleDbCommand oleDbUpdateCommand2;
		private System.Data.OleDb.OleDbCommand oleDbDeleteCommand2;
		private DebtManagerTest.LookupComboObjects.LookupCombo lookupCombo1;
		private System.Windows.Forms.Label label1;
		private UtilityLibrary.WinControls.ButtonEx cmdOpenTemplate;
		private System.Windows.Forms.CheckBox chkSave;
		private UtilityLibrary.WinControls.ButtonEx cmdOpenLetter;
		private System.Windows.Forms.Label lblLocation;
		private UtilityLibrary.WinControls.ButtonEx cmdDestinationDir;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label3;
		private UtilityLibrary.WinControls.ListViewEx listViewEx1;
		private Crownwood.Magic.Menus.MenuCommand mnuRemove;
		private Crownwood.Magic.Menus.MenuCommand mnuAdd;
		private UtilityLibrary.WinControls.ButtonEx cmdAdd;
		private UtilityLibrary.WinControls.ButtonEx cmdRemove;
		private System.Windows.Forms.CheckBox chkEdited;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		private System.Windows.Forms.Label lblFilename;
		private System.ComponentModel.IContainer components = null;
		private Crownwood.Magic.Menus.PopupMenu pm;
		private System.Data.OleDb.OleDbCommand cmdMergeData;
		private System.Data.OleDb.OleDbDataAdapter daTempRecipientsTable;
		private System.Data.OleDb.OleDbCommand oleDbInsertCommand3;
		private DataSet dsRecipients;

		public frmLetters()
		{
			// This call is required by the Windows Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitializeComponent call
			this.daMain = daLetters;
			this.mDs = dsLetters1;
			this.mTableName = "Letters";

			daRecipients.SelectCommand.Connection = daLetters.SelectCommand.Connection;
			daRecipients.UpdateCommand.Connection = daLetters.UpdateCommand.Connection;
			daRecipients.DeleteCommand.Connection = daLetters.DeleteCommand.Connection;
			daRecipients.InsertCommand.Connection = daLetters.InsertCommand.Connection;
			daTempRecipientsTable.InsertCommand.Connection = daLetters.InsertCommand.Connection;

			dsRecipients = new DataSet();
			
			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuAdd);
			pm.MenuCommands.Add(mnuRemove);

			if(!CSession.ChangeSaveOptions)
			{
				this.chkSave.Visible = false;
				this.lblFilename.Visible = false;
				this.lblLocation.Visible = false;
			}
			if(CSession.DisallowEdits)
			{
				this.cmdOpenLetter.Visible = false;
			}
		}

		private void FillRecipientsList()
		{
			FillRecipientsList(true);
		}

		private void FillRecipientsList(bool updateList)
		{
			if (updateList)
			{
				listViewEx1.BeginUpdate();
				listViewEx1.Items.Clear();
				Hashtable x = new Hashtable();
				ArrayList drs = new ArrayList();
				foreach (DataRow dr in dsRecipients.Tables[0].Rows)
				{
					try
					{
						x.Add(dr["PersonID"],DBNull.Value);
						if (dr["PersonID"].Equals(DBNull.Value))
						{
							ListViewItem temp = listViewEx1.Items.Add("Default Borrowers");
							temp.SubItems.Add("Property Address");
							temp.Tag = DBNull.Value;
						}
						else
						{
							ArrayList tempList = cMyDB.GetFirstRow("Select Title, Initials, Surname, Address, AddressAsProperty, ID from People Where ID = " + dr["PersonID"].ToString());
							ListViewItem temp = listViewEx1.Items.Add(tempList[0] + " " + tempList[1] + " " + tempList[2]);
							if (tempList[4].Equals(true))
								temp.SubItems.Add("Property Address");
							else
								temp.SubItems.Add(tempList[3].ToString().Replace("\r\n",", "));
							temp.Tag = tempList[5];
						}
					}
					catch (ArgumentException)
					{ drs.Add(dr); }
				}
				if (drs.Count > 0)
				{
					foreach (DataRow dr in drs)
					{
						dr.Delete();
					}
				}
				listViewEx1.EndUpdate();
			}
			if (listViewEx1.Items.Count == 0)
			{
				cmdOK.Enabled = false;
				cmdOpenLetter.Enabled = false;
			}
			else if (chkSave.Checked && Adding && (lblLocation.Text == string.Empty))
			{
				cmdOK.Enabled = false;
				cmdOpenLetter.Enabled = false;
			}
			else
			{
				cmdOK.Enabled = true;
				cmdOpenLetter.Enabled = true;
			}
		}

		public override void AddNew(int CaseID)
		{
			base.AddNew(CaseID);
			dsLetters1.Letters.Rows[0].BeginEdit();
			dsLetters1.Letters.Rows[0]["LetterDate"] = DateTime.Today;
			if(CSession.AlwaysSave)
			{
				dsLetters1.Letters.Rows[0]["Directory"] = CSession.SavePath;
				dsLetters1.Letters.Rows[0]["Saved"] = true;
			}
			dsLetters1.Letters.Rows[0].EndEdit();

			daRecipients.FillSchema(dsRecipients, SchemaType.Mapped, "LetterRecipients");
			DataRow dr = dsRecipients.Tables["LetterRecipients"].NewRow();
			dr["LastUpdated"] = DateTime.Now;
			dr["Created"] = DateTime.Today;
			dr["LastUser"] = CSession.User.Username;
			dr["CreateUser"] = CSession.User.Username;
			dr["LetterID"] = DBNull.Value;
			dr["PersonID"] = DBNull.Value;
			dsRecipients.Tables["LetterRecipients"].Rows.Add(dr);
			FillRecipientsList();
		}

		public override void Edit(int ID)
		{
			base.Edit(ID);
			this.chkSave.Text = "Saved?";
			if (CSession.ChangeSaveOptions)
			{
				this.lblFilename.Visible = true;
				this.chkEdited.Visible = true;
			}
			this.cmdAdd.Visible = false;
			this.cmdRemove.Visible = false;
			this.lookupCombo1.Enabled = false;
			this.chkEdited.Enabled = false;
			this.chkSave.Enabled = false;
			if (dsLetters1.Letters.Rows[0]["Saved"].Equals(false))
			{
				this.cmdOK.Visible = false;
				this.cmdOpenLetter.Visible = false;
				this.cmdCancel.Text = "Close ";
			}
			else
			{
				this.cmdOK.Text = "Reprint Letter ";
				this.cmdCancel.Text = "Close ";
			}
			daRecipients.SelectCommand.Parameters["LetterID"].Value = ID;
			daRecipients.Fill(dsRecipients);
			FillRecipientsList();
			this.listViewEx1.Select();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.cmdOpenLetter = new UtilityLibrary.WinControls.ButtonEx();
			this.daLetters = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand1 = new System.Data.OleDb.OleDbCommand();
			this.dsLetters1 = new DebtManagerTest.dsLetters();
			this.daRecipients = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbDeleteCommand2 = new System.Data.OleDb.OleDbCommand();
			this.oleDbInsertCommand2 = new System.Data.OleDb.OleDbCommand();
			this.oleDbSelectCommand2 = new System.Data.OleDb.OleDbCommand();
			this.oleDbUpdateCommand2 = new System.Data.OleDb.OleDbCommand();
			this.lookupCombo1 = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label1 = new System.Windows.Forms.Label();
			this.cmdOpenTemplate = new UtilityLibrary.WinControls.ButtonEx();
			this.chkSave = new System.Windows.Forms.CheckBox();
			this.lblLocation = new System.Windows.Forms.Label();
			this.cmdDestinationDir = new UtilityLibrary.WinControls.ButtonEx();
			this.label2 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.listViewEx1 = new UtilityLibrary.WinControls.ListViewEx();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.cmdAdd = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdRemove = new UtilityLibrary.WinControls.ButtonEx();
			this.mnuRemove = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdd = new Crownwood.Magic.Menus.MenuCommand();
			this.lblFilename = new System.Windows.Forms.Label();
			this.chkEdited = new System.Windows.Forms.CheckBox();
			this.cmdMergeData = new System.Data.OleDb.OleDbCommand();
			this.daTempRecipientsTable = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbInsertCommand3 = new System.Data.OleDb.OleDbCommand();
			this.tabControl1.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsLetters1)).BeginInit();
			this.SuspendLayout();
			// 
			// tabControl1
			// 
			this.tabControl1.Size = new System.Drawing.Size(404, 259);
			this.tabControl1.Visible = true;
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.cmdRemove,
																					 this.cmdAdd,
																					 this.listViewEx1,
																					 this.label3,
																					 this.label2,
																					 this.cmdDestinationDir,
																					 this.lblLocation,
																					 this.chkSave,
																					 this.cmdOpenTemplate,
																					 this.label1,
																					 this.lookupCombo1,
																					 this.lblFilename,
																					 this.chkEdited});
			this.tabGeneral.Size = new System.Drawing.Size(404, 234);
			this.tabGeneral.Visible = true;
			// 
			// lblStatus
			// 
			this.lblStatus.Location = new System.Drawing.Point(5, 266);
			this.lblStatus.Size = new System.Drawing.Size(137, 29);
			this.lblStatus.Visible = true;
			// 
			// cmdOK
			// 
			this.cmdOK.Location = new System.Drawing.Point(265, 271);
			this.cmdOK.Size = new System.Drawing.Size(70, 23);
			this.cmdOK.Text = "Print Letter ";
			this.cmdOK.Visible = true;
			// 
			// cmdCancel
			// 
			this.cmdCancel.Location = new System.Drawing.Point(341, 271);
			this.cmdCancel.Size = new System.Drawing.Size(58, 23);
			this.cmdCancel.Text = "Cancel ";
			this.cmdCancel.Visible = true;
			// 
			// cmdOpenLetter
			// 
			this.cmdOpenLetter.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdOpenLetter.Location = new System.Drawing.Point(186, 271);
			this.cmdOpenLetter.Name = "cmdOpenLetter";
			this.cmdOpenLetter.Size = new System.Drawing.Size(74, 23);
			this.cmdOpenLetter.TabIndex = 30;
			this.cmdOpenLetter.Text = "Open Letter ";
			this.cmdOpenLetter.Click += new System.EventHandler(this.cmdOpenLetter_Click);
			// 
			// daLetters
			// 
			this.daLetters.DeleteCommand = this.oleDbDeleteCommand1;
			this.daLetters.InsertCommand = this.oleDbInsertCommand1;
			this.daLetters.SelectCommand = this.oleDbSelectCommand1;
			this.daLetters.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								new System.Data.Common.DataTableMapping("Table", "Letters", new System.Data.Common.DataColumnMapping[] {
																																																		   new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																		   new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																		   new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																		   new System.Data.Common.DataColumnMapping("Directory", "Directory"),
																																																		   new System.Data.Common.DataColumnMapping("Filename", "Filename"),
																																																		   new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																		   new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																		   new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																		   new System.Data.Common.DataColumnMapping("LetterDate", "LetterDate"),
																																																		   new System.Data.Common.DataColumnMapping("LetterType", "LetterType"),
																																																		   new System.Data.Common.DataColumnMapping("Saved", "Saved")})});
			this.daLetters.UpdateCommand = this.oleDbUpdateCommand1;
			this.daLetters.RowUpdated += new System.Data.OleDb.OleDbRowUpdatedEventHandler(this.daLetters_RowUpdated);
			// 
			// oleDbDeleteCommand1
			// 
			this.oleDbDeleteCommand1.CommandText = "DELETE FROM Letters WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AN" +
				"D ? IS NULL)";
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param3", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbInsertCommand1
			// 
			this.oleDbInsertCommand1.CommandText = "INSERT INTO Letters(CaseID, Created, CreateUser, Directory, Edited, Filename, Las" +
				"tUpdated, LastUser, LetterDate, LetterType, Saved) VALUES (?, ?, ?, ?, ?, ?, ?, " +
				"?, ?, ?, ?)";
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Directory", System.Data.OleDb.OleDbType.VarWChar, 255, "Directory"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Edited", System.Data.OleDb.OleDbType.Boolean, 2, "Edited"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Filename", System.Data.OleDb.OleDbType.VarWChar, 255, "Filename"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterDate", System.Data.OleDb.OleDbType.DBDate, 0, "LetterDate"));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterType", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "LetterType", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Saved", System.Data.OleDb.OleDbType.Boolean, 2, "Saved"));
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT CaseID, Created, CreateUser, Directory, Edited,  Filename, ID, LastUpdated" +
				", LastUser, LetterDate, LetterType, Saved FROM Letters WHERE (ID = ?)";
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbUpdateCommand1
			// 
			this.oleDbUpdateCommand1.CommandText = "UPDATE Letters SET CaseID = ?, Created = ?, CreateUser = ?, Directory = ?, Edited" +
				" = ?, Filename = ?, LastUpdated = ?, LastUser = ?, LetterDate = ?, LetterType = " +
				"?, Saved = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS" +
				" NULL)";
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Directory", System.Data.OleDb.OleDbType.VarWChar, 255, "Directory"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Edited", System.Data.OleDb.OleDbType.Boolean, 2, "Edited"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Filename", System.Data.OleDb.OleDbType.VarWChar, 255, "Filename"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterDate", System.Data.OleDb.OleDbType.DBDate, 0, "LetterDate"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterType", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "LetterType", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Saved", System.Data.OleDb.OleDbType.Boolean, 2, "Saved"));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param65", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// dsLetters1
			// 
			this.dsLetters1.DataSetName = "dsLetters";
			this.dsLetters1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsLetters1.Namespace = "http://www.tempuri.org/dsLetters.xsd";
			// 
			// daRecipients
			// 
			this.daRecipients.DeleteCommand = this.oleDbDeleteCommand2;
			this.daRecipients.InsertCommand = this.oleDbInsertCommand2;
			this.daRecipients.SelectCommand = this.oleDbSelectCommand2;
			this.daRecipients.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																								   new System.Data.Common.DataTableMapping("Table", "LetterRecipients", new System.Data.Common.DataColumnMapping[] {
																																																					   new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																					   new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																					   new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																					   new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																					   new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																					   new System.Data.Common.DataColumnMapping("LetterID", "LetterID"),
																																																					   new System.Data.Common.DataColumnMapping("PersonID", "PersonID")})});
			this.daRecipients.UpdateCommand = this.oleDbUpdateCommand2;
			// 
			// oleDbDeleteCommand2
			// 
			this.oleDbDeleteCommand2.CommandText = "DELETE FROM LetterRecipients WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated I" +
				"S NULL AND ? IS NULL)";
			this.oleDbDeleteCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbDeleteCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param3", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// oleDbInsertCommand2
			// 
			this.oleDbInsertCommand2.CommandText = "INSERT INTO LetterRecipients(Created, CreateUser, LastUpdated, LastUser, LetterID" +
				", PersonID) VALUES (?, ?, ?, ?, ?, ?)";
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "LetterID", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "PersonID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbSelectCommand2
			// 
			this.oleDbSelectCommand2.CommandText = "SELECT Created, CreateUser, ID, LastUpdated, LastUser, LetterID, PersonID FROM Le" +
				"tterRecipients WHERE (LetterID = ?)";
			this.oleDbSelectCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "LetterID", System.Data.DataRowVersion.Current, null));
			// 
			// oleDbUpdateCommand2
			// 
			this.oleDbUpdateCommand2.CommandText = "UPDATE LetterRecipients SET Created = ?, CreateUser = ?, LastUpdated = ?, LastUse" +
				"r = ?, LetterID = ?, PersonID = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpd" +
				"ated IS NULL AND ? IS NULL)";
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("LetterID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "LetterID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "PersonID", System.Data.DataRowVersion.Current, null));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.oleDbUpdateCommand2.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param45", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// lookupCombo1
			// 
			this.lookupCombo1.AllowUpdates = true;
			this.lookupCombo1.ComboValue = null;
			this.lookupCombo1.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsLetters1, "Letters.LetterType"));
			this.lookupCombo1.DataBound = true;
			this.lookupCombo1.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.lookupCombo1.ExtraRefreshes = true;
			this.lookupCombo1.Location = new System.Drawing.Point(110, 16);
			this.lookupCombo1.LookupID = "LetterType";
			this.lookupCombo1.Name = "lookupCombo1";
			this.lookupCombo1.Nullable = false;
			this.lookupCombo1.Size = new System.Drawing.Size(184, 21);
			this.lookupCombo1.TabIndex = 0;
			this.lookupCombo1.Validating += new System.ComponentModel.CancelEventHandler(this.lookupCombo1_Validating);
			this.lookupCombo1.SelectedIndexChanged += new System.EventHandler(this.lookupCombo1_SelectedIndexChanged);
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(18, 20);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(85, 17);
			this.label1.TabIndex = 1;
			this.label1.Text = "Letter Type";
			// 
			// cmdOpenTemplate
			// 
			this.cmdOpenTemplate.Location = new System.Drawing.Point(302, 15);
			this.cmdOpenTemplate.Name = "cmdOpenTemplate";
			this.cmdOpenTemplate.Size = new System.Drawing.Size(85, 23);
			this.cmdOpenTemplate.TabIndex = 2;
			this.cmdOpenTemplate.Text = "Open Template ";
			this.cmdOpenTemplate.Visible = false;
			this.cmdOpenTemplate.Click += new System.EventHandler(this.cmdOpenTemplate_Click);
			// 
			// chkSave
			// 
			this.chkSave.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkSave.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsLetters1, "Letters.Saved"));
			this.chkSave.Location = new System.Drawing.Point(17, 45);
			this.chkSave.Name = "chkSave";
			this.chkSave.Size = new System.Drawing.Size(107, 18);
			this.chkSave.TabIndex = 3;
			this.chkSave.Text = "Save a Copy?";
			this.chkSave.CheckedChanged += new System.EventHandler(this.checkBox1_CheckedChanged);
			// 
			// lblLocation
			// 
			this.lblLocation.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsLetters1, "Letters.Directory"));
			this.lblLocation.Location = new System.Drawing.Point(110, 73);
			this.lblLocation.Name = "lblLocation";
			this.lblLocation.Size = new System.Drawing.Size(273, 30);
			this.lblLocation.TabIndex = 4;
			// 
			// cmdDestinationDir
			// 
			this.cmdDestinationDir.Location = new System.Drawing.Point(140, 43);
			this.cmdDestinationDir.Name = "cmdDestinationDir";
			this.cmdDestinationDir.Size = new System.Drawing.Size(94, 23);
			this.cmdDestinationDir.TabIndex = 5;
			this.cmdDestinationDir.Text = "Specify Directory ";
			this.cmdDestinationDir.Visible = false;
			this.cmdDestinationDir.Click += new System.EventHandler(this.cmdDestinationDir_Click);
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(18, 73);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(63, 21);
			this.label2.TabIndex = 6;
			this.label2.Text = "Directory";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(18, 105);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(100, 13);
			this.label3.TabIndex = 7;
			this.label3.Text = "Recipients";
			// 
			// listViewEx1
			// 
			this.listViewEx1.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						  this.columnHeader1,
																						  this.columnHeader2});
			this.listViewEx1.FullRowSelect = true;
			this.listViewEx1.HeaderImageList = null;
			this.listViewEx1.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.listViewEx1.Location = new System.Drawing.Point(19, 123);
			this.listViewEx1.MultiSelect = false;
			this.listViewEx1.Name = "listViewEx1";
			this.listViewEx1.Size = new System.Drawing.Size(369, 98);
			this.listViewEx1.TabIndex = 8;
			this.listViewEx1.View = System.Windows.Forms.View.Details;
			this.listViewEx1.MouseUp += new System.Windows.Forms.MouseEventHandler(this.listViewEx1_MouseUp);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Name";
			this.columnHeader1.Width = 100;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Address";
			this.columnHeader2.Width = 240;
			// 
			// cmdAdd
			// 
			this.cmdAdd.Location = new System.Drawing.Point(287, 104);
			this.cmdAdd.Name = "cmdAdd";
			this.cmdAdd.Size = new System.Drawing.Size(47, 19);
			this.cmdAdd.TabIndex = 9;
			this.cmdAdd.Text = "Add ";
			this.cmdAdd.Click += new System.EventHandler(this.cmdAdd_Click);
			// 
			// cmdRemove
			// 
			this.cmdRemove.Location = new System.Drawing.Point(333, 104);
			this.cmdRemove.Name = "cmdRemove";
			this.cmdRemove.Size = new System.Drawing.Size(54, 19);
			this.cmdRemove.TabIndex = 10;
			this.cmdRemove.Text = "Remove ";
			this.cmdRemove.Click += new System.EventHandler(this.cmdRemove_Click);
			// 
			// mnuRemove
			// 
			this.mnuRemove.Description = "Remove Recipient";
			this.mnuRemove.Text = "&Remove Recipient";
			this.mnuRemove.Click += new System.EventHandler(this.mnuRemove_Click);
			// 
			// mnuAdd
			// 
			this.mnuAdd.Description = "Add Recipients";
			this.mnuAdd.Text = "&Add Recipients";
			this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
			// 
			// lblFilename
			// 
			this.lblFilename.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsLetters1, "Letters.Filename"));
			this.lblFilename.Location = new System.Drawing.Point(206, 46);
			this.lblFilename.Name = "lblFilename";
			this.lblFilename.Size = new System.Drawing.Size(182, 16);
			this.lblFilename.TabIndex = 11;
			this.lblFilename.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.lblFilename.Visible = false;
			// 
			// chkEdited
			// 
			this.chkEdited.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkEdited.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsLetters1, "Letters.Edited"));
			this.chkEdited.Location = new System.Drawing.Point(133, 43);
			this.chkEdited.Name = "chkEdited";
			this.chkEdited.Size = new System.Drawing.Size(67, 24);
			this.chkEdited.TabIndex = 12;
			this.chkEdited.Text = "Edited?";
			this.chkEdited.Visible = false;
			// 
			// cmdMergeData
			// 
			this.cmdMergeData.CommandText = @"SELECT TempLetterRecipients.PersonID, Cases.AccountNumber, Cases.AccountSalutation, Cases.AccountTitle, Cases.AmountOfArrears, Cases.BranchRef, Cases.CapitalBalance, Cases.CapitalBalanceDate, Cases.CauseOfArrears, Cases.DateInstructed, Cases.DateMarketed, Cases.DateSold, Cases.DebtOnSale, Cases.Degree, Cases.DegreeDate, Cases.DSS, Cases.IndemnityAmount, Cases.IndemnityClaimed, Cases.IndemnityCo, Cases.IndemnityInsurance, Cases.IndemnityPayout, Cases.IndemnityPayoutDate, Cases.IndemnityScheme, Cases.LastContactDate, Cases.MarketPrice, Cases.MarketPriceDate, Cases.PaymentAmount, Cases.PaymentAmountDate, Cases.PaymentProtection, Cases.PercentageAdvance, Cases.PercentageShare, Cases.PossessionDate, Cases.PossessionOrder, Cases.PropertyAddress, Cases.PropertyPostCode, Cases.PropertyTelephone, Cases.SalePrice, Cases.SharedOwnership, Cases.WeeklyDSS, Cases.WithinEarlyRepaymentPeriod, People.Address, People.AddressAsProperty, People.Initials, People.MaritalStatus, People.PostCode, People.SameAsPropertyTelephone, People.Surname, People.TelephoneHome, People.TelephoneWork, People.Title FROM (Cases INNER JOIN TempLetterRecipients ON Cases.ID = TempLetterRecipients.CaseID) LEFT OUTER JOIN People ON TempLetterRecipients.PersonID = People.ID WHERE (TempLetterRecipients.LastUpdated = ?) AND (TempLetterRecipients.LastUser = ?) AND (TempLetterRecipients.CaseID = ?)";
			this.cmdMergeData.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date));
			this.cmdMergeData.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12));
			this.cmdMergeData.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, null));
			// 
			// daTempRecipientsTable
			// 
			this.daTempRecipientsTable.InsertCommand = this.oleDbInsertCommand3;
			this.daTempRecipientsTable.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																											new System.Data.Common.DataTableMapping("Table", "TempLetterRecipients", new System.Data.Common.DataColumnMapping[] {
																																																									new System.Data.Common.DataColumnMapping("PersonID", "PersonID"),
																																																									new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																									new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																									new System.Data.Common.DataColumnMapping("CaseID", "CaseID")})});
			// 
			// oleDbInsertCommand3
			// 
			this.oleDbInsertCommand3.CommandText = "INSERT INTO TempLetterRecipients(PersonID, LastUser, LastUpdated, CaseID) VALUES " +
				"(?, ?, ?, ?)";
			this.oleDbInsertCommand3.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "PersonID", System.Data.DataRowVersion.Current, null));
			this.oleDbInsertCommand3.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12));
			this.oleDbInsertCommand3.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date));
			this.oleDbInsertCommand3.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "", System.Data.DataRowVersion.Current, null));
			// 
			// frmLetters
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(404, 302);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabControl1,
																		  this.lblStatus,
																		  this.cmdOK,
																		  this.cmdCancel,
																		  this.cmdOpenLetter});
			this.Name = "frmLetters";
			this.Text = "Letter Details";
			this.tabControl1.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsLetters1)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		private void lookupCombo1_SelectedIndexChanged(object sender, System.EventArgs e)
		{
			if (lookupCombo1.SelectedIndex >= 0)
			{
				if(!CSession.DisallowEdits)
				{
					this.cmdOpenTemplate.Visible = true;
				}
			}
			else
				this.cmdOpenTemplate.Visible = false;
		}

		private void checkBox1_CheckedChanged(object sender, System.EventArgs e)
		{
			if (this.Adding)
			{
				if (this.chkSave.Checked)
				{
					if (this.lblLocation.Text == "" || this.lblLocation.Text == null)
					{
						dsLetters1.Letters.Rows[0].BeginEdit();
						dsLetters1.Letters.Rows[0]["Saved"] = true;
						dsLetters1.Letters.Rows[0]["Directory"] = CSession.SavePath;
						dsLetters1.Letters.Rows[0].EndEdit();
					}
					this.cmdDestinationDir.Visible = true;
				}
				else
				{
					dsLetters1.Letters.Rows[0].BeginEdit();
					dsLetters1.Letters.Rows[0]["Saved"] = false;
					dsLetters1.Letters.Rows[0]["Directory"] = DBNull.Value;
					dsLetters1.Letters.Rows[0].EndEdit();
					this.cmdDestinationDir.Visible = false;
				}
			}
			FillRecipientsList(false);
		}

		private bool QuickWordAttach(ref Word8.Application wdapp)
		{
			try
			{
				wdapp = (Word8.Application)System.Runtime.InteropServices.Marshal.GetActiveObject("Word.Application");
				return true;
			}
			catch
			{	return false;	}
		}

		private bool LoadWord(ref Word8.Application wdapp)
		{
			try
			{
				wdapp = (Word8.Application)System.Runtime.InteropServices.Marshal.GetActiveObject("Word.Application");
				return true;
			}
			catch
			{	System.Diagnostics.Debug.WriteLine("Starting Word");	}

			if (wdapp==null)
			{
				try
				{
					string wrdPath = CSession.WordAppPath;
					if (wrdPath!= null)
					{
						System.Diagnostics.ProcessStartInfo psi = new System.Diagnostics.ProcessStartInfo(wrdPath);
						psi.WindowStyle = System.Diagnostics.ProcessWindowStyle.Minimized;
						System.Diagnostics.Process.Start(psi);
					}
					else
						throw new ApplicationException("Word is currently not available");
					
					this.Activate();

					int iSection = 0;
					int iTries = 0;
				tryAgain: 
					try 
					{      
						iSection = 1; // Attempting GetObject.
						wdapp = (Word8.Application) System.Runtime.InteropServices.Marshal.GetActiveObject("Word.Application");
						iSection = 0; // Resume normal error handling.
						return true;
					} 
					catch (Exception err) 
					{
						if (iSection == 1) 
						{ 
							iTries++;
							if (iTries < 20) 
							{
								System.Threading.Thread.Sleep(500); // Wait 1/2 seconds.
								this.Activate();
								goto tryAgain; //resume code at the GetObject line
							} 
							else
							{
								return false;		
							}
						} 
						else 
						{   
							MessageBox.Show("It has not been possible to open Microsoft Word for you. Please try again, or contact support. [" +  err.Message + "]");
							return false;
						}
					}
				}
				catch
				{
					return false;
				}
			}
			else
				return true;
		}

		private void cmdOpenTemplate_Click(object sender, System.EventArgs e)
		{
			Word8.Application wdapp=null;
			object fileName = cMyDB.GetResult("Select Filename from LetterTypeLookup Where ID = " + this.lookupCombo1.SelectedValue.ToString());
			System.IO.FileInfo fi = new System.IO.FileInfo((string)fileName);
			if (!fi.Exists)
			{
				MessageBox.Show("The template file associated with this letter does not exist.", "Letter Error");
				return;
			}
			if (LoadWord(ref wdapp))
			{
				object nothing = System.Reflection.Missing.Value;
				
				try
				{
					wdapp.Documents.Open(ref fileName, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
					if (!wdapp.Visible)
						wdapp.Visible = true;
					wdapp.Activate();
				}
				catch (Exception ex)
				{ 
					MessageBox.Show("An error occured during the communication with Microsoft Word. If this problem persists please contact support. [" + ex.Message + "]", "Automation Error");
				}
			}
			else
				MessageBox.Show("Microsoft Word based functions are not currently available on this PC. Please Contact Tech Support.", "Configuration Error");
			wdapp = null;
		}

		private void cmdDestinationDir_Click(object sender, System.EventArgs e)
		{
			CP.Windows.Forms.ShellFolderBrowser fb = new CP.Windows.Forms.ShellFolderBrowser();
			if (lblLocation.Text !="")
			{
				DirectoryInfo dI = new DirectoryInfo(lblLocation.Text);
				if (dI.Exists)
				{
					fb.FolderPath = lblLocation.Text;
				}
			}
			fb.Title = "Select Destination Folder";
			if(fb.ShowDialog())
			{
				if (fb.FolderPath!="")
				{
					dsLetters1.Letters.Rows[0].BeginEdit();
					dsLetters1.Letters.Rows[0]["Directory"] = fb.FolderPath;
					dsLetters1.Letters.Rows[0].EndEdit();
				}
			}
			fb.Dispose();
			FillRecipientsList(false);
		}

		private void AddRecipients()
		{
			frmSelectRecipients frm = new frmSelectRecipients((Int32)dsLetters1.Letters.Rows[0]["CaseID"]);
			if (frm.ShowDialog() == DialogResult.OK)
			{
				if (frm.lvwAvailable.SelectedItems.Count > 0)
				{
					foreach(ListViewItem item in frm.lvwAvailable.SelectedItems)
					{
						bool skip = false;
						foreach (DataRow dr in dsRecipients.Tables[0].Rows)
						{
							if (dr["PersonID"].Equals(item.Tag))
								skip = true;
						}
						if (!skip)
						{
							DataRow dr = dsRecipients.Tables[0].NewRow();
							dr["LastUpdated"] = DateTime.Now;
							dr["Created"] = DateTime.Today;
							dr["LastUser"] = CSession.User.Username;
							dr["CreateUser"] = CSession.User.Username;
							dr["LetterID"] = DBNull.Value;
							dr["PersonID"] = item.Tag;
							dsRecipients.Tables["LetterRecipients"].Rows.Add(dr);
						}
					}
					FillRecipientsList();
				}
			}
		}

		private void cmdAdd_Click(object sender, System.EventArgs e)
		{
			AddRecipients();
		}

		private void cmdRemove_Click(object sender, System.EventArgs e)
		{
			if (this.listViewEx1.SelectedItems.Count == 1)
			{
				ArrayList drs = new ArrayList();
				foreach (DataRow dr in dsRecipients.Tables[0].Rows)
				{
					if (dr["PersonID"].Equals(this.listViewEx1.SelectedItems[0].Tag))
						drs.Add(dr);
				}
				if (drs.Count > 0)
				{
					foreach (DataRow dr in drs)
					{
						dr.Delete();
					}
				}
				FillRecipientsList();
			}
		}

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			AddRecipients();
		}

		private void mnuRemove_Click(object sender, System.EventArgs e)
		{
			ArrayList drs = new ArrayList();
			foreach (DataRow dr in dsRecipients.Tables[0].Rows)
			{
				if (dr["PersonID"].Equals(mnuRemove.UserData))
					drs.Add(dr);
			}
			if (drs.Count > 0)
			{
				foreach (DataRow dr in drs)
				{
					dr.Delete();
				}
			}
			FillRecipientsList();
		}

		private bool OutputMailMergeData(string fileName, string directory)
		{
			daTempRecipientsTable.InsertCommand.Parameters["LastUser"].Value = CSession.User.Username;
			daTempRecipientsTable.InsertCommand.Parameters["LastUpdated"].Value = DateTime.Now;
			daTempRecipientsTable.InsertCommand.Parameters["CaseID"].Value = dsLetters1.Letters.Rows[0]["CaseID"];
			
			daTempRecipientsTable.Update(dsRecipients.Tables[0].GetChanges());

			cmdMergeData.Parameters["LastUser"].Value = CSession.User.Username;
			cmdMergeData.Parameters["LastUpdated"].Value = daTempRecipientsTable.InsertCommand.Parameters["LastUpdated"].Value;
			cmdMergeData.Parameters["CaseID"].Value = daTempRecipientsTable.InsertCommand.Parameters["CaseID"].Value;
			
			DataSet dsSource = cMyDB.GetDataSet(cmdMergeData);

			System.Data.OleDb.OleDbCommand tempDelCmd = new System.Data.OleDb.OleDbCommand("Delete From TempLetterRecipients Where LastUser = ? and lastupdated = ? and CaseID = ?");

			tempDelCmd.Parameters.Add(CUtil.NewParam("LastUser",System.Data.OleDb.OleDbType.VarWChar, CSession.User.Username));
			tempDelCmd.Parameters.Add(CUtil.NewParam("LastUpdated",System.Data.OleDb.OleDbType.Date, daTempRecipientsTable.InsertCommand.Parameters["LastUpdated"].Value));
			tempDelCmd.Parameters.Add(CUtil.NewParam("CaseID",System.Data.OleDb.OleDbType.Integer, daTempRecipientsTable.InsertCommand.Parameters["CaseID"].Value));
			
			cMyDB.Execute(tempDelCmd);
			
			tempDelCmd.Dispose();

			dsMailMerge dsFinal = new dsMailMerge();

			foreach (DataRow dr in dsSource.Tables[0].Rows)
			{
				dsMailMerge.MailMergeDataRow mdr = dsFinal.MailMergeData.NewMailMergeDataRow();
				if (!dr["AccountNumber"].Equals(DBNull.Value))
					mdr.Account_Number = (string) dr["AccountNumber"];
				if (!dr["AmountOfArrears"].Equals(DBNull.Value))
					mdr.Amount_Of_Arrears = (decimal) dr["AmountOfArrears"];
				if (!dr["BranchRef"].Equals(DBNull.Value))
					mdr.Branch_Ref = (string) dr["BranchRef"];
				if (!dr["CapitalBalance"].Equals(DBNull.Value))
					mdr.Capital_Balance = (decimal) dr["CapitalBalance"];
				if (!dr["CapitalBalanceDate"].Equals(DBNull.Value))
					mdr.Capital_Balance_Date = (DateTime) dr["CapitalBalanceDate"];
				if (!dr["CauseOfArrears"].Equals(DBNull.Value))
					mdr.Cause_Of_Arrears = (string) dr["CauseOfArrears"];
				if (dr["PersonID"].Equals(DBNull.Value) || dr["AddressAsProperty"].Equals(true))
				{
					if (!dr["PropertyAddress"].Equals(DBNull.Value))
						mdr.Contact_Address = (string) dr["PropertyAddress"];
					if (!dr["AccountSalutation"].Equals(DBNull.Value))
						mdr.Salutation = (string) dr["AccountSalutation"];
					if (!dr["AccountTitle"].Equals(DBNull.Value))
						mdr.Title = (string) dr["AccountTitle"];
					if (!dr["PropertyPostCode"].Equals(DBNull.Value))
						mdr.Contact_Post_Code = (string) dr["PropertyPostCode"];
					if (!dr["PropertyTelephone"].Equals(DBNull.Value))
						mdr.Contact_Telephone_Home = (string) dr["PropertyTelephone"];
				}
				else
				{
					if (!dr["Address"].Equals(DBNull.Value))
						mdr.Contact_Address = (string) dr["Address"];
					mdr.Salutation = dr["Title"] + " " + dr["Surname"]; 
					if (dr["Initials"].Equals(DBNull.Value))
						mdr.Title = dr["Title"] + " " + dr["Surname"];
					else
						mdr.Title = dr["Title"] + " " + dr["Initials"] + " " + dr["Surname"];
					if (!dr["PostCode"].Equals(DBNull.Value))
						mdr.Contact_Post_Code = (string) dr["PostCode"];
					if (!dr["TelephoneHome"].Equals(DBNull.Value))
						mdr.Contact_Telephone_Home = (string) dr["TelephoneHome"];
					if (!dr["TelephoneWork"].Equals(DBNull.Value))
						mdr.Contact_Telephone_Work = (string) dr["TelephoneWork"];
				}
				if (!dr["DateInstructed"].Equals(DBNull.Value))
					mdr.Date_Instructed = (DateTime) dr["DateInstructed"];
				if (!dr["DateMarketed"].Equals(DBNull.Value))
					mdr.Date_Marketed = (DateTime) dr["DateMarketed"];
				if (!dr["DateSold"].Equals(DBNull.Value))
					mdr.Date_Sold = (DateTime) dr["DateSold"];
				if (!dr["DebtOnSale"].Equals(DBNull.Value))
					mdr.Debt_On_Sale = (decimal) dr["DebtOnSale"];
				if (!dr["Degree"].Equals(DBNull.Value))
					mdr.Degree = (Int32) dr["Degree"];
				if (!dr["DegreeDate"].Equals(DBNull.Value))
					mdr.Degree_Date = (DateTime) dr["DegreeDate"];
				if (!dr["DSS"].Equals(DBNull.Value))
					mdr.DSS = (bool) dr["DSS"];
				if (!dr["IndemnityAmount"].Equals(DBNull.Value))
					mdr.Indemnity_Amount = (decimal) dr["IndemnityAmount"];
				if (!dr["IndemnityClaimed"].Equals(DBNull.Value))
					mdr.Indemnity_Claimed = (decimal) dr["IndemnityClaimed"];
				if (!dr["IndemnityCo"].Equals(DBNull.Value))
					mdr.Indemnity_Co = (string) dr["IndemnityCo"];
				if (!dr["IndemnityInsurance"].Equals(DBNull.Value))
					mdr.Indemnity_Insurance = (bool) dr["IndemnityInsurance"];
				if (!dr["IndemnityPayout"].Equals(DBNull.Value))
					mdr.Indemnity_Payout = (decimal) dr["IndemnityPayout"];
				if (!dr["IndemnityPayoutDate"].Equals(DBNull.Value))
					mdr.Indemnity_Payout_Date = (DateTime) dr["IndemnityPayoutDate"];
				if (!dr["IndemnityScheme"].Equals(DBNull.Value))
					mdr.Indemnity_Scheme = (string) dr["IndemnityScheme"];
				if (!dr["LastContactDate"].Equals(DBNull.Value))
					mdr.Last_Contact_Date = (DateTime) dr["LastContactDate"];
				if (!dr["MarketPrice"].Equals(DBNull.Value))
					mdr.Market_Price = (decimal) dr["MarketPrice"];
				if (!dr["MarketPriceDate"].Equals(DBNull.Value))
					mdr.Market_Price_Date = (DateTime) dr["MarketPriceDate"];
				if (!dr["PaymentAmount"].Equals(DBNull.Value))
					mdr.Payment_Amount = (decimal) dr["PaymentAmount"];
				if (!dr["PaymentAmountDate"].Equals(DBNull.Value))
					mdr.Payment_Amount_Date = (DateTime) dr["PaymentAmountDate"];
				if (!dr["PaymentProtection"].Equals(DBNull.Value))
					mdr.Payment_Protection = (bool) dr["PaymentProtection"];
				if (!dr["PercentageAdvance"].Equals(DBNull.Value))
					mdr.Percentage_Advance = (Single) dr["PercentageAdvance"];
				if (!dr["PercentageShare"].Equals(DBNull.Value))
					mdr.Percentage_Share = (Single) dr["PercentageShare"];
				if (!dr["PossessionDate"].Equals(DBNull.Value))
					mdr.Possession_Date = (DateTime) dr["PossessionDate"];
				if (!dr["PossessionOrder"].Equals(DBNull.Value))
					mdr.Possession_Order = (string) dr["PossessionOrder"];
				if (!dr["PropertyAddress"].Equals(DBNull.Value))
					mdr.Property_Address = (string) dr["PropertyAddress"];
				if (!dr["PropertyPostCode"].Equals(DBNull.Value))
					mdr.Property_Post_Code = (string) dr["PropertyPostCode"];
				if (!dr["PropertyTelephone"].Equals(DBNull.Value))
					mdr.Property_Telephone = (string) dr["PropertyTelephone"];
				if (!dr["SalePrice"].Equals(DBNull.Value))
					mdr.Sale_Price = (decimal) dr["SalePrice"];
				if (!dr["AddressAsProperty"].Equals(DBNull.Value))
					mdr.Same_As_Property = (bool) dr["AddressAsProperty"];
				if (!dr["SharedOwnership"].Equals(DBNull.Value))
					mdr.Shared_Ownership = (bool) dr["SharedOwnership"];
				if (!dr["WeeklyDSS"].Equals(DBNull.Value))
					mdr.Weekly_DSS = (decimal) dr["WeeklyDSS"];
				if (!dr["WithinEarlyRepaymentPeriod"].Equals(DBNull.Value))
					mdr.Within_Early_Repayment_Period = (bool) dr["WithinEarlyRepaymentPeriod"];
				dsFinal.MailMergeData.Rows.Add(mdr);
			}
			dsSource.Dispose();
			
			if (cMyDB.OutputRTF(dsFinal, fileName, directory, false, false))
			{
				dsFinal.Dispose();
				return true;
			}
			else
			{
				dsFinal.Dispose();
				return false;
			}
		}

		protected override void cmdOK_Click(object sender, System.EventArgs e)
		{			
			object fileToOpen = null;
			object fileToSave = null;
			bool sucessful = false;

			if (Adding)
			{
				if (!OutputMailMergeData("MailMergeData.rtf", Environment.CurrentDirectory))
				{
					MessageBox.Show("An error occurred while preparing the data for your letter.", "Mail Merge Error");
					return;
				}
				fileToOpen = cMyDB.GetResult("Select Filename from LetterTypeLookup Where ID = " + this.lookupCombo1.SelectedValue.ToString());
				System.IO.FileInfo fi = new System.IO.FileInfo((string)fileToOpen);
				if (!fi.Exists)
				{
					MessageBox.Show("The template file associated with this letter does not exist.", "Letter Error");
					return;
				}
				if (!lblLocation.Text.EndsWith("\\"))
					lblLocation.Text += "\\";
				lblFilename.Text = dsLetters1.Letters[0].CaseID.ToString() + "-" + DateTime.Now.Ticks.ToString() + ".doc";
				fileToSave = lblLocation.Text + lblFilename.Text;
				fi = new System.IO.FileInfo((string)fileToSave);
				if (fi.Exists)
				{
					while (fi.Exists)
					{
						lblFilename.Text = dsLetters1.Letters[0].CaseID.ToString() + "-" + DateTime.Now.Ticks.ToString() + ".doc";
						fileToSave = lblLocation.Text + lblFilename.Text;
						fi = new System.IO.FileInfo((string)fileToSave);
					}
				}
			}
			else
			{
				if (!lblLocation.Text.EndsWith("\\"))
					lblLocation.Text += "\\";
				fileToOpen = lblLocation.Text + lblFilename.Text;
				System.IO.FileInfo fi = new System.IO.FileInfo((string)fileToOpen);
				if (!fi.Exists)
				{
					MessageBox.Show("The saved letter file for this letter cannot be found. Check that you have access to the save location.", "Letter Error");
					return;
				}
			}

			bool ErrorOccured = false;
			object nothing = System.Reflection.Missing.Value;
			object wrdFalse = false;
			Word8.Application wdapp = null;
			Word8.Document wdDoc = null;
			object wrd1 = 1;
			object wrdRange = Word8.WdPrintOutRange.wdPrintAllDocument;
			object wrdPages = Word8.WdPrintOutPages.wdPrintAllPages;

			try
			{
				wdapp= new Word8.ApplicationClass();

				wdDoc = wdapp.Documents.Open(ref fileToOpen, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
				if (Adding)
				{
					wdDoc.MailMerge.OpenDataSource(Environment.CurrentDirectory + "\\MailMergeData.rtf", ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
					wdDoc.MailMerge.Destination = Word8.WdMailMergeDestination.wdSendToNewDocument;

					try
					{
						wdDoc.MailMerge.Execute(ref nothing);
					}
					catch (Exception ex)
					{
						ErrorOccured = true;
						MessageBox.Show("An error occured during the communication with Microsoft Word. If this problem persists please contact support. [" + ex.Message + "]", "Automation Error");
					}
					finally
					{
						wdDoc.Close(ref wrdFalse, ref nothing, ref nothing);
					}
					wdDoc = null;
					
					if (!ErrorOccured)
					{
						if (chkSave.Checked)
						{
							wdapp.ActiveDocument.SaveAs(ref fileToSave, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
						}
												
						wdapp.ActiveDocument.PrintOut(ref wrdFalse, ref nothing, ref wrdRange, ref nothing, ref nothing, ref nothing, ref nothing, ref wrd1, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
						wdapp.ActiveDocument.Close(ref wrdFalse, ref nothing, ref nothing);
					}
				}
				else
				{
					wdDoc.PrintOut(ref wrdFalse, ref nothing, ref wrdRange, ref nothing, ref nothing, ref nothing, ref nothing, ref wrd1, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
					wdDoc.Close(ref wrdFalse, ref nothing, ref nothing);
				}
				sucessful = true;
				wdapp.Quit(ref wrdFalse, ref nothing, ref nothing);
				wdapp = null;
			}
			catch (Exception ex)
			{ 
				MessageBox.Show("An error occured during the communication with Microsoft Word. If this problem persists please contact support. [" + ex.Message + "]", "Automation Error");
			}
			finally
			{
				wdDoc = null;
				if(	wdapp != null)
				{
					wdapp.Quit(ref wrdFalse, ref nothing, ref nothing);
					wdapp = null;
				}
			}
			
			if (Adding && sucessful && !ErrorOccured)
			{
				if (chkSave.Checked)
				{
					dsLetters1.Letters[0].BeginEdit();
					dsLetters1.Letters[0].Filename = lblFilename.Text;
					dsLetters1.Letters[0].EndEdit();
				}
				base.cmdOK_Click(sender, e);

				foreach(DataRow dr in dsRecipients.Tables[0].Rows)
				{
					dr["LetterID"] = dsLetters1.Letters.Rows[0]["ID"];
				}
				daRecipients.Update(dsRecipients, "LetterRecipients");			
			}
		}

		private void cmdOpenLetter_Click(object sender, System.EventArgs e)
		{
			object fileToOpen = null;
			object fileToSave = null;
			bool sucessful = false;

			if (Adding)
			{
				if (!OutputMailMergeData("MailMergeData.rtf", Environment.CurrentDirectory))
				{
					MessageBox.Show("An error occurred while preparing the data for your letter.", "Mail Merge Error");
					return;
				}
				fileToOpen = cMyDB.GetResult("Select Filename from LetterTypeLookup Where ID = " + this.lookupCombo1.SelectedValue.ToString());
				System.IO.FileInfo fi = new System.IO.FileInfo((string)fileToOpen);
				if (!fi.Exists)
				{
					MessageBox.Show("The template file associated with this letter does not exist.", "Letter Error");
					return;
				}
				if (!lblLocation.Text.EndsWith("\\"))
					lblLocation.Text += "\\";
				lblFilename.Text = dsLetters1.Letters[0].CaseID.ToString() + "-" + DateTime.Now.Ticks.ToString() + ".doc";
				fileToSave = lblLocation.Text + lblFilename.Text;
				fi = new System.IO.FileInfo((string)fileToSave);
				if (fi.Exists)
				{
					while (fi.Exists)
					{
						lblFilename.Text = dsLetters1.Letters[0].CaseID.ToString() + "-" + DateTime.Now.Ticks.ToString() + ".doc";
						fileToSave = lblLocation.Text + lblFilename.Text;
						fi = new System.IO.FileInfo((string)fileToSave);
					}
				}
			}
			else
			{
				if (!lblLocation.Text.EndsWith("\\"))
					lblLocation.Text += "\\";
				fileToOpen = lblLocation.Text + lblFilename.Text;
				System.IO.FileInfo fi = new System.IO.FileInfo((string)fileToOpen);
				if (!fi.Exists)
				{
					MessageBox.Show("The saved letter file for this letter cannot be found. Check that you have access to the save location.", "Letter Error");
					return;
				}
			}

			bool ErrorOccured = false;
			Word8.Application wdapp=null;
			object wrdFalse = false;
			object wrd1 = 1;
			
			if (LoadWord(ref wdapp))
			{
				object nothing = System.Reflection.Missing.Value;

				try
				{
					int tempTop = 0;
					int tempHeight = 0;
					int tempLeft = 0;
					int tempWidth = 0;
					bool restoreWinPos = false;

					if (wdapp.Windows.Count > 0)
					{
						/*if (wdapp.Windows.Item(ref wrd1).WindowState != Word8.WdWindowState.wdWindowStateMinimize)
						{
							tempTop = wdapp.Windows.Item(ref wrd1).Top;
							tempHeight = wdapp.Windows.Item(ref wrd1).Height;
							tempLeft = wdapp.Windows.Item(ref wrd1).Left;
							tempWidth = wdapp.Windows.Item(ref wrd1).Width;
							restoreWinPos = true;
						}*/
					}

					Word8.Document wdDoc = wdapp.Documents.Open(ref fileToOpen, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
					
					/*if (restoreWinPos)
					{
						wdDoc.Windows.Item(ref wrd1).Top = tempTop;
						wdDoc.Windows.Item(ref wrd1).Height = tempHeight;
						wdDoc.Windows.Item(ref wrd1).Left = tempLeft;
						wdDoc.Windows.Item(ref wrd1).Width = tempWidth;
					}*/

					if (Adding)
					{
						wdDoc.MailMerge.OpenDataSource(Environment.CurrentDirectory + "\\MailMergeData.rtf", ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
						wdDoc.MailMerge.Destination = Word8.WdMailMergeDestination.wdSendToNewDocument;
						
						try
						{
							wdDoc.MailMerge.Execute(ref nothing);
						}
						catch (Exception ex)
						{
							ErrorOccured = true;
							MessageBox.Show("An error occured during the communication with Microsoft Word. If this problem persists please contact support. [" + ex.Message + "]", "Automation Error");
						}
						finally
						{
							wdDoc.Close(ref wrdFalse, ref nothing, ref nothing);
						}
						wdDoc = null;
						if (!ErrorOccured)
						{
							if (chkSave.Checked)
							{
								wdapp.ActiveDocument.SaveAs(ref fileToSave, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing, ref nothing);
							}
						}
					}
					if (!wdapp.Visible)
						wdapp.Visible = true;
					wdapp.Activate();
					wdapp.WindowState = Word8.WdWindowState.wdWindowStateMaximize;
					sucessful = true;
				}
				catch (Exception ex)
				{ 
					MessageBox.Show("An error occured during the communication with Microsoft Word. If this problem persists please contact support. [" + ex.Message + "]", "Automation Error");
				}
			}
			else
				MessageBox.Show("Microsoft Word based functions are not currently available on this PC. Please Contact Tech Support.", "Configuration Error");

			wdapp = null;

			if (Adding && sucessful && !ErrorOccured) 
			{
				if (chkSave.Checked)
				{
					dsLetters1.Letters[0].BeginEdit();
					dsLetters1.Letters[0].Filename = lblFilename.Text;
					dsLetters1.Letters[0].Edited = true;
					dsLetters1.Letters[0].EndEdit();
				}
				base.cmdOK_Click(sender, e);
			
				foreach(DataRow dr in dsRecipients.Tables[0].Rows)
				{
					dr["LetterID"] = dsLetters1.Letters.Rows[0]["ID"];
				}
				daRecipients.Update(dsRecipients, "LetterRecipients");
			}
		}

		private void listViewEx1_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (this.Adding)
			{
				if( e.Button == MouseButtons.Right)
				{
					if (listViewEx1.GetItemAt(e.X, e.Y)!=null)
					{
						mnuRemove.Visible = true;
						mnuRemove.UserData = listViewEx1.GetItemAt(e.X, e.Y).Tag;
					}
					else
					{
						mnuRemove.Visible = false;
					}
					pm.TrackPopup(listViewEx1.PointToScreen(new Point(e.X,e.Y)));
				}
			}
		}

		private void lookupCombo1_Validating(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if (lookupCombo1.SelectedIndex < 0 )
			{
				MessageBox.Show("You must select a letter type.", "Invalid Selection");
				e.Cancel = true;
			}		
		}

		private void daLetters_RowUpdated(object sender, System.Data.OleDb.OleDbRowUpdatedEventArgs e)
		{
			if (e.StatementType == StatementType.Insert)
			{
				System.Data.OleDb.OleDbCommand getKey = new System.Data.OleDb.OleDbCommand("SELECT @@IDENTITY", e.Command.Connection);
				e.Row["ID"] = getKey.ExecuteScalar();
				getKey.Dispose();
			}
		}
	}
}

