using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmUsers.
	/// </summary>
	public class frmMaintainCompanies : System.Windows.Forms.Form
	{
		private UtilityLibrary.WinControls.ButtonEx cmdClose;
		private Crownwood.Magic.Menus.MenuCommand mnuDelete;
		private Crownwood.Magic.Menus.MenuCommand mnuRefresh;
		private Crownwood.Magic.Menus.MenuCommand mnuNew;
		private Crownwood.Magic.Menus.MenuCommand mnuEdit;
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private System.Windows.Forms.ColumnHeader columnHeader2;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private UtilityLibrary.WinControls.ListViewEx lvwCompanies;
		private Crownwood.Magic.Menus.PopupMenu pm;
		private System.Windows.Forms.ColumnHeader columnHeader3;
		private System.Windows.Forms.ColumnHeader columnHeader4;
		private System.Windows.Forms.ColumnHeader columnHeader5;
		private System.Windows.Forms.ColumnHeader columnHeader6;
		private System.Windows.Forms.ColumnHeader columnHeader7;
		private System.Windows.Forms.ColumnHeader columnHeader8;
		private System.Windows.Forms.ColumnHeader columnHeader9;
		private object mLastUpdated;

		public frmMaintainCompanies()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			
			FillCompanyList();
			
			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuNew);
			pm.MenuCommands.Add(mnuEdit);
			pm.MenuCommands.Add(mnuDelete);
			pm.MenuCommands.Add(mnuRefresh);
		}

		private void FillCompanyList()
		{
			lvwCompanies.BeginUpdate();
			lvwCompanies.Items.Clear();
			dsCompanies dsCompanies1 = new dsCompanies();
			CCompanies.FillData(dsCompanies1, true, true, true, true, true, true, true, true, true);
			foreach (dsCompanies.CompaniesRow ur in dsCompanies1.Companies)
			{
				ListViewItem temp = null;
				temp = lvwCompanies.Items.Add(ur.ShortName);
				if(!ur.IsFullNameNull())
					temp.SubItems.Add(ur.FullName);
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForHousingAssociationNull())
				{
					if(ur.ValidForHousingAssociation)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForInvoiceSourceNull())
				{
					if(ur.ValidForInvoiceSource)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForValuerNull())
				{
					if(ur.ValidForValuer)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForEndowmentCompanyNull())
				{
					if(ur.ValidForEndowmentCompany)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForEstateAgentNull())
				{
					if(ur.ValidForEstateAgent)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForIndemnityCompanyNull())
				{
					if(ur.ValidForIndemnityCompany)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if(!ur.IsValidForSecondChargeNull())
				{
					if(ur.ValidForSecondCharge)
						temp.SubItems.Add("Yes");
					else
						temp.SubItems.Add(String.Empty);
				}
				else
					temp.SubItems.Add(String.Empty);
				if (!ur.IsLastUpdatedNull())
					temp.Tag = ur.LastUpdated;
				else
					temp.Tag = DBNull.Value;
			}
			dsCompanies1.Dispose();
			lvwCompanies.EndUpdate();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmMaintainCompanies));
			this.lvwCompanies = new UtilityLibrary.WinControls.ListViewEx();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader2 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader3 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader4 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader5 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader6 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader7 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader8 = new System.Windows.Forms.ColumnHeader();
			this.columnHeader9 = new System.Windows.Forms.ColumnHeader();
			this.cmdClose = new UtilityLibrary.WinControls.ButtonEx();
			this.mnuDelete = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuRefresh = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuNew = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuEdit = new Crownwood.Magic.Menus.MenuCommand();
			this.SuspendLayout();
			// 
			// lvwCompanies
			// 
			this.lvwCompanies.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwCompanies.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwCompanies.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwCompanies.CheckBookLookEnabled = false;
			this.lvwCompanies.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwCompanies.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwCompanies.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						   this.columnHeader1,
																						   this.columnHeader2,
																						   this.columnHeader3,
																						   this.columnHeader4,
																						   this.columnHeader5,
																						   this.columnHeader6,
																						   this.columnHeader7,
																						   this.columnHeader8,
																						   this.columnHeader9});
			this.lvwCompanies.FullRowSelect = true;
			this.lvwCompanies.HeaderColor = System.Drawing.Color.Empty;
			this.lvwCompanies.HeaderImageList = null;
			this.lvwCompanies.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwCompanies.Location = new System.Drawing.Point(4, 6);
			this.lvwCompanies.MultiSelect = false;
			this.lvwCompanies.Name = "lvwCompanies";
			this.lvwCompanies.PaintSortedColumnBackground = true;
			this.lvwCompanies.Size = new System.Drawing.Size(496, 231);
			this.lvwCompanies.SortingEnabled = true;
			this.lvwCompanies.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwCompanies.TabIndex = 0;
			this.lvwCompanies.View = System.Windows.Forms.View.Details;
			this.lvwCompanies.Resize += new System.EventHandler(this.lvwCompanies_Resize);
			this.lvwCompanies.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwCompanies_MouseUp);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Short Name";
			this.columnHeader1.Width = 70;
			// 
			// columnHeader2
			// 
			this.columnHeader2.Text = "Full Name";
			this.columnHeader2.Width = 160;
			// 
			// columnHeader3
			// 
			this.columnHeader3.Text = "H.A.";
			this.columnHeader3.Width = 35;
			// 
			// columnHeader4
			// 
			this.columnHeader4.Text = "Inv.";
			this.columnHeader4.Width = 35;
			// 
			// columnHeader5
			// 
			this.columnHeader5.Text = "Val.";
			this.columnHeader5.Width = 35;
			// 
			// columnHeader6
			// 
			this.columnHeader6.Text = "End.";
			this.columnHeader6.Width = 35;
			// 
			// columnHeader7
			// 
			this.columnHeader7.Text = "Est.";
			this.columnHeader7.Width = 35;
			// 
			// columnHeader8
			// 
			this.columnHeader8.Text = "Ind.";
			this.columnHeader8.Width = 35;
			// 
			// columnHeader9
			// 
			this.columnHeader9.Text = "S.C.";
			this.columnHeader9.Width = 35;
			// 
			// cmdClose
			// 
			this.cmdClose.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdClose.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.cmdClose.Location = new System.Drawing.Point(426, 246);
			this.cmdClose.Name = "cmdClose";
			this.cmdClose.TabIndex = 1;
			this.cmdClose.Text = "Close ";
			// 
			// mnuDelete
			// 
			this.mnuDelete.Description = "Delete this Company";
			this.mnuDelete.Text = "&Delete Company";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// mnuRefresh
			// 
			this.mnuRefresh.Description = "Refresh this list";
			this.mnuRefresh.Text = "&Refresh";
			this.mnuRefresh.Click += new System.EventHandler(this.mnuRefresh_Click);
			// 
			// mnuNew
			// 
			this.mnuNew.Description = "New Company";
			this.mnuNew.Text = "&New Company";
			this.mnuNew.Click += new System.EventHandler(this.mnuNew_Click);
			// 
			// mnuEdit
			// 
			this.mnuEdit.Description = "Edit Company";
			this.mnuEdit.Text = "&Edit Company";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// frmMaintainCompanies
			// 
			this.AcceptButton = this.cmdClose;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(505, 276);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdClose,
																		  this.lvwCompanies});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmMaintainCompanies";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Company Maintenance";
			this.ResumeLayout(false);

		}
		#endregion

		private void mnuDelete_Click(object sender, System.EventArgs e)
		{
			CCompanies.DeleteCompany(lvwCompanies.Tag.ToString(),mLastUpdated);
			mnuRefresh_Click(sender, e);
		}

		private void mnuNew_Click(object sender, System.EventArgs e)
		{
			CCompanies.AddCompany(true, true, true, true, true, false, true, true, false);
			mnuRefresh_Click(sender, e);
		}

		private void mnuEdit_Click(object sender, System.EventArgs e)
		{
			CCompanies.EditCompany(lvwCompanies.Tag.ToString());
			mnuRefresh_Click(sender, e);
		}

		private void mnuRefresh_Click(object sender, System.EventArgs e)
		{
			FillCompanyList();
		}

		private void lvwCompanies_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				if (lvwCompanies.GetItemAt(e.X,e.Y)!=null)
				{
					lvwCompanies.Tag = lvwCompanies.GetItemAt(e.X,e.Y).Text;
					mLastUpdated = lvwCompanies.GetItemAt(e.X,e.Y).Tag;
					mnuEdit.Visible = true;
					mnuDelete.Visible = true;
				}
				else
				{
					mnuEdit.Visible = false;
					mnuDelete.Visible = false;
				}
				mnuEdit.Enabled = CSession.MaintainCompanies;
				mnuDelete.Enabled = CSession.MaintainCompanies;
				mnuNew.Enabled = CSession.MaintainCompanies;
				pm.TrackPopup(lvwCompanies.PointToScreen(new Point(e.X,e.Y)));
			}
		}

		private void lvwCompanies_Resize(object sender, System.EventArgs e)
		{
		
		}
	}
}
