using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data.OleDb;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmReports.
	/// </summary>
	public class frmReports : System.Windows.Forms.Form
	{
		private System.Windows.Forms.ColumnHeader columnHeader1;
		private UtilityLibrary.WinControls.ListViewEx lvwReports;
		private UtilityLibrary.WinControls.ButtonEx cmdOpen;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmReports()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			lvwReports.Columns[0].Width = lvwReports.ClientSize.Width;
			lvwReports.Items.Add("Properties in possession").Tag = 1;
			lvwReports.Items.Add("Degree of Arrears Breakdown").Tag = 2;
			lvwReports.Items.Add("Possession Chart").Tag = 3;
			lvwReports.Items.Add("V4 Report Engine Test").Tag = 4;
			cmdOpen.Enabled = false;
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmReports));
			this.lvwReports = new UtilityLibrary.WinControls.ListViewEx();
			this.columnHeader1 = new System.Windows.Forms.ColumnHeader();
			this.cmdOpen = new UtilityLibrary.WinControls.ButtonEx();
			this.SuspendLayout();
			// 
			// lvwReports
			// 
			this.lvwReports.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwReports.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwReports.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwReports.CheckBookLookEnabled = false;
			this.lvwReports.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwReports.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwReports.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
																						 this.columnHeader1});
			this.lvwReports.FullRowSelect = true;
			this.lvwReports.HeaderColor = System.Drawing.Color.Empty;
			this.lvwReports.HeaderImageList = null;
			this.lvwReports.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwReports.Location = new System.Drawing.Point(6, 9);
			this.lvwReports.MultiSelect = false;
			this.lvwReports.Name = "lvwReports";
			this.lvwReports.PaintSortedColumnBackground = true;
			this.lvwReports.Size = new System.Drawing.Size(278, 221);
			this.lvwReports.SortingEnabled = true;
			this.lvwReports.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwReports.TabIndex = 0;
			this.lvwReports.View = System.Windows.Forms.View.Details;
			this.lvwReports.Click += new System.EventHandler(this.lvwReports_Click);
			// 
			// columnHeader1
			// 
			this.columnHeader1.Text = "Report Name";
			// 
			// cmdOpen
			// 
			this.cmdOpen.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.cmdOpen.Location = new System.Drawing.Point(210, 238);
			this.cmdOpen.Name = "cmdOpen";
			this.cmdOpen.TabIndex = 1;
			this.cmdOpen.Text = "Open Report ";
			this.cmdOpen.Click += new System.EventHandler(this.cmdOpen_Click);
			// 
			// frmReports
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(292, 266);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.cmdOpen,
																		  this.lvwReports});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "frmReports";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Available Reports";
			this.Resize += new System.EventHandler(this.frmReports_Resize);
			this.ResumeLayout(false);

		}
		#endregion

		private void frmReports_Resize(object sender, System.EventArgs e)
		{
			lvwReports.Columns[0].Width = lvwReports.ClientSize.Width;		
		}

		private void cmdOpen_Click(object sender, System.EventArgs e)
		{
			switch ((int)lvwReports.SelectedItems[0].Tag)
			{
				case 1:
				{
					new CReportViewer(new CasesDataEngine("Select * from Cases Where PossessionDate is not null and Archived = false"),new SampleReportA());
					break;
				}
				case 2:
				{
					new CReportViewer(new CasesDataEngine(),new SampleReportB());
					break;
				}
				case 3:
				{
					new CReportViewer(new PinPDataEngine(),new PinPReport());
					break;
				}			
				case 4:
				{
					new V4ReportViewer(new CasesDataEngine());
					break;
				}
			}
			lvwReports.Focus();
		}

		private void lvwReports_Click(object sender, System.EventArgs e)
		{
			if (lvwReports.SelectedItems.Count > 0)
				cmdOpen.Enabled = true;
			else
				cmdOpen.Enabled = false;
		}
	}
}
