using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for frmSelectRecipients.
	/// </summary>
	public class frmSelectRecipients : System.Windows.Forms.Form
	{
		private UtilityLibrary.WinControls.ButtonEx buttonEx1;
		private UtilityLibrary.WinControls.ButtonEx buttonEx2;
		public UtilityLibrary.WinControls.ListViewEx lvwAvailable;
		private System.Data.OleDb.OleDbCommand cmdList;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmSelectRecipients(Int32 CaseID)
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();

			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			lvwAvailable.Columns.Clear();
			lvwAvailable.Columns.Add("Type",lvwAvailable.ClientSize.Width / 4,HorizontalAlignment.Left);
			lvwAvailable.Columns.Add("Name",lvwAvailable.ClientSize.Width / 4,HorizontalAlignment.Left);
			lvwAvailable.Columns.Add("Address",lvwAvailable.ClientSize.Width / 2,HorizontalAlignment.Left);
			
			lvwAvailable.BeginUpdate();
			lvwAvailable.Items.Clear();
			cmdList.Parameters["CaseID"].Value = CaseID;
			DataSet dt = cMyDB.GetDataSet(cmdList);

			ListViewItem temp = lvwAvailable.Items.Add("Borrowers");
			temp.SubItems.Add("Default Title");
			temp.SubItems.Add("Property Address");
			temp.Tag = DBNull.Value;

			foreach (DataRow dr in dt.Tables[0].Rows)
			{
				temp = lvwAvailable.Items.Add(dr["Description"] + String.Empty);
				temp.SubItems.Add(dr["Title"] + " " + dr["Initials"] + " " + dr["Surname"]);
				if(dr["AddressAsProperty"].Equals(true))
					temp.SubItems.Add("Property Address");
				else
					temp.SubItems.Add(dr["Address"].ToString().Replace("\r\n",", "));
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvwAvailable.EndUpdate();
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.lvwAvailable = new UtilityLibrary.WinControls.ListViewEx();
			this.buttonEx1 = new UtilityLibrary.WinControls.ButtonEx();
			this.buttonEx2 = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdList = new System.Data.OleDb.OleDbCommand();
			this.SuspendLayout();
			// 
			// lvwAvailable
			// 
			this.lvwAvailable.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwAvailable.FullRowSelect = true;
			this.lvwAvailable.HeaderImageList = null;
			this.lvwAvailable.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwAvailable.Location = new System.Drawing.Point(9, 10);
			this.lvwAvailable.Name = "lvwAvailable";
			this.lvwAvailable.Size = new System.Drawing.Size(343, 132);
			this.lvwAvailable.TabIndex = 0;
			this.lvwAvailable.View = System.Windows.Forms.View.Details;
			// 
			// buttonEx1
			// 
			this.buttonEx1.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.buttonEx1.DialogResult = System.Windows.Forms.DialogResult.OK;
			this.buttonEx1.Location = new System.Drawing.Point(209, 147);
			this.buttonEx1.Name = "buttonEx1";
			this.buttonEx1.Size = new System.Drawing.Size(68, 23);
			this.buttonEx1.TabIndex = 1;
			this.buttonEx1.Text = "Add ";
			// 
			// buttonEx2
			// 
			this.buttonEx2.Anchor = (System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Right);
			this.buttonEx2.DialogResult = System.Windows.Forms.DialogResult.Cancel;
			this.buttonEx2.Location = new System.Drawing.Point(284, 147);
			this.buttonEx2.Name = "buttonEx2";
			this.buttonEx2.Size = new System.Drawing.Size(68, 23);
			this.buttonEx2.TabIndex = 2;
			this.buttonEx2.Text = "Cancel ";
			// 
			// cmdList
			// 
			this.cmdList.CommandText = @"SELECT PersonTypeLookup.Description, People.Title, People.Surname, People.AddressAsProperty, People.Address, People.CaseID, People.ID, People.Initials FROM People INNER JOIN PersonTypeLookup ON People.PersonType = PersonTypeLookup.ID WHERE (People.CaseID = ?)";
			this.cmdList.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			// 
			// frmSelectRecipients
			// 
			this.AcceptButton = this.buttonEx1;
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.CancelButton = this.buttonEx2;
			this.ClientSize = new System.Drawing.Size(362, 176);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.buttonEx2,
																		  this.buttonEx1,
																		  this.lvwAvailable});
			this.Name = "frmSelectRecipients";
			this.SizeGripStyle = System.Windows.Forms.SizeGripStyle.Hide;
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "Select Recipients to Add";
			this.ResumeLayout(false);

		}
		#endregion
	}
}
