using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for AssociatedCostListManager.
	/// </summary>
	public class AssociatedCostListManager: OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmAssociatedCosts();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select [Date], Amount, Comments, ID From AssociatedCosts Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp;
				if (!dr["Date"].Equals(DBNull.Value))
					temp = lvw.Items.Add(((DateTime)dr["Date"]).ToShortDateString());
				else
					continue;
				if (!dr["Amount"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["Amount"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);				
				temp.SubItems.Add(dr["Comments"] + String.Empty);
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Amount",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Comments",lvw.ClientSize.Width / 2, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
		}
	}
}
