using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Windows.Forms;

namespace DebtManagerTest.InterfaceComponents
{
	/// <summary>
	/// Summary description for CompanyLookup.
	/// </summary>
	public class CompanyLookup : System.Windows.Forms.ComboBox
	{
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private bool mValidForHousingAssociation = false;
		private bool mValidForEndowmentCompany = false;
		private bool mValidForIndemnityCompany = false;
		private bool mValidForValuer = false;
		private bool mValidForSecondCharge = false;
		private bool mValidForCreditor = false;
		private bool mValidForEstateAgent = false;
		private bool mValidForInvoiceSource = false;
		private bool mValidForEmployer = false;
		public event EventHandler ListUpdated;
		private Crownwood.Magic.Menus.MenuCommand mnuEdit;
		private Crownwood.Magic.Menus.MenuCommand mnuAdd;
		private Crownwood.Magic.Menus.PopupMenu pm;
		private bool mDataBound = false;

		public bool zDataBound
		{
			get 
			{
				return mDataBound;
			}
			set
			{
				if (!DesignMode)
				{
					if (this.DataSource == null)
					{
						dsCompanies ds = new dsCompanies();
						CCompanies.FillData(ds, this.ValidForHousingAssociation,
												this.ValidForEndowmentCompany,
												this.ValidForIndemnityCompany,
												this.ValidForValuer,
												this.ValidForSecondCharge,
												this.ValidForCreditor,
												this.ValidForEstateAgent,
												this.ValidForInvoiceSource,
												this.ValidForEmployer);
						this.DataSource = ds.Companies;
						this.ValueMember = "ShortName";
						this.DisplayMember = "FullName";						
					}
					this.SelectedIndex = -1;
				}
				mDataBound = value;
			}
		}

		public bool ValidForHousingAssociation
		{
			get 
			{
				return mValidForHousingAssociation;
			}
			set
			{
				mValidForHousingAssociation = value;
			}
		}
		public bool ValidForEndowmentCompany
		{
			get 
			{
				return mValidForEndowmentCompany;
			}
			set
			{
				mValidForEndowmentCompany = value;
			}
		}
		public bool ValidForIndemnityCompany
		{
			get 
			{
				return mValidForIndemnityCompany;
			}
			set
			{
				mValidForIndemnityCompany = value;
			}
		}
		public bool ValidForValuer
		{
			get 
			{
				return mValidForValuer;
			}
			set
			{
				mValidForValuer = value;
			}
		}
		public bool ValidForSecondCharge
		{
			get 
			{
				return mValidForSecondCharge;
			}
			set
			{
				mValidForSecondCharge = value;
			}
		}
		public bool ValidForCreditor
		{
			get 
			{
				return mValidForCreditor;
			}
			set
			{
				mValidForCreditor = value;
			}
		}
		public bool ValidForEstateAgent
		{
			get 
			{
				return mValidForEstateAgent;
			}
			set
			{
				mValidForEstateAgent = value;
			}
		}
		public bool ValidForInvoiceSource
		{
			get 
			{
				return mValidForInvoiceSource;
			}
			set
			{
				mValidForInvoiceSource = value;
			}
		}
		public bool ValidForEmployer
		{
			get 
			{
				return mValidForEmployer;
			}
			set
			{
				mValidForEmployer = value;
			}
		}

		public CompanyLookup()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call
			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuEdit);
			pm.MenuCommands.Add(mnuAdd);
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.mnuEdit = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdd = new Crownwood.Magic.Menus.MenuCommand();
			// 
			// mnuEdit
			// 
			this.mnuEdit.Description = "Edit Company";
			this.mnuEdit.Text = "&Edit Company";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// mnuAdd
			// 
			this.mnuAdd.Description = "Add Company";
			this.mnuAdd.Text = "&New Company";
			this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
			// 
			// CompanyLookup
			// 
			this.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;

		}
		#endregion

		protected override void OnMouseUp(System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				if (this.SelectedIndex >= 0)
					mnuEdit.Visible = true;
				else
					mnuEdit.Visible = false;
				
				mnuEdit.Enabled = CSession.MaintainCompanies;
				mnuAdd.Enabled = CSession.MaintainCompanies;
				
				pm.TrackPopup(this.PointToScreen(new Point(e.X,e.Y)));
			}
			base.OnMouseUp(e);
		}

		private void mnuEdit_Click(object sender, System.EventArgs e)
		{
			CCompanies.EditCompany(this.SelectedValue.ToString());
			object curVal = this.SelectedValue;
			this.BeginUpdate();
			((dsCompanies.CompaniesDataTable)this.DataSource).Dispose();
			dsCompanies ds = new dsCompanies();
			CCompanies.FillData(ds,
								this.ValidForHousingAssociation,
								this.ValidForEndowmentCompany,
								this.ValidForIndemnityCompany,
								this.ValidForValuer,
								this.ValidForSecondCharge,
								this.ValidForCreditor,
								this.ValidForEstateAgent,
								this.ValidForInvoiceSource,
								this.ValidForEmployer);
			this.DataSource = ds.Companies;
			this.DisplayMember = "FullName";
			this.ValueMember = "ShortName";
			if (curVal!= null)
				this.SelectedValue = curVal;
			this.EndUpdate();
			if (this.ListUpdated != null)
				this.ListUpdated(this, new EventArgs());
		}

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			CCompanies.AddCompany(this.ValidForHousingAssociation,
									this.ValidForEndowmentCompany,
									this.ValidForIndemnityCompany,
									this.ValidForValuer,
									this.ValidForSecondCharge,
									this.ValidForCreditor,
									this.ValidForEstateAgent,
									this.ValidForInvoiceSource,
									this.ValidForEmployer);
			object curVal = this.SelectedValue;
			this.BeginUpdate();
			((dsCompanies.CompaniesDataTable)this.DataSource).Dispose();
			dsCompanies ds = new dsCompanies();
			CCompanies.FillData(ds,
								this.ValidForHousingAssociation,
								this.ValidForEndowmentCompany,
								this.ValidForIndemnityCompany,
								this.ValidForValuer,
								this.ValidForSecondCharge,
								this.ValidForCreditor,
								this.ValidForEstateAgent,
								this.ValidForInvoiceSource,
								this.ValidForEmployer);
			this.DataSource = ds.Companies;
			this.DisplayMember = "FullName";
			this.ValueMember = "ShortName";
			if (curVal!= null)
				this.SelectedValue = curVal;
			this.EndUpdate();
			if (this.ListUpdated != null)
				this.ListUpdated(this, new EventArgs());
		}

		public void RefreshData()
		{
			object curVal = this.SelectedValue;
			this.BeginUpdate();
			((dsCompanies.CompaniesDataTable)this.DataSource).Dispose();
			dsCompanies ds = new dsCompanies();
			CCompanies.FillData(ds, this.ValidForHousingAssociation,
				this.ValidForEndowmentCompany,
				this.ValidForIndemnityCompany,
				this.ValidForValuer,
				this.ValidForSecondCharge,
				this.ValidForCreditor,
				this.ValidForEstateAgent,
				this.ValidForInvoiceSource,
				this.ValidForEmployer);
			this.DataSource = ds.Companies;
			this.ValueMember = "ShortName";
			this.DisplayMember = "FullName";
			if (curVal!= null)
				this.SelectedValue = curVal;
			this.EndUpdate();
		}
	}
}
