using System;
using System.Collections;
using System.ComponentModel;
using System.Drawing;
using System.Data;
using System.Data.OleDb;
using System.Windows.Forms;

namespace DebtManagerTest.InterfaceComponents
{
	/// <summary>
	/// Summary description for FindCase.
	/// </summary>
	public class FindCase : System.Windows.Forms.UserControl
	{
		private System.Windows.Forms.Label label1;
		private System.Windows.Forms.ComboBox cboSearch;
		private Crownwood.Magic.Menus.MenuCommand mnuOpen;
		/// <summary> 
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;
		private UtilityLibrary.WinControls.ListViewEx lvwResults;
		private ArrayList SearchHistory;
		private System.Windows.Forms.Label label2;
		private Crownwood.Magic.Menus.PopupMenu pm;

		public FindCase()
		{
			// This call is required by the Windows.Forms Form Designer.
			InitializeComponent();

			// TODO: Add any initialization after the InitForm call
			SearchHistory = new ArrayList();
			cboSearch.DataSource = SearchHistory;
			SetupColumns();
			pm = new Crownwood.Magic.Menus.PopupMenu();
            pm.MenuCommands.Add(mnuOpen);
		}

		/// <summary> 
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Component Designer generated code
		/// <summary> 
		/// Required method for Designer support - do not modify 
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.label1 = new System.Windows.Forms.Label();
			this.cboSearch = new System.Windows.Forms.ComboBox();
			this.mnuOpen = new Crownwood.Magic.Menus.MenuCommand();
			this.lvwResults = new UtilityLibrary.WinControls.ListViewEx();
			this.label2 = new System.Windows.Forms.Label();
			this.SuspendLayout();
			// 
			// label1
			// 
			this.label1.Location = new System.Drawing.Point(6, 8);
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(60, 18);
			this.label1.TabIndex = 1;
			this.label1.Text = "Search For";
			// 
			// cboSearch
			// 
			this.cboSearch.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.cboSearch.Location = new System.Drawing.Point(71, 5);
			this.cboSearch.Name = "cboSearch";
			this.cboSearch.Size = new System.Drawing.Size(156, 21);
			this.cboSearch.TabIndex = 3;
			this.cboSearch.KeyPress += new System.Windows.Forms.KeyPressEventHandler(this.cboSearch_KeyPress);
			// 
			// mnuOpen
			// 
			this.mnuOpen.Description = "Open Case";
			this.mnuOpen.Text = "&Open";
			this.mnuOpen.Click += new System.EventHandler(this.mnuOpen_Click);
			// 
			// lvwResults
			// 
			this.lvwResults.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwResults.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwResults.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwResults.CheckBookLookEnabled = false;
			this.lvwResults.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwResults.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwResults.FullRowSelect = true;
			this.lvwResults.HeaderColor = System.Drawing.Color.Empty;
			this.lvwResults.HeaderImageList = null;
			this.lvwResults.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwResults.HideSelection = false;
			this.lvwResults.Location = new System.Drawing.Point(8, 45);
			this.lvwResults.MultiSelect = false;
			this.lvwResults.Name = "lvwResults";
			this.lvwResults.PaintSortedColumnBackground = true;
			this.lvwResults.Size = new System.Drawing.Size(220, 133);
			this.lvwResults.SortingEnabled = true;
			this.lvwResults.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwResults.TabIndex = 4;
			this.lvwResults.View = System.Windows.Forms.View.Details;
			this.lvwResults.Resize += new System.EventHandler(this.lvwResults_Resize);
			this.lvwResults.DoubleClick += new System.EventHandler(this.lvwResults_DoubleClick_1);
			this.lvwResults.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwResults_MouseUp);
			// 
			// label2
			// 
			this.label2.Anchor = ((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.label2.Location = new System.Drawing.Point(69, 28);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(152, 15);
			this.label2.TabIndex = 5;
			this.label2.Text = "Post Code/Address/Surname";
			// 
			// FindCase
			// 
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.label2,
																		  this.lvwResults,
																		  this.cboSearch,
																		  this.label1});
			this.Name = "FindCase";
			this.Size = new System.Drawing.Size(235, 186);
			this.ResumeLayout(false);

		}
		#endregion

		private void cboSearch_KeyPress(object sender, System.Windows.Forms.KeyPressEventArgs e)
		{
			if (e.KeyChar == (char) 13)
			{
				Find();
				if (SearchHistory.BinarySearch(cboSearch.Text)< 0)
				{
					SearchHistory.Insert(0, cboSearch.Text);
					cboSearch.DataSource = null;
					cboSearch.DataSource = SearchHistory;
				}
			}
		}

		private void lvwResults_DoubleClick(object sender, System.EventArgs e)
		{
			Point pt = lvwResults.PointToClient(MousePosition);
			ListViewItem x = lvwResults.GetItemAt(pt.X, pt.Y);
			if (x!=null)
				CSession.SelectCase(Convert.ToInt32(x.SubItems[1].Text));
		}

		private void mnuOpen_Click(object sender, System.EventArgs e)
		{
			CSession.SelectCase(Convert.ToInt32(((ListViewItem)mnuOpen.UserData).SubItems[1].Text));
		}

		private void SetupColumns()
		{
			lvwResults.Columns.Clear();
			lvwResults.Columns.Add("Case", lvwResults.ClientSize.Width,HorizontalAlignment.Left);
		}

		private void Find()
		{
			OleDbCommand cmd = new OleDbCommand("SELECT AccountNumber, Cases.ID as theID FROM Cases LEFT OUTER JOIN People ON Cases.ID = People.CaseID  WHERE (((People.Surname) Like ?)) or (((Cases.PropertyPostCode) Like ?)) OR (((Cases.PropertyAddress) Like ?))");
			cmd.Parameters.Add(CUtil.NewParam("search1",OleDbType.VarWChar, "%" + cboSearch.Text + "%"));
			cmd.Parameters.Add(CUtil.NewParam("search2",OleDbType.VarWChar, "%" + cboSearch.Text + "%"));
			cmd.Parameters.Add(CUtil.NewParam("search3",OleDbType.VarWChar, "%" + cboSearch.Text + "%"));

			cmd.Connection = cMyDB.NewConnection();
			cmd.Connection.Open();
			OleDbDataReader Results = cmd.ExecuteReader(CommandBehavior.CloseConnection);

			lvwResults.Items.Clear();
			while (Results.Read())
			{
				ListViewItem temp = lvwResults.Items.Add(Results.GetString(0));
				temp.SubItems.Add(Convert.ToString(Results.GetInt32(1)));
			}
			Results.Close();
			cmd.Dispose();
		}

		private void lvwResults_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if (e.Button == MouseButtons.Right)
			{
				ListViewItem x = lvwResults.GetItemAt(e.X, e.Y);
				if (x!=null)
				{
					mnuOpen.UserData = x;
					pm.TrackPopup(lvwResults.PointToScreen(new Point(e.X, e.Y)));
				}
			}
		}

		private void lvwResults_Resize(object sender, System.EventArgs e)
		{
			if (lvwResults.Columns.Count > 0)
				lvwResults.Columns[0].Width = lvwResults.ClientSize.Width;
		}

		private void lvwResults_DoubleClick_1(object sender, System.EventArgs e)
		{
			Point pt = lvwResults.PointToClient(MousePosition);
			ListViewItem x = lvwResults.GetItemAt(pt.X, pt.Y);
			if (x!=null)
				CSession.SelectCase(Convert.ToInt32(x.SubItems[1].Text));
		}
	}
}
