using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for InvestmentAccountListManager.
	/// </summary>
	public class InvestmentAccountListManager : OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmInvestmentAccounts();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select AccountNumber, Balance, Closed, ID From InvestmentAccounts Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp = new System.Windows.Forms.ListViewItem();
				temp.Text = (dr["AccountNumber"] + String.Empty);
				
				if (!dr["Balance"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["Balance"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				if (!dr["Closed"].Equals(DBNull.Value))
					temp.SubItems.Add(((DateTime)dr["Closed"]).ToShortDateString() + "");
				else
					temp.SubItems.Add(String.Empty);
				temp.Tag = dr["ID"];
				lvw.Items.Add(temp);
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Account Number", lvw.ClientSize.Width / 3, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Balance",lvw.ClientSize.Width / 3, System.Windows.Forms.HorizontalAlignment.Right);
			lvw.Columns.Add("Closed",lvw.ClientSize.Width / 3, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
			{
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(1,UtilityLibrary.WinControls.SortedListViewFormatType.Currency);
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(2,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
			}
		}
	}
}
