using System;
using System.Data.OleDb;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for OtherNodeCollection.
	/// </summary>
	public class OtherNodeArray
	{
		public OtherNode[] OtherNodes;

		public OtherNodeArray(OtherNode[] nodes)
		{
			OtherNodes = nodes;
		}
		public void UpdateNodes()
		{
			UpdateNodes(CSession.CaseID);
		}
		public void UpdateNodes(Int32 CaseID)
		{
			OleDbCommand cmd = new OleDbCommand();				
			cmd.Parameters.Add("ID",OleDbType.Integer);
			cmd.Parameters["ID"].Value = CaseID;
			cmd.Connection = cMyDB.NewConnection();
			cmd.Connection.Open();
			
			OtherNodes[0].TreeView.BeginUpdate();

			foreach(OtherNode n in OtherNodes)
			{
				UpdateNodeText(n, cmd);
			}

			OtherNodes[0].TreeView.EndUpdate();

			cmd.Connection.Dispose();
			cmd.Dispose();
		}
		public void UpdateNodeText(OtherNode n, Int32 CaseID)
		{
			OleDbCommand cmd = new OleDbCommand();
			cmd.Parameters.Add("ID",OleDbType.Integer);
			cmd.Parameters["ID"].Value = CaseID;
			cmd.Connection = cMyDB.NewConnection();
			cmd.Connection.Open();
		
			UpdateNodeText(n, cmd);
			if (n.Parent is OtherNode)
			{
				UpdateNodeText((OtherNode) n.Parent, cmd);
			}
			
			cmd.Connection.Dispose();
			cmd.Dispose();
		}
		public void UpdateNodeText(OtherNode n, OleDbCommand cmd)
		{
			if (n.Nodes.Count > 0)
			{
				n.Total = 0;
				foreach (OtherNode subN in n.Nodes)
				{
					UpdateNodeText(subN, cmd);
					n.Total += subN.Total;
				}
			}
			else
			{
				cmd.CommandText = n.SQL;
				n.Total = (Int32)cmd.ExecuteScalar();
			}
			if (n.Total > 0)
			{
				n.Text = n.InitialText + " (" + n.Total.ToString() + ")";
			}
			else
			{
				n.Text = n.InitialText;
			}
		}

	}
}
