using System;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for PaymentAgreementListManager.
	/// </summary>
	public class PaymentAgreementListManager : OtherListManager
	{
		protected override DebtManagerTest.DebtBaseForm getNewForm()
		{
			return new frmPaymentAgreements();
		}

		public override void FillList(System.Windows.Forms.ListView lvw, Int32 CaseID)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			DataTable dt = cMyDB.GetDataTable("Select EffectiveDate, AmountToPay, LastChecked, LastPaymentID, ID From PaymentAgreements Where CaseID = " + CaseID.ToString());
			foreach (DataRow dr in dt.Rows)
			{
				System.Windows.Forms.ListViewItem temp = new System.Windows.Forms.ListViewItem();
				if (!dr["EffectiveDate"].Equals(DBNull.Value))
					temp.Text = ((DateTime)dr["EffectiveDate"]).ToShortDateString() + "";
				else
					temp.Text = String.Empty;
				if (!dr["AmountToPay"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["AmountToPay"]).ToString("c"));
				else
					temp.SubItems.Add(String.Empty);
				if (!dr["LastChecked"].Equals(DBNull.Value))
					temp.SubItems.Add(((DateTime)dr["LastChecked"]).ToShortDateString() + "");
				else
					temp.SubItems.Add(String.Empty);
				temp.SubItems.Add(dr["LastPaymentID"].ToString());
				temp.Tag = dr["ID"];
				lvw.Items.Add(temp);
			}
			dt.Dispose();
			lvw.EndUpdate();
		}

		public override void SetupColums(System.Windows.Forms.ListView lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Agreement Date",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("Amount to Pay",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Right);
			lvw.Columns.Add("First Payment",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Left);
			lvw.Columns.Add("No of Payments",lvw.ClientSize.Width / 4, System.Windows.Forms.HorizontalAlignment.Right);
			if (lvw is UtilityLibrary.WinControls.ListViewEx)
			{
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(0,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(1,UtilityLibrary.WinControls.SortedListViewFormatType.Currency);
				((UtilityLibrary.WinControls.ListViewEx)lvw).SetColumnSortFormat(2,UtilityLibrary.WinControls.SortedListViewFormatType.Date);
			}
		}
	}
}
