VERSION 5.00
Begin VB.UserControl HSplit 
   ClientHeight    =   900
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   3720
   MousePointer    =   7  'Size N S
   ScaleHeight     =   900
   ScaleWidth      =   3720
   ToolboxBitmap   =   "HSplit.ctx":0000
   Begin VB.Image imgSlider 
      Appearance      =   0  'Flat
      Height          =   135
      Left            =   90
      Top             =   435
      Width           =   3390
   End
   Begin VB.Shape sFace 
      BackColor       =   &H8000000F&
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   3690
      Left            =   975
      Top             =   75
      Width           =   135
   End
   Begin VB.Shape sLight 
      BackColor       =   &H8000000F&
      BorderColor     =   &H80000014&
      Height          =   120
      Left            =   45
      Top             =   375
      Width           =   3495
   End
   Begin VB.Shape sDark 
      BorderColor     =   &H80000010&
      Height          =   150
      Left            =   90
      Top             =   270
      Width           =   3435
   End
End
Attribute VB_Name = "HSplit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'local variable(s) to hold property value(s)
Private mHostPane As Object 'local copy
Private mTopPane As Object 'local copy
Private mBottomPane As Object 'local copy
Private mSplitOn As Boolean 'local copy
Private mComplex As Boolean
Private mControlHeight As Long
Private mMinimumTop As Long
Private mMinimumBottom As Long
Private mSliderTop As Long
Private FirstRunThrough As Boolean

Event SliderMoved()
Event SliderMoveComplete()
Event SliderMoveStarted()

Public Property Set BottomPane(ByVal vData As Object)
    '
    Set mBottomPane = vData
    '
End Property

Public Property Get BottomPane() As Object
    '
    Set BottomPane = mBottomPane
    '
End Property

Public Property Set TopPane(ByVal vData As Object)
    '
    Set mTopPane = vData
    '
End Property

Public Property Get TopPane() As Object
    '
    Set TopPane = mTopPane
    '
End Property

Public Property Set HostPane(ByVal vData As Object)
    '
    Set mHostPane = vData
    '
End Property

Public Property Get HostPane() As Object
    '
    Set HostPane = mHostPane
    '
End Property

Public Property Let SplitOn(ByVal vData As Boolean)
    '
    mSplitOn = vData
    '
End Property

Public Property Get SplitOn() As Boolean
    '
    SplitOn = mSplitOn
    '
End Property

Public Property Let Complex(ByVal vData As Boolean)
    '
    mComplex = vData
    PropertyChanged "Complex"
    '
End Property

Public Property Get Complex() As Boolean
    '
    Complex = mComplex
    '
End Property

Public Property Let ControlHeight(ByVal vData As Long)
    '
    mControlHeight = vData
    PropertyChanged "ControlHeight"
    '
End Property

Public Property Get ControlHeight() As Long
    '
    ControlHeight = mControlHeight
    '
End Property

Public Property Let MinimumTop(ByVal vData As Long)
    '
    mMinimumTop = vData
    PropertyChanged "MinimumTop"
    '
End Property

Public Property Get MinimumTop() As Long
    '
    MinimumTop = mMinimumTop
    '
End Property

Public Property Let MinimumBottom(ByVal vData As Long)
    '
    mMinimumBottom = vData
    PropertyChanged "MinimumBottom"
    '
End Property

Public Property Get MinimumBottom() As Long
    '
    MinimumBottom = mMinimumBottom
    '
End Property

Public Property Let SliderTop(ByVal vData As Long)
    '
    mSliderTop = vData
    If Ambient.UserMode Then
        UserControl.Parent(Ambient.DisplayName).Top = mSliderTop
'        ResizePanes
    End If
    PropertyChanged "SliderTop"
    '
End Property

Public Property Get SliderTop() As Long
    '
    If Ambient.UserMode Then
        SliderTop = UserControl.Parent(Ambient.DisplayName).Top
        mSliderTop = SliderTop
    Else
        SliderTop = mSliderTop
    End If
    '
End Property

Public Sub ResizePanes(Optional Twips As Single)
    '
    On Error GoTo LocalErr
    Dim TempTop As Long, NewTop As Long
    '
    If IsMissing(Twips) Then
        Twips = 0
    End If
    '
    With mHostPane
        If .ScaleHeight < (MinimumTop + MinimumBottom + ControlHeight) Then
            NewTop = (.ScaleHeight - ControlHeight) / 2
        Else
            TempTop = SliderTop + Twips
            If TempTop < MinimumTop Then
                NewTop = MinimumTop
            ElseIf (.ScaleHeight - TempTop - ControlHeight) < MinimumBottom Then
                NewTop = (.ScaleHeight - MinimumBottom - ControlHeight)
            Else
                NewTop = TempTop
            End If
        End If
    End With
    
    With UserControl.Parent(Ambient.DisplayName)
        .Top = NewTop
        If Not Complex Then
            .Left = 0
            .Width = mHostPane.ScaleWidth
        End If
        .Height = ControlHeight
    End With
    '
    With mTopPane
        If Not Complex Then
            .Left = 0
            .Width = mHostPane.ScaleWidth
        End If
        .Top = 0
        .Height = NewTop
    End With
    '
    With mBottomPane
        If Not Complex Then
            .Left = 0
            .Width = mHostPane.ScaleWidth
        End If
        .Top = NewTop + ControlHeight
        .Height = mHostPane.ScaleHeight - (mTopPane.Height + ControlHeight)
    End With
    '
    SliderTop = NewTop
    'If SplitOn Then RaiseEvent SliderMoved
        
    Exit Sub
    '
LocalErr:
    Debug.Print Err.Number, Err.Description
    Exit Sub
End Sub

Private Sub UserControl_Initialize()
    SplitOn = False
End Sub

Private Sub UserControl_InitProperties()
    mComplex = False
    mControlHeight = 30
    mMinimumTop = 500
    mMinimumBottom = 500
    mSliderTop = 2000
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    mControlHeight = PropBag.ReadProperty("ControlHeight", 30)
    mComplex = PropBag.ReadProperty("Complex", False)
    mMinimumTop = PropBag.ReadProperty("MinimumTop", 500)
    mMinimumBottom = PropBag.ReadProperty("MinimumBottom", 500)
    SliderTop = PropBag.ReadProperty("SliderTop", 2000)
    FirstRunThrough = True
End Sub

Private Sub UserControl_Resize()
On Error GoTo Rz_Err
    ScaleMode = vbPixels
    sLight.Left = 0
    sLight.Top = 0
    sLight.Width = ScaleWidth - 1
    sLight.Height = ScaleHeight - 1
    sDark.Left = 0
    sDark.Top = 0
    sDark.Width = ScaleWidth
    sDark.Height = ScaleHeight
    sFace.Left = 0 '1
    sFace.Top = 1
    sFace.Width = ScaleWidth + 1 '- 1
    sFace.Height = ScaleHeight - 1
    imgSlider.Left = 0
    imgSlider.Top = 0
    imgSlider.Width = ScaleWidth
    imgSlider.Height = ScaleHeight
    
    If FirstRunThrough Then
        If Ambient.UserMode Then
            SliderTop = mSliderTop
'            ResizePanes
        End If
        FirstRunThrough = False
    End If
Rz_End:
    Exit Sub
Rz_Err:
    Debug.Print Err.Number, Err.Description
    GoTo Rz_End
End Sub

Private Sub imgSlider_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    SetPointer vbSizeWE
    SplitOn = True
    RaiseEvent SliderMoveStarted
    '
End Sub

Private Sub imgSlider_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    SetPointer vbSizeWE
    '
    If SplitOn = True Then
        'ResizePanes Y
        RaiseEvent SliderMoved
    End If
    '
End Sub

Private Sub imgSlider_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    spVSet.SetPointer vbNormal
    '
    If SplitOn = True Then
        ResizePanes Y
        SplitOn = False
        RaiseEvent SliderMoveComplete
    End If
    '
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "ControlHeight", mControlHeight, 30
    PropBag.WriteProperty "Complex", mComplex, False
    PropBag.WriteProperty "MinimumTop", mMinimumTop, 500
    PropBag.WriteProperty "MinimumBottom", mMinimumBottom, 500
    PropBag.WriteProperty "SliderTop", mSliderTop, 2000
End Sub

Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
    Dim x As New frmAbout
    x.Show vbModal
    Unload x
    Set x = Nothing
End Sub
