VERSION 5.00
Begin VB.UserControl VSplit 
   ClientHeight    =   4155
   ClientLeft      =   0
   ClientTop       =   0
   ClientWidth     =   735
   MousePointer    =   9  'Size W E
   ScaleHeight     =   4155
   ScaleWidth      =   735
   ToolboxBitmap   =   "VSplit.ctx":0000
   Begin VB.Image imgSlider 
      Appearance      =   0  'Flat
      Height          =   3615
      Left            =   510
      Top             =   180
      Width           =   75
   End
   Begin VB.Shape sFace 
      BackColor       =   &H8000000F&
      BackStyle       =   1  'Opaque
      BorderStyle     =   0  'Transparent
      Height          =   3825
      Left            =   90
      Top             =   210
      Width           =   90
   End
   Begin VB.Shape sLight 
      BackColor       =   &H8000000F&
      BorderColor     =   &H80000014&
      Height          =   3480
      Left            =   270
      Top             =   120
      Width           =   120
   End
   Begin VB.Shape sDark 
      BorderColor     =   &H80000010&
      Height          =   3495
      Left            =   195
      Top             =   180
      Width           =   135
   End
End
Attribute VB_Name = "VSplit"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
Option Explicit

'local variable(s) to hold property value(s)
Private mHostPane As Object 'local copy
Private mLeftPane As Object 'local copy
Private mRightPane As Object 'local copy
Private mSplitOn As Boolean 'local copy
Private mComplex As Boolean
Private mControlWidth As Long
Private mMinimumLeft As Long
Private mMinimumRight As Long
Private mSliderLeft As Long
Private FirstRunThrough As Boolean

Event SliderMoved()
Event SliderMoveComplete()
Event SliderMoveStarted()

Sub ShowAboutBox()
Attribute ShowAboutBox.VB_UserMemId = -552
    Dim x As New frmAbout
    x.Show vbModal
    Unload x
    Set x = Nothing
End Sub

Public Property Set RightPane(ByVal vData As Object)
    '
    Set mRightPane = vData
    '
End Property

Public Property Get RightPane() As Object
    '
    Set RightPane = mRightPane
    '
End Property

Public Property Set LeftPane(ByVal vData As Object)
    '
    Set mLeftPane = vData
    '
End Property

Public Property Get LeftPane() As Object
    '
    Set LeftPane = mLeftPane
    '
End Property

Public Property Set HostPane(ByVal vData As Object)
    '
    Set mHostPane = vData
    '
End Property

Public Property Get HostPane() As Object
    '
    Set HostPane = mHostPane
    '
End Property

Public Property Let SplitOn(ByVal vData As Boolean)
    '
    mSplitOn = vData
    '
End Property

Public Property Get SplitOn() As Boolean
    '
    SplitOn = mSplitOn
    '
End Property

Public Property Let Complex(ByVal vData As Boolean)
    '
    mComplex = vData
    PropertyChanged "Complex"
    '
End Property

Public Property Get Complex() As Boolean
    '
    Complex = mComplex
    '
End Property

Public Property Let ControlWidth(ByVal vData As Long)
    '
    mControlWidth = vData
    PropertyChanged "ControlWidth"
    '
End Property

Public Property Get ControlWidth() As Long
    '
    ControlWidth = mControlWidth
    '
End Property

Public Property Let MinimumLeft(ByVal vData As Long)
    '
    mMinimumLeft = vData
    PropertyChanged "MinimumLeft"
    '
End Property

Public Property Get MinimumLeft() As Long
    '
    MinimumLeft = mMinimumLeft
    '
End Property

Public Property Let MinimumRight(ByVal vData As Long)
    '
    mMinimumRight = vData
    PropertyChanged "MinimumRight"
    '
End Property

Public Property Get MinimumRight() As Long
    '
    MinimumRight = mMinimumRight
    '
End Property

Public Property Let SliderLeft(ByVal vData As Long)
    '
    mSliderLeft = vData
    If Ambient.UserMode Then
        UserControl.Parent(Ambient.DisplayName).Left = mSliderLeft
'        ResizePanes
    End If
    PropertyChanged "SliderLeft"
    '
End Property

Public Property Get SliderLeft() As Long
    '
    If Ambient.UserMode Then
        SliderLeft = UserControl.Parent(Ambient.DisplayName).Left
        mSliderLeft = SliderLeft
    Else
        SliderLeft = mSliderLeft
    End If
    '
End Property

Public Sub ResizePanes(Optional Twips As Single)
    '
    On Error GoTo LocalErr
    Dim TempLeft As Long, NewLeft As Long
    '
    If IsMissing(Twips) Then
        Twips = 0
    End If
    '
    If mHostPane.ScaleHeight = 0 Then Exit Sub
    If mHostPane.ScaleWidth = 0 Then Exit Sub
    
    With mHostPane
        If .ScaleWidth < (MinimumLeft + MinimumRight + ControlWidth) Then
            NewLeft = (.ScaleWidth - ControlWidth) / 2
        Else
            TempLeft = SliderLeft + Twips
            If TempLeft < MinimumLeft Then
                NewLeft = MinimumLeft
            ElseIf (.ScaleWidth - TempLeft - ControlWidth) < MinimumRight Then
                NewLeft = (.ScaleWidth - MinimumRight - ControlWidth)
            Else
                NewLeft = TempLeft
            End If
        End If
    End With
    
    With UserControl.Parent(Ambient.DisplayName)
        .Left = NewLeft
        If Not Complex Then
            .Top = 0
            .Height = mHostPane.ScaleHeight
        End If
        .Width = ControlWidth
    End With
    '
    With mLeftPane
        If Not Complex Then
            .Top = 0
            .Height = mHostPane.ScaleHeight
        End If
        .Left = 0
        .Width = NewLeft
    End With
    '
    With mRightPane
        If Not Complex Then
            .Top = 0
            .Height = mHostPane.ScaleHeight
        End If
        .Left = NewLeft + ControlWidth
        .Width = mHostPane.ScaleWidth - (mLeftPane.Width + ControlWidth)
    End With
    '
    SliderLeft = NewLeft
    'If SplitOn Then RaiseEvent SliderMoved(Twips)
        
    Exit Sub
    '
LocalErr:
    Debug.Print Err.Number, Err.Description
    Exit Sub
End Sub

Public Sub PreviewResize(Optional Twips As Single)
    '
    On Error GoTo LocalErr
    Dim TempLeft As Long, NewLeft As Long
    '
    If IsMissing(Twips) Then
        Twips = 0
    End If
    '
    If mHostPane.ScaleHeight = 0 Then Exit Sub
    If mHostPane.ScaleWidth = 0 Then Exit Sub

    With mHostPane
        If .ScaleWidth < (MinimumLeft + MinimumRight + ControlWidth) Then
            NewLeft = (.ScaleWidth - ControlWidth) / 2
        Else
            TempLeft = SliderLeft + Twips
            If TempLeft < MinimumLeft Then
                NewLeft = MinimumLeft
            ElseIf (.ScaleWidth - TempLeft - ControlWidth) < MinimumRight Then
                NewLeft = (.ScaleWidth - MinimumRight - ControlWidth)
            Else
                NewLeft = TempLeft
            End If
        End If
    End With

    '
    'SliderLeft = NewLeft
    'If SplitOn Then RaiseEvent SliderMoved(x)

    Exit Sub
    '
LocalErr:
    Debug.Print Err.Number, Err.Description
    Exit Sub
End Sub

Private Sub UserControl_Initialize()
    SplitOn = False
End Sub

Private Sub UserControl_InitProperties()
    mComplex = False
    mControlWidth = 30
    mMinimumLeft = 500
    mMinimumRight = 500
    mSliderLeft = 2000
End Sub

Private Sub UserControl_ReadProperties(PropBag As PropertyBag)
    mControlWidth = PropBag.ReadProperty("ControlWidth", 30)
    mComplex = PropBag.ReadProperty("Complex", False)
    mMinimumLeft = PropBag.ReadProperty("MinimumLeft", 500)
    mMinimumRight = PropBag.ReadProperty("MinimumRight", 500)
    SliderLeft = PropBag.ReadProperty("SliderLeft", 2000)
    FirstRunThrough = True
End Sub

Private Sub UserControl_Resize()
On Error GoTo Rz_Err
    ScaleMode = vbPixels
    sLight.Left = 0
    sLight.Top = 0
    sLight.Width = ScaleWidth - 1
    sLight.Height = ScaleHeight - 1
    sDark.Left = 0
    sDark.Top = 0
    sDark.Width = ScaleWidth
    sDark.Height = ScaleHeight
    sFace.Left = 1
    sFace.Top = 0 '1
    sFace.Width = ScaleWidth - 1
    sFace.Height = ScaleHeight + 1 ' - 1
    imgSlider.Left = 0
    imgSlider.Top = 0
    imgSlider.Width = ScaleWidth
    imgSlider.Height = ScaleHeight
    
    If FirstRunThrough Then
        If Ambient.UserMode Then
            SliderLeft = mSliderLeft
'            ResizePanes
        End If
        FirstRunThrough = False
    End If
Rz_End:
    Exit Sub
Rz_Err:
    Debug.Print Err.Number, Err.Description
    GoTo Rz_End
End Sub

Private Sub imgSlider_MouseDown(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    SetPointer vbSizeWE
    SplitOn = True
    RaiseEvent SliderMoveStarted
    '
End Sub

Private Sub imgSlider_MouseMove(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    SetPointer vbSizeWE
    '
    If SplitOn = True Then
        'PreviewResize x
        RaiseEvent SliderMoved
    End If
    '
End Sub

Private Sub imgSlider_MouseUp(Button As Integer, Shift As Integer, x As Single, Y As Single)
    '
'    spVSet.SetPointer vbNormal
    '
    If SplitOn = True Then
        ResizePanes x
        SplitOn = False
        RaiseEvent SliderMoveComplete
    End If
    '
End Sub

Private Sub UserControl_WriteProperties(PropBag As PropertyBag)
    PropBag.WriteProperty "ControlWidth", mControlWidth, 30
    PropBag.WriteProperty "Complex", mComplex, False
    PropBag.WriteProperty "MinimumLeft", mMinimumLeft, 500
    PropBag.WriteProperty "MinimumRight", mMinimumRight, 500
    PropBag.WriteProperty "SliderLeft", mSliderLeft, 2000
End Sub
