using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using UtilityLibrary.CommandBars;
using System.Data;

namespace DebtManagerTest
{
	/// <summary>
	/// Summary description for MainForm.
	/// </summary>
	public class MainForm : System.Windows.Forms.Form
	{
		private Crownwood.Magic.Menus.MenuControl mnuMain;
		private Crownwood.Magic.Menus.MenuCommand mnuFile;
		private System.Windows.Forms.StatusBar sbarMain;
		private System.Windows.Forms.Panel panel1;
		private Crownwood.Magic.Controls.TabControl tabsMenu;
		private System.Windows.Forms.Splitter splitter1;
		private DebtManagerTest.InterfaceComponents.DiaryListView diaryMain;
		private System.Windows.Forms.Splitter splitter2;
		private Crownwood.Magic.Controls.TabControl tabsMain;
		private Crownwood.Magic.Controls.TabPage tabTree;
		private Crownwood.Magic.Controls.TabPage tabFind;
		private DebtManagerTest.InterfaceComponents.FindCase findCase1;
		private Crownwood.Magic.Controls.TabPage tabGeneral;
		private Crownwood.Magic.Controls.TabPage tabAccount;
		private Crownwood.Magic.Controls.TabPage tabPossession;
		private Crownwood.Magic.Controls.TabPage tabOther;
		private Crownwood.Magic.Controls.TabPage tabJournal;
		private DebtManagerTest.InterfaceComponents.CaseTreeViewEx tvwIndex;
		private System.Windows.Forms.ImageList imgsToolbar;
		private UtilityLibrary.CommandBars.ToolBarEx tbarMain;
		private Crownwood.Magic.Controls.TabPage tabBorrowers;
		private Crownwood.Magic.Controls.TabPage tabGuaruntors;
		private Crownwood.Magic.Controls.TabPage tabTenants;
		private UtilityLibrary.WinControls.ListViewEx lvwBorrowers;
		private UtilityLibrary.WinControls.ListViewEx lvwGuaruntors;
		private UtilityLibrary.WinControls.ListViewEx lvwTenants;
		private System.Windows.Forms.Panel panel2;
		private System.Windows.Forms.TreeView tvwOther;
		private System.Windows.Forms.Splitter splitter3;
		private System.Windows.Forms.Panel panel3;
		private System.Windows.Forms.Label label1;
		private UtilityLibrary.WinControls.ListViewEx lvwOther;
		private System.Windows.Forms.TextBox txtNotes;
		private System.Windows.Forms.Splitter splitter4;
		private DebtManagerTest.InterfaceComponents.DiaryListView diaryCase;
		private Crownwood.Magic.Controls.TabControl tabsGeneral;
		private System.Data.OleDb.OleDbDataAdapter daCases;
		private System.Data.OleDb.OleDbCommand cmdDeleteCases;
		private System.Data.OleDb.OleDbCommand cmdSelectCases;
		private System.Data.OleDb.OleDbCommand cmdInsertCases;
		private System.Data.OleDb.OleDbCommand cmdUpdateCases;
		private DebtManagerTest.dsCases dsCases1;
		private System.Data.OleDb.OleDbDataAdapter daPersonLists;
		private Crownwood.Magic.Menus.MenuCommand mnuDelete;
		private Crownwood.Magic.Menus.MenuCommand mnuEdit;
		private Crownwood.Magic.Menus.MenuCommand mnuAdd;
		private Crownwood.Magic.Menus.MenuCommand mnuRefresh;
		private Crownwood.Magic.Menus.PopupMenu pm;
		private System.Data.OleDb.OleDbCommand oleDbSelectCommand1;
		private System.Windows.Forms.StatusBarPanel sbarPanel1;
		private System.Windows.Forms.StatusBarPanel sbarPanel2;
		private System.Windows.Forms.Panel panel4;
		private System.Windows.Forms.DateTimePicker dtpLastContact;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboPropertyType;
		private System.Windows.Forms.TextBox txtTelephoneNo;
		private System.Windows.Forms.TextBox txtPostCode;
		private System.Windows.Forms.TextBox txtPropertyAddress;
		private System.Windows.Forms.TextBox txtSalutation;
		private System.Windows.Forms.TextBox txtTitle;
		private System.Windows.Forms.TextBox txtAcc;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label9;
		private System.Windows.Forms.Label label8;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label5;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboBranch;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label3;
		private System.Windows.Forms.Label label2;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label12;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label16;
		private System.Windows.Forms.Label label17;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.Label lblDegreeDate;
		private System.Windows.Forms.Label lblBalanceDate;
		private System.Windows.Forms.CheckBox chkSharedOwnership;
		private System.Windows.Forms.Label lblHousingAssociation;
		private System.Windows.Forms.Label lblShare;
		private System.Windows.Forms.TextBox txtShare;
		private System.Windows.Forms.Label lblPaymentDate;
		private DebtManagerTest.InterfaceComponents.CompanyLookup cboHousingAssociation;
		private System.Windows.Forms.CheckBox chkDSS;
		private System.Windows.Forms.Label lblDSS;
		private System.Windows.Forms.TextBox txtDSS;
		private System.Windows.Forms.TextBox txtAmountofArrears;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboCauseOfArrears;
		private System.Windows.Forms.CheckBox chkBancruptcy;
		private System.Windows.Forms.CheckBox chkOtherDebts;
		private System.Windows.Forms.CheckBox chkEarlyRepayment;
		private System.Windows.Forms.CheckBox chkPaymentProtection;
		private System.Windows.Forms.TextBox txtPercentageAdvance;
		private UtilityLibrary.WinControls.ListViewEx lvwAccounts;
		private UtilityLibrary.WinControls.ButtonEx cmdDegreeHistory;
		private UtilityLibrary.WinControls.ButtonEx cmdBalanceHistory;
		private UtilityLibrary.WinControls.ButtonEx cmdPaymentHistory;
		private System.Windows.Forms.Label lblPossessionDate;
		private System.Windows.Forms.DateTimePicker dtpPossessionDate;
		private System.Windows.Forms.Label lblEstateAgent;
		private DebtManagerTest.InterfaceComponents.CompanyLookup cboEstateAgent;
		private System.Windows.Forms.DateTimePicker dtpDateInstructed;
		private System.Windows.Forms.DateTimePicker dtpDateMarketed;
		private System.Windows.Forms.Label lblDateInstructed;
		private System.Windows.Forms.Label lblDateMarketed;
		private System.Windows.Forms.Label lblMarketPriceAsAt;
		private UtilityLibrary.WinControls.ButtonEx cmdMarketPriceHistory;
		private System.Windows.Forms.CheckBox chkIndemnityInsurance;
		private DebtManagerTest.InterfaceComponents.CompanyLookup cboIndemnityCompany;
		private System.Windows.Forms.Label lblIndemnityCompany;
		private System.Windows.Forms.Label lblIndemnityAmount;
		private System.Windows.Forms.TextBox txtIndemnityAmount;
		private System.Windows.Forms.Label lblIndemnityPayout;
		private System.Windows.Forms.TextBox txtIndemnityPayout;
		private System.Windows.Forms.Label lblPayoutDate;
		private System.Windows.Forms.DateTimePicker dtpPayoutDate;
		private System.Windows.Forms.Label lblDateSold;
		private System.Windows.Forms.TextBox txtSalePrice;
		private System.Windows.Forms.DateTimePicker dtpDateSold;
		private System.Windows.Forms.Label lblSalePrice;
		private System.Windows.Forms.Label lblDebtOnSale;
		private System.Windows.Forms.TextBox txtDebtOnSale;
		private System.Windows.Forms.Label lblDeferredInterest;
		private System.Windows.Forms.TextBox txtDeferredInterest;
		private System.Windows.Forms.Label lblLossProvision;
		private System.Windows.Forms.TextBox txtLossProvision;
		private System.Windows.Forms.Label lblWrittenOff;
		private System.Windows.Forms.TextBox txtWrittenOff;
		private System.Windows.Forms.Label lblMarketPriceDate;
		private System.Windows.Forms.Label lblIndemnityClaimed;
		private System.Windows.Forms.TextBox txtIndemnityClaimed;
		private System.Windows.Forms.Label lblIndemnityScheme;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboIndemnityScheme;
		private System.Windows.Forms.Label lblPossessionOrder;
		private DebtManagerTest.LookupComboObjects.LookupCombo cboPossessionOrder;
		private System.Windows.Forms.Label label13;
		private System.Data.OleDb.OleDbCommand cmdSelectAccounts;
		private System.ComponentModel.IContainer components;
		private System.Windows.Forms.ImageList imagesTreeView;
		private OtherNodeArray OtherNodes;
		private System.Threading.Thread otherTreeThread;
		private System.Windows.Forms.CheckBox chkArchived;
		private System.Windows.Forms.Label lblCapitalBalance;
		private System.Windows.Forms.Label lblMarketPriceLabel;
		private System.Windows.Forms.Label lblDegree;
		private System.Windows.Forms.Label lblRegularPayment;
		private System.Windows.Forms.Label lblMarketPrice;
		private Crownwood.Magic.Menus.MenuCommand mnuFileNew;
		private Crownwood.Magic.Menus.MenuCommand mnuFileSave;
		private Crownwood.Magic.Menus.MenuCommand mnuFileClose;
		private Crownwood.Magic.Menus.MenuCommand menuCommand1;
		private Crownwood.Magic.Menus.MenuCommand mnuFileDelete;
		private Crownwood.Magic.Menus.MenuCommand mnuFilePrint;
		private Crownwood.Magic.Menus.MenuCommand menuCommand2;
		private Crownwood.Magic.Menus.MenuCommand mnuFileExit;
		private Crownwood.Magic.Menus.MenuCommand mnuCase;
		private Crownwood.Magic.Menus.MenuCommand mnuAdmin;
		private Crownwood.Magic.Menus.MenuCommand mnuHelp;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseBorrower;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseGuarantor;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseTenant;
		private Crownwood.Magic.Menus.MenuCommand menuCommand3;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseAccount;
		private Crownwood.Magic.Menus.MenuCommand menuCommand4;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseJournal;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseDiary;
		private Crownwood.Magic.Menus.MenuCommand menuCommand5;
		private Crownwood.Magic.Menus.MenuCommand mnuFileAddFav;
		private Crownwood.Magic.Menus.MenuCommand mnuFileDelFav;
		private Crownwood.Magic.Menus.MenuCommand mnuFileArchive;
		private Crownwood.Magic.Menus.MenuCommand menuCommand6;
		private Crownwood.Magic.Menus.MenuCommand mnuFileReactivate;
		private Crownwood.Magic.Menus.MenuCommand menuCommand7;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseLetter;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseValuation;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseOffer;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseHoldCode;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseInvoice;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseExpense;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseEndowment;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseVisit;
		private Crownwood.Magic.Menus.MenuCommand mnuAdminUsers;
		private Crownwood.Magic.Menus.MenuCommand mnuHelpAbout;
		private bool SupressValueEvent = false;
		private System.Data.OleDb.OleDbCommand cmdChangeArchiveStatus;
		static public bool BorrowersChanged = false;
		private bool HoldCaseTransition  = false;
		private Crownwood.Magic.Menus.MenuCommand mnuAdminSettings;
		private Crownwood.Magic.Menus.MenuCommand mnuAdminLetter;
		private Crownwood.Magic.Menus.MenuCommand mnuAdminMailMerge;
		private Crownwood.Magic.Menus.MenuCommand mnuReports;
		private Crownwood.Magic.Menus.MenuCommand mnuReportsMenu;
		private System.Windows.Forms.StatusBarPanel sbarPanel3;
		private Crownwood.Magic.Menus.MenuCommand mnuAdminChangePassword;
		private bool LoadError = false;
		private System.Windows.Forms.DateTimePicker cboIndemnityClaimDate;
		private System.Windows.Forms.Label lblIndemnityClaimDate;
		private System.Windows.Forms.Label label18;
		private Crownwood.Magic.Menus.MenuCommand mnuCaseInvAcc;
		private ArrayList CompanyState;

		[STAThread]
		static void Main() 
		{
			try 
			{	
				CSession.GetConfig();
				cMyDB.Initialise();
				Application.Run(new MainForm());
			}
			catch (Exception e)
			{
				MessageBox.Show("Cannot Continue : " + e.Message,"System Error");
			}
		}		

		public MainForm()
		{
			//
			// Required for Windows Form Designer support
			//
			this.Load += new System.EventHandler(this.MainForm_Load);
			try
			{
				InitializeComponent();
			}
			catch
			{
				LoadError = true;
				return;
			}
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			this.tabGeneral.BindingContext = this.BindingContext;
			this.tabGeneral.Selected = true;
			this.tabAccount.BindingContext = this.BindingContext;
			this.tabPossession.BindingContext = this.BindingContext;
			this.tabOther.BindingContext = this.BindingContext;
			this.tabJournal.BindingContext = this.BindingContext;
			this.daPersonLists.SelectCommand.Connection = cMyDB.NewConnection();
			this.daCases.SelectCommand.Connection = this.daPersonLists.SelectCommand.Connection;
			this.daCases.UpdateCommand.Connection = this.daPersonLists.SelectCommand.Connection;
			this.daCases.InsertCommand.Connection = this.daPersonLists.SelectCommand.Connection;
			this.daCases.DeleteCommand.Connection = this.daPersonLists.SelectCommand.Connection;
			SetupCurrencyBindings();
			SetupToolbars();
			SetupMenus();
			SetupListViews();
			SetupDateBindings();

			this.sbarPanel3.Text = CSession.User.Username.ToUpper();			

			this.tvwIndex.FillDefaultDebtTree();
			this.diaryMain.GetData();
			this.diaryCase.GetData();
			FillOtherTree();
			CSession.CaseSelected += new CaseEventHandler(on_CaseSelected);

			CompanyState = cMyDB.GetFirstRow("Select Count(*) as cnt, Max(LastUpdated) as maxDate from Companies");
		}

		private void on_CaseSelected(object sender, CaseEventArgs e)
		{
			if (!HoldCaseTransition)
			{
				SupressValueEvent = true;
				if(!CloseCase())
				{
					HoldCaseTransition = true;
					tvwIndex.ShowCase(dsCases1.Cases[0].ID);
					HoldCaseTransition = false;
					return;
				}
				OpenCase(e.CaseID);
				SupressValueEvent = false;
			}
		}

		private void OpenCase(Int32 CaseID)
		{
			daCases.SelectCommand.Parameters["ID"].Value = CaseID;
			daCases.Fill(dsCases1, "Cases");
			if (dsCases1.Cases.Rows.Count> 0)
			{
				FillListViews();
				
				StartOtherTreeThread();
				lvwOther.Clear();
				tvwOther.SelectedNode = null;

				if (!tabsMain.Visible)
				{
					tabsMain.SelectedTab = tabGeneral;
					tabsMain.Visible = true;
					tabGeneral.Select();
				}
				sbarPanel2.Text = "Last Updated " + dsCases1.Cases.Rows[0]["LastUpdated"].ToString() + " By " + dsCases1.Cases.Rows[0]["LastUser"].ToString();
				SwitchPossessionDate(!dsCases1.Cases.Rows[0]["PossessionDate"].Equals(DBNull.Value));

				ArrayList temp = cMyDB.GetFirstRow("Select Count(*) as cnt, Max(LastUpdated) as maxDate from Companies");
				if (!CompanyState[1].Equals(temp[1]) || !CompanyState[0].Equals(temp[0]))
				{
					RefreshCompanyCombos();
					CompanyState = temp;
				}
			}
			else
			{
				tabsMain.Visible = false;
				sbarPanel2.Text = "No case selected";
			}
		}

		private bool CloseCase()
		{			
			if (!SaveCase(true))
				return false;
			dtpLastContact.Value = DateTime.Today;
			dtpDateInstructed.Value = DateTime.Today;
			dtpDateMarketed.Value = DateTime.Today;
			dtpDateSold.Value = DateTime.Today;
			dtpPayoutDate.Value = DateTime.Today;
			cboIndemnityClaimDate.Value = DateTime.Today;
			this.dtpPossessionDate.Value = DateTime.Today;
			dsCases1.Clear();
			return true;
		}

		private bool SaveCase(bool closing)
		{
			if (dsCases1.Cases.Rows.Count > 0)
			{
				bool RefreshTree = false;

				this.BindingContext[dsCases1, "Cases"].EndCurrentEdit();

				if(!dsCases1.Cases.Rows[0]["AccountNumber", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["AccountNumber", DataRowVersion.Original]))
					RefreshTree = true;
				if(!dsCases1.Cases.Rows[0]["PropertyPostCode", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["PropertyPostCode", DataRowVersion.Original]))
					RefreshTree = true;
				if(!dsCases1.Cases.Rows[0]["PropertyAddress", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["PropertyAddress", DataRowVersion.Original]))
					RefreshTree = true;
				if(!dsCases1.Cases.Rows[0]["PossessionDate", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["PossessionDate", DataRowVersion.Original]))
					RefreshTree = true;
				if(!dsCases1.Cases.Rows[0]["Archived", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["Archived", DataRowVersion.Original]))
					RefreshTree = true;
				if(!dsCases1.Cases.Rows[0]["Degree", DataRowVersion.Current].Equals(dsCases1.Cases.Rows[0]["Degree", DataRowVersion.Original]))
					RefreshTree = true;
				if(BorrowersChanged == true)
					RefreshTree = true;
				BorrowersChanged = false;
				
				bool dataChanged = false;

				for (int x = 0; x < dsCases1.Cases.Columns.Count; x++ )
				{
					if (!dsCases1.Cases.Rows[0][x, DataRowVersion.Original].Equals(dsCases1.Cases.Rows[0][x, DataRowVersion.Current]))
					{
						dataChanged = true;
						break;
					}
				}

				if (dataChanged)
				{
					dsCases1.Cases.Rows[0]["LastUpdated"] = DateTime.Now;
					dsCases1.Cases.Rows[0]["LastUser"] = CSession.User.Username;
					try
					{
						daCases.Update(dsCases1.GetChanges(), "Cases");
					}
					catch
					{
						if (closing)
						{
							if (MessageBox.Show("The current record can not be saved, because of invalid data, or a duplicate account number. Continue (Changes to the current record will be discarded)?","Save Error", MessageBoxButtons.YesNo) == DialogResult.No)
								return false;
						}
						else
						{
							MessageBox.Show("The current record can not be saved, because of invalid data, or a duplicate account number.", "Save Error");
							return false;
						}
					}
				}

				if (RefreshTree)
				{
					tvwIndex.FillDefaultDebtTree();
					HoldCaseTransition = true;
					tvwIndex.ShowCase(CSession.CaseID);
					HoldCaseTransition = false;
				}

				if (!closing)
				{
					dsCases1.Clear();
					OpenCase(CSession.CaseID);
				}
			}
			return true;
		}

		private void RefreshCompanyCombos()
		{
			Control temp = this.ActiveControl;
			this.cboEstateAgent.RefreshData();
			this.cboHousingAssociation.RefreshData();
			this.cboIndemnityCompany.RefreshData();
			temp.Focus();
		}

		private void SetupListViews()
		{
			SetupPeopleListViewColumns(lvwBorrowers);
			SetupPeopleListViewColumns(lvwGuaruntors);
			SetupPeopleListViewColumns(lvwTenants);
			SetupAccountListViewColumns(lvwAccounts);
		}
		private void FillListViews()
		{
			FillPeopleListView(lvwBorrowers);
			FillPeopleListView(lvwGuaruntors);
			FillPeopleListView(lvwTenants);
			FillAccountListView(lvwAccounts);
		}
		private void SetupPeopleListViewColumns(UtilityLibrary.WinControls.ListViewEx lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Name",lvw.ClientSize.Width / 3,HorizontalAlignment.Left);
			lvw.Columns.Add("Resident",lvw.ClientSize.Width / 6,HorizontalAlignment.Left);
			lvw.Columns.Add("Telephone Work",lvw.ClientSize.Width / 4,HorizontalAlignment.Left);
			lvw.Columns.Add("Telephone Home",lvw.ClientSize.Width / 4,HorizontalAlignment.Left);
		}
		private void SetupAccountListViewColumns(UtilityLibrary.WinControls.ListViewEx lvw)
		{
			lvw.Columns.Clear();
			lvw.Columns.Add("Type", lvw.ClientSize.Width /4, HorizontalAlignment.Left);
			lvw.Columns.Add("Start Date", lvw.ClientSize.Width /4, HorizontalAlignment.Right);
			lvw.Columns.Add("Maturity Date", lvw.ClientSize.Width /4, HorizontalAlignment.Right);
			lvw.Columns.Add("Advance", lvw.ClientSize.Width /4, HorizontalAlignment.Right);
		}

		private void FillPeopleListView(UtilityLibrary.WinControls.ListViewEx lvw)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			daPersonLists.SelectCommand.Parameters["PersonType"].Value = lvw.Tag.ToString();
			daPersonLists.SelectCommand.Parameters["CaseID"].Value = CSession.CaseID;
			DataTable dt = new DataTable();
			daPersonLists.Fill(dt);
			foreach (DataRow dr in dt.Rows)
			{
				ListViewItem temp = lvw.Items.Add(dr["Title"] + " " + dr["Initials"] + " " + dr["Surname"]);
				if (((bool)dr["AddressAsProperty"]) == true)
					temp.SubItems.Add("Yes");
				else
					temp.SubItems.Add("No");
				temp.SubItems.Add(dr["TelephoneWork"] + "");
				temp.SubItems.Add(dr["TelephoneHome"] + "");
				temp.Tag = dr["ID"];
			}
			dt.Dispose();
			lvw.EndUpdate();
		}
		private void FillAccountListView(UtilityLibrary.WinControls.ListViewEx lvw)
		{
			lvw.BeginUpdate();
			lvw.Items.Clear();
			cmdSelectAccounts.Parameters["CaseID"].Value = CSession.CaseID;
			DataSet ds = cMyDB.GetDataSet(cmdSelectAccounts);
			foreach (DataRow dr in ds.Tables[0].Rows)
			{
				ListViewItem temp = lvw.Items.Add(dr["Type"] + "");
				if (!dr["StartDate"].Equals(DBNull.Value))
					temp.SubItems.Add(((DateTime)dr["StartDate"]).ToShortDateString());
				if (!dr["MaturityDate"].Equals(DBNull.Value))
					temp.SubItems.Add(((DateTime)dr["MaturityDate"]).ToShortDateString());
				if (!dr["AmountAdvanced"].Equals(DBNull.Value))
					temp.SubItems.Add(((decimal)dr["AmountAdvanced"]).ToString("c"));
				temp.Tag = dr["ID"];
			}
			ds.Dispose();
			lvw.EndUpdate();
		}

		private void SetupCurrencyBindings()
		{
			this.lblRegularPayment.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.PaymentAmount"));
			this.txtDSS.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.WeeklyDSS"));
			this.txtAmountofArrears.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.AmountOfArrears"));
			this.txtIndemnityClaimed.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.IndemnityClaimed"));
			this.txtWrittenOff.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.AmountWrittenOff"));
			this.txtLossProvision.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.Provision"));
			this.txtDeferredInterest.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.DeferredInterest"));
			this.txtDebtOnSale.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.DebtOnSale"));
			this.txtSalePrice.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.SalePrice"));
			this.txtIndemnityPayout.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.IndemnityPayout"));
			this.txtIndemnityAmount.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.IndemnityAmount"));
			this.lblMarketPrice.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.MarketPrice"));

			//Percentage Bindings
			this.txtShare.DataBindings.Add(new PercentageBinding("Text", this.dsCases1, "Cases.PercentageShare"));
			this.txtPercentageAdvance.DataBindings.Add(new PercentageBinding("Text", this.dsCases1, "Cases.PercentageAdvance"));
			
			this.lblCapitalBalance.DataBindings.Add(new CurrencyBinding("Text", this.dsCases1, "Cases.CapitalBalance"));
			this.lblBalanceDate.DataBindings.Add(new ShortDateBinding("Text", this.dsCases1, "Cases.CapitalBalanceDate"));
			this.lblMarketPriceDate.DataBindings.Add(new ShortDateBinding("Text", this.dsCases1, "Cases.MarketPriceDate"));
			this.lblDegreeDate.DataBindings.Add(new ShortDateBinding("Text", this.dsCases1, "Cases.DegreeDate"));
			this.lblPaymentDate.DataBindings.Add(new ShortDateBinding("Text", this.dsCases1, "Cases.PaymentAmountDate"));
		}

		private void StartOtherTreeThread()
		{
			//Start another thread to update the tree because it is non critical and
			// time consuming.
			if (otherTreeThread!=null)
			{
				if(otherTreeThread.IsAlive)
				{
					otherTreeThread.Abort();
				}
				otherTreeThread = null;
			}
			otherTreeThread = new System.Threading.Thread(new System.Threading.ThreadStart(OtherNodes.UpdateNodes));
			otherTreeThread.Priority = System.Threading.ThreadPriority.BelowNormal;
			otherTreeThread.Start();
		}

		private void FillOtherTree()
		{
			tvwOther.BeginUpdate();
			if (OtherNodes==null)
			{
				OtherNodes = new OtherNodeArray(new OtherNode[]{	
												new OtherNode("Paperwork", 0,1),
												new OtherNode("Valuations", 0 ,1, "Select Count(ID) From Valuations Where CaseID = ?", new ValuationListManager()),
												new OtherNode("Costs Incurred", 0, 1),
												new OtherNode("Endowment Policies", 0, 1, "Select Count(ID) From EndowmentPolicies Where CaseID = ?", new EndowmentListManager()),
												new OtherNode("Offers",0,1, "Select Count(ID) From Offers Where CaseID = ?", new OfferListManager()),
												new OtherNode("Hold Codes", 0,1, "Select Count(ID) From HoldCodes Where CaseID = ?", new HoldCodeListManager()),
												new OtherNode("Second Charges", 0,1, "Select Count(ID) From SecondCharges Where CaseID = ?", new SecondChargesListManager()),
												new OtherNode("Marketing Reports", 0, 1, "Select Count(ID) From MarketingReports Where CaseID = ?", new MarketingReportListManager()),
												new OtherNode("Site Visits", 0,1, "Select Count(ID) From Visits Where CaseID = ?", new VisitListManager()),
												new OtherNode("Payment Agreements", 0, 1, "Select Count(ID) From PaymentAgreements Where CaseID = ?",new PaymentAgreementListManager()),
												new OtherNode("Investment Accounts", 0, 1, "Select Count(ID) From InvestmentAccounts Where CaseID = ?", new InvestmentAccountListManager()) } );
				OtherNodes.OtherNodes[2].Nodes.AddRange(new OtherNode[] {	new OtherNode("Invoices", 0, 1, "Select Count(ID) From Invoices Where CaseID = ?", new InvoiceListManager()),
																			new OtherNode("Miscellaneous Expenses", 0, 1, "Select Count(ID) From AssociatedCosts Where CaseID = ?", new AssociatedCostListManager()) });
				OtherNodes.OtherNodes[2].Expand();
				OtherNodes.OtherNodes[0].Nodes.AddRange(new OtherNode[] {	new OtherNode("Letters and Memos", 0,1, "Select Count(ID) From Letters Where CaseID = ?", new LetterListManager())} );//,
																			//new OtherNode("Forms", 0,1) 
				OtherNodes.OtherNodes[0].Expand();
				//OtherNodes.OtherNodes[0].Nodes[1].Nodes.Add(new OtherNode("Budget Planners", 0, 1, "Select Count(ID) From BudgetPlanners Where CaseID = ?"));
				
				tvwOther.Nodes.AddRange(OtherNodes.OtherNodes);
			}
			tvwOther.EndUpdate();
		}
		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if(components != null)
				{
					components.Dispose();
				}
				LookupDataManager.CleanUp();
				cMyDB.CleanUp();
				CSession.CleanUp();
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.components = new System.ComponentModel.Container();
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(MainForm));
			this.mnuMain = new Crownwood.Magic.Menus.MenuControl();
			this.mnuFile = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileNew = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileSave = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileClose = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand1 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileArchive = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileReactivate = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileAddFav = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileDelFav = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand5 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileDelete = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand2 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFilePrint = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand6 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuFileExit = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCase = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseBorrower = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseGuarantor = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseTenant = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand3 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseAccount = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseHoldCode = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand4 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseJournal = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseDiary = new Crownwood.Magic.Menus.MenuCommand();
			this.menuCommand7 = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseEndowment = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseInvAcc = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseInvoice = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseLetter = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseExpense = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseOffer = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseVisit = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuCaseValuation = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuReports = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuReportsMenu = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdmin = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdminSettings = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdminUsers = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdminLetter = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdminMailMerge = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdminChangePassword = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuHelp = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuHelpAbout = new Crownwood.Magic.Menus.MenuCommand();
			this.sbarMain = new System.Windows.Forms.StatusBar();
			this.sbarPanel1 = new System.Windows.Forms.StatusBarPanel();
			this.sbarPanel3 = new System.Windows.Forms.StatusBarPanel();
			this.sbarPanel2 = new System.Windows.Forms.StatusBarPanel();
			this.imgsToolbar = new System.Windows.Forms.ImageList(this.components);
			this.panel1 = new System.Windows.Forms.Panel();
			this.diaryMain = new DebtManagerTest.InterfaceComponents.DiaryListView();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.tabsMenu = new Crownwood.Magic.Controls.TabControl();
			this.tabTree = new Crownwood.Magic.Controls.TabPage();
			this.tvwIndex = new DebtManagerTest.InterfaceComponents.CaseTreeViewEx();
			this.tabFind = new Crownwood.Magic.Controls.TabPage();
			this.findCase1 = new DebtManagerTest.InterfaceComponents.FindCase();
			this.splitter2 = new System.Windows.Forms.Splitter();
			this.tabsMain = new Crownwood.Magic.Controls.TabControl();
			this.tabGeneral = new Crownwood.Magic.Controls.TabPage();
			this.panel4 = new System.Windows.Forms.Panel();
			this.dtpLastContact = new System.Windows.Forms.DateTimePicker();
			this.cboPropertyType = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.dsCases1 = new DebtManagerTest.dsCases();
			this.txtTelephoneNo = new System.Windows.Forms.TextBox();
			this.txtPostCode = new System.Windows.Forms.TextBox();
			this.txtPropertyAddress = new System.Windows.Forms.TextBox();
			this.txtSalutation = new System.Windows.Forms.TextBox();
			this.txtTitle = new System.Windows.Forms.TextBox();
			this.txtAcc = new System.Windows.Forms.TextBox();
			this.label10 = new System.Windows.Forms.Label();
			this.label9 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label6 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.cboBranch = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label4 = new System.Windows.Forms.Label();
			this.label3 = new System.Windows.Forms.Label();
			this.label2 = new System.Windows.Forms.Label();
			this.tabsGeneral = new Crownwood.Magic.Controls.TabControl();
			this.tabBorrowers = new Crownwood.Magic.Controls.TabPage();
			this.lvwBorrowers = new UtilityLibrary.WinControls.ListViewEx();
			this.tabGuaruntors = new Crownwood.Magic.Controls.TabPage();
			this.lvwGuaruntors = new UtilityLibrary.WinControls.ListViewEx();
			this.tabTenants = new Crownwood.Magic.Controls.TabPage();
			this.lvwTenants = new UtilityLibrary.WinControls.ListViewEx();
			this.tabAccount = new Crownwood.Magic.Controls.TabPage();
			this.label18 = new System.Windows.Forms.Label();
			this.lblRegularPayment = new System.Windows.Forms.Label();
			this.lblDegree = new System.Windows.Forms.Label();
			this.lblCapitalBalance = new System.Windows.Forms.Label();
			this.cmdPaymentHistory = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdBalanceHistory = new UtilityLibrary.WinControls.ButtonEx();
			this.cmdDegreeHistory = new UtilityLibrary.WinControls.ButtonEx();
			this.lvwAccounts = new UtilityLibrary.WinControls.ListViewEx();
			this.cboHousingAssociation = new DebtManagerTest.InterfaceComponents.CompanyLookup();
			this.lblPaymentDate = new System.Windows.Forms.Label();
			this.label24 = new System.Windows.Forms.Label();
			this.label23 = new System.Windows.Forms.Label();
			this.txtShare = new System.Windows.Forms.TextBox();
			this.lblShare = new System.Windows.Forms.Label();
			this.txtPercentageAdvance = new System.Windows.Forms.TextBox();
			this.label21 = new System.Windows.Forms.Label();
			this.lblHousingAssociation = new System.Windows.Forms.Label();
			this.chkSharedOwnership = new System.Windows.Forms.CheckBox();
			this.txtDSS = new System.Windows.Forms.TextBox();
			this.lblDSS = new System.Windows.Forms.Label();
			this.chkDSS = new System.Windows.Forms.CheckBox();
			this.lblBalanceDate = new System.Windows.Forms.Label();
			this.label17 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.chkPaymentProtection = new System.Windows.Forms.CheckBox();
			this.chkEarlyRepayment = new System.Windows.Forms.CheckBox();
			this.chkOtherDebts = new System.Windows.Forms.CheckBox();
			this.chkBancruptcy = new System.Windows.Forms.CheckBox();
			this.cboCauseOfArrears = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.label15 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.txtAmountofArrears = new System.Windows.Forms.TextBox();
			this.lblDegreeDate = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label11 = new System.Windows.Forms.Label();
			this.tabPossession = new Crownwood.Magic.Controls.TabPage();
			this.lblIndemnityClaimDate = new System.Windows.Forms.Label();
			this.cboIndemnityClaimDate = new System.Windows.Forms.DateTimePicker();
			this.lblMarketPrice = new System.Windows.Forms.Label();
			this.chkArchived = new System.Windows.Forms.CheckBox();
			this.cboPossessionOrder = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.lblPossessionOrder = new System.Windows.Forms.Label();
			this.cboIndemnityScheme = new DebtManagerTest.LookupComboObjects.LookupCombo();
			this.lblIndemnityScheme = new System.Windows.Forms.Label();
			this.txtIndemnityClaimed = new System.Windows.Forms.TextBox();
			this.lblIndemnityClaimed = new System.Windows.Forms.Label();
			this.txtWrittenOff = new System.Windows.Forms.TextBox();
			this.lblWrittenOff = new System.Windows.Forms.Label();
			this.txtLossProvision = new System.Windows.Forms.TextBox();
			this.lblLossProvision = new System.Windows.Forms.Label();
			this.txtDeferredInterest = new System.Windows.Forms.TextBox();
			this.lblDeferredInterest = new System.Windows.Forms.Label();
			this.txtDebtOnSale = new System.Windows.Forms.TextBox();
			this.lblDebtOnSale = new System.Windows.Forms.Label();
			this.lblSalePrice = new System.Windows.Forms.Label();
			this.dtpDateSold = new System.Windows.Forms.DateTimePicker();
			this.txtSalePrice = new System.Windows.Forms.TextBox();
			this.lblDateSold = new System.Windows.Forms.Label();
			this.dtpPayoutDate = new System.Windows.Forms.DateTimePicker();
			this.lblPayoutDate = new System.Windows.Forms.Label();
			this.txtIndemnityPayout = new System.Windows.Forms.TextBox();
			this.lblIndemnityPayout = new System.Windows.Forms.Label();
			this.txtIndemnityAmount = new System.Windows.Forms.TextBox();
			this.lblIndemnityAmount = new System.Windows.Forms.Label();
			this.lblIndemnityCompany = new System.Windows.Forms.Label();
			this.cboIndemnityCompany = new DebtManagerTest.InterfaceComponents.CompanyLookup();
			this.chkIndemnityInsurance = new System.Windows.Forms.CheckBox();
			this.cmdMarketPriceHistory = new UtilityLibrary.WinControls.ButtonEx();
			this.lblMarketPriceDate = new System.Windows.Forms.Label();
			this.lblMarketPriceAsAt = new System.Windows.Forms.Label();
			this.lblMarketPriceLabel = new System.Windows.Forms.Label();
			this.lblDateMarketed = new System.Windows.Forms.Label();
			this.lblDateInstructed = new System.Windows.Forms.Label();
			this.dtpDateMarketed = new System.Windows.Forms.DateTimePicker();
			this.dtpDateInstructed = new System.Windows.Forms.DateTimePicker();
			this.cboEstateAgent = new DebtManagerTest.InterfaceComponents.CompanyLookup();
			this.lblEstateAgent = new System.Windows.Forms.Label();
			this.dtpPossessionDate = new System.Windows.Forms.DateTimePicker();
			this.lblPossessionDate = new System.Windows.Forms.Label();
			this.tabOther = new Crownwood.Magic.Controls.TabPage();
			this.panel2 = new System.Windows.Forms.Panel();
			this.lvwOther = new UtilityLibrary.WinControls.ListViewEx();
			this.splitter3 = new System.Windows.Forms.Splitter();
			this.tvwOther = new System.Windows.Forms.TreeView();
			this.imagesTreeView = new System.Windows.Forms.ImageList(this.components);
			this.tabJournal = new Crownwood.Magic.Controls.TabPage();
			this.panel3 = new System.Windows.Forms.Panel();
			this.diaryCase = new DebtManagerTest.InterfaceComponents.DiaryListView();
			this.splitter4 = new System.Windows.Forms.Splitter();
			this.txtNotes = new System.Windows.Forms.TextBox();
			this.label1 = new System.Windows.Forms.Label();
			this.tbarMain = new UtilityLibrary.CommandBars.ToolBarEx();
			this.daCases = new System.Data.OleDb.OleDbDataAdapter();
			this.cmdDeleteCases = new System.Data.OleDb.OleDbCommand();
			this.cmdInsertCases = new System.Data.OleDb.OleDbCommand();
			this.cmdSelectCases = new System.Data.OleDb.OleDbCommand();
			this.cmdUpdateCases = new System.Data.OleDb.OleDbCommand();
			this.daPersonLists = new System.Data.OleDb.OleDbDataAdapter();
			this.oleDbSelectCommand1 = new System.Data.OleDb.OleDbCommand();
			this.mnuDelete = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuEdit = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuAdd = new Crownwood.Magic.Menus.MenuCommand();
			this.mnuRefresh = new Crownwood.Magic.Menus.MenuCommand();
			this.label13 = new System.Windows.Forms.Label();
			this.cmdSelectAccounts = new System.Data.OleDb.OleDbCommand();
			this.cmdChangeArchiveStatus = new System.Data.OleDb.OleDbCommand();
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel1)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel3)).BeginInit();
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel2)).BeginInit();
			this.panel1.SuspendLayout();
			this.tabsMenu.SuspendLayout();
			this.tabTree.SuspendLayout();
			this.tabFind.SuspendLayout();
			this.tabsMain.SuspendLayout();
			this.tabGeneral.SuspendLayout();
			this.panel4.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.dsCases1)).BeginInit();
			this.tabsGeneral.SuspendLayout();
			this.tabBorrowers.SuspendLayout();
			this.tabGuaruntors.SuspendLayout();
			this.tabTenants.SuspendLayout();
			this.tabAccount.SuspendLayout();
			this.tabPossession.SuspendLayout();
			this.tabOther.SuspendLayout();
			this.panel2.SuspendLayout();
			this.tabJournal.SuspendLayout();
			this.panel3.SuspendLayout();
			this.SuspendLayout();
			// 
			// mnuMain
			// 
			this.mnuMain.BackColor = System.Drawing.SystemColors.Control;
			this.mnuMain.Cursor = System.Windows.Forms.Cursors.Default;
			this.mnuMain.Direction = Crownwood.Magic.Common.Direction.Horizontal;
			this.mnuMain.Dock = System.Windows.Forms.DockStyle.Top;
			this.mnuMain.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.mnuMain.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																						   this.mnuFile,
																						   this.mnuCase,
																						   this.mnuReports,
																						   this.mnuAdmin,
																						   this.mnuHelp});
			this.mnuMain.Name = "mnuMain";
			this.mnuMain.Size = new System.Drawing.Size(741, 25);
			this.mnuMain.Style = Crownwood.Magic.Common.VisualStyle.IDE;
			this.mnuMain.TabIndex = 1;
			this.mnuMain.TabStop = false;
			this.mnuMain.Text = "menuControl1";
			this.mnuMain.PopupStart += new Crownwood.Magic.Menus.CommandHandler(this.mnuMain_PopupStart);
			// 
			// mnuFile
			// 
			this.mnuFile.Description = "MenuItem";
			this.mnuFile.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																						   this.mnuFileNew,
																						   this.mnuFileSave,
																						   this.mnuFileClose,
																						   this.menuCommand1,
																						   this.mnuFileArchive,
																						   this.mnuFileReactivate,
																						   this.mnuFileAddFav,
																						   this.mnuFileDelFav,
																						   this.menuCommand5,
																						   this.mnuFileDelete,
																						   this.menuCommand2,
																						   this.mnuFilePrint,
																						   this.menuCommand6,
																						   this.mnuFileExit});
			this.mnuFile.Text = "&File";
			// 
			// mnuFileNew
			// 
			this.mnuFileNew.Description = "MenuItem";
			this.mnuFileNew.Text = "&New Case";
			this.mnuFileNew.Click += new System.EventHandler(this.mnuFileNew_Click);
			// 
			// mnuFileSave
			// 
			this.mnuFileSave.Description = "MenuItem";
			this.mnuFileSave.Text = "&Save Case";
			this.mnuFileSave.Click += new System.EventHandler(this.mnuFileSave_Click);
			// 
			// mnuFileClose
			// 
			this.mnuFileClose.Description = "MenuItem";
			this.mnuFileClose.Text = "&Close Case";
			this.mnuFileClose.Click += new System.EventHandler(this.mnuFileClose_Click);
			// 
			// menuCommand1
			// 
			this.menuCommand1.Description = "MenuItem";
			this.menuCommand1.Text = "-";
			// 
			// mnuFileArchive
			// 
			this.mnuFileArchive.Description = "MenuItem";
			this.mnuFileArchive.Text = "&Archive Case";
			this.mnuFileArchive.Click += new System.EventHandler(this.mnuFileArchive_Click);
			// 
			// mnuFileReactivate
			// 
			this.mnuFileReactivate.Description = "MenuItem";
			this.mnuFileReactivate.Text = "&Make Active";
			this.mnuFileReactivate.Click += new System.EventHandler(this.mnuFileReactivate_Click);
			// 
			// mnuFileAddFav
			// 
			this.mnuFileAddFav.Description = "MenuItem";
			this.mnuFileAddFav.Text = "Add to &Favourites";
			this.mnuFileAddFav.Click += new System.EventHandler(this.mnuFileAddFav_Click);
			// 
			// mnuFileDelFav
			// 
			this.mnuFileDelFav.Description = "MenuItem";
			this.mnuFileDelFav.Text = "&Delete from Favourites";
			this.mnuFileDelFav.Click += new System.EventHandler(this.mnuFileDelFav_Click);
			// 
			// menuCommand5
			// 
			this.menuCommand5.Description = "MenuItem";
			this.menuCommand5.Text = "-";
			// 
			// mnuFileDelete
			// 
			this.mnuFileDelete.Description = "MenuItem";
			this.mnuFileDelete.Text = "Delete Case";
			this.mnuFileDelete.Click += new System.EventHandler(this.mnuFileDelete_Click);
			// 
			// menuCommand2
			// 
			this.menuCommand2.Description = "MenuItem";
			this.menuCommand2.Text = "-";
			this.menuCommand2.Visible = false;
			// 
			// mnuFilePrint
			// 
			this.mnuFilePrint.Description = "MenuItem";
			this.mnuFilePrint.Text = "&Print Screen";
			this.mnuFilePrint.Visible = false;
			this.mnuFilePrint.Click += new System.EventHandler(this.mnuFilePrint_Click);
			// 
			// menuCommand6
			// 
			this.menuCommand6.Description = "MenuItem";
			this.menuCommand6.Text = "-";
			// 
			// mnuFileExit
			// 
			this.mnuFileExit.Description = "MenuItem";
			this.mnuFileExit.Text = "E&xit System";
			this.mnuFileExit.Click += new System.EventHandler(this.mnuFileExit_Click);
			// 
			// mnuCase
			// 
			this.mnuCase.Description = "MenuItem";
			this.mnuCase.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																						   this.mnuCaseBorrower,
																						   this.mnuCaseGuarantor,
																						   this.mnuCaseTenant,
																						   this.menuCommand3,
																						   this.mnuCaseAccount,
																						   this.mnuCaseHoldCode,
																						   this.menuCommand4,
																						   this.mnuCaseJournal,
																						   this.mnuCaseDiary,
																						   this.menuCommand7,
																						   this.mnuCaseEndowment,
																						   this.mnuCaseInvAcc,
																						   this.mnuCaseInvoice,
																						   this.mnuCaseLetter,
																						   this.mnuCaseExpense,
																						   this.mnuCaseOffer,
																						   this.mnuCaseVisit,
																						   this.mnuCaseValuation});
			this.mnuCase.Text = "&Case Items";
			// 
			// mnuCaseBorrower
			// 
			this.mnuCaseBorrower.Description = "MenuItem";
			this.mnuCaseBorrower.Text = "New &Borrower";
			this.mnuCaseBorrower.Click += new System.EventHandler(this.mnuCaseBorrower_Click);
			// 
			// mnuCaseGuarantor
			// 
			this.mnuCaseGuarantor.Description = "MenuItem";
			this.mnuCaseGuarantor.Text = "New &Guarantor";
			this.mnuCaseGuarantor.Click += new System.EventHandler(this.mnuCaseGuarantor_Click);
			// 
			// mnuCaseTenant
			// 
			this.mnuCaseTenant.Description = "MenuItem";
			this.mnuCaseTenant.Text = "New &Tenant";
			this.mnuCaseTenant.Click += new System.EventHandler(this.mnuCaseTenant_Click);
			// 
			// menuCommand3
			// 
			this.menuCommand3.Description = "MenuItem";
			this.menuCommand3.Text = "-";
			// 
			// mnuCaseAccount
			// 
			this.mnuCaseAccount.Description = "MenuItem";
			this.mnuCaseAccount.Text = "New &Account";
			this.mnuCaseAccount.Click += new System.EventHandler(this.mnuCaseAccount_Click);
			// 
			// mnuCaseHoldCode
			// 
			this.mnuCaseHoldCode.Description = "MenuItem";
			this.mnuCaseHoldCode.Text = "Add &Hold Code";
			this.mnuCaseHoldCode.Click += new System.EventHandler(this.mnuCaseHoldCode_Click);
			// 
			// menuCommand4
			// 
			this.menuCommand4.Description = "MenuItem";
			this.menuCommand4.Text = "-";
			// 
			// mnuCaseJournal
			// 
			this.mnuCaseJournal.Description = "MenuItem";
			this.mnuCaseJournal.Text = "Add &Journal Entry";
			this.mnuCaseJournal.Click += new System.EventHandler(this.mnuCaseJournal_Click);
			// 
			// mnuCaseDiary
			// 
			this.mnuCaseDiary.Description = "MenuItem";
			this.mnuCaseDiary.Text = "Add &Diary Entry";
			this.mnuCaseDiary.Click += new System.EventHandler(this.mnuCaseDiary_Click);
			// 
			// menuCommand7
			// 
			this.menuCommand7.Description = "MenuItem";
			this.menuCommand7.Text = "-";
			// 
			// mnuCaseEndowment
			// 
			this.mnuCaseEndowment.Description = "MenuItem";
			this.mnuCaseEndowment.Text = "New &Endowment Policy";
			this.mnuCaseEndowment.Click += new System.EventHandler(this.mnuCaseEndowment_Click);
			// 
			// mnuCaseInvAcc
			// 
			this.mnuCaseInvAcc.Description = "MenuItem";
			this.mnuCaseInvAcc.Text = "New &Investment Account";
			this.mnuCaseInvAcc.Click += new System.EventHandler(this.mnuCaseInvAcc_Click);
			// 
			// mnuCaseInvoice
			// 
			this.mnuCaseInvoice.Description = "MenuItem";
			this.mnuCaseInvoice.Text = "New &I&nvoice";
			this.mnuCaseInvoice.Click += new System.EventHandler(this.mnuCaseInvoice_Click);
			// 
			// mnuCaseLetter
			// 
			this.mnuCaseLetter.Description = "MenuItem";
			this.mnuCaseLetter.Text = "New &Letter/Memo";
			this.mnuCaseLetter.Click += new System.EventHandler(this.mnuCaseLetter_Click);
			// 
			// mnuCaseExpense
			// 
			this.mnuCaseExpense.Description = "MenuItem";
			this.mnuCaseExpense.Text = "New Misc E&xpense";
			this.mnuCaseExpense.Click += new System.EventHandler(this.mnuCaseExpense_Click);
			// 
			// mnuCaseOffer
			// 
			this.mnuCaseOffer.Description = "MenuItem";
			this.mnuCaseOffer.Text = "New &Offer";
			this.mnuCaseOffer.Click += new System.EventHandler(this.mnuCaseOffer_Click);
			// 
			// mnuCaseVisit
			// 
			this.mnuCaseVisit.Description = "MenuItem";
			this.mnuCaseVisit.Text = "New &Site Visit";
			this.mnuCaseVisit.Click += new System.EventHandler(this.mnuCaseVisit_Click);
			// 
			// mnuCaseValuation
			// 
			this.mnuCaseValuation.Description = "MenuItem";
			this.mnuCaseValuation.Text = "New &Valuation";
			this.mnuCaseValuation.Click += new System.EventHandler(this.mnuCaseValuation_Click);
			// 
			// mnuReports
			// 
			this.mnuReports.Description = "MenuItem";
			this.mnuReports.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																							  this.mnuReportsMenu});
			this.mnuReports.Text = "&Reports";
			// 
			// mnuReportsMenu
			// 
			this.mnuReportsMenu.Description = "MenuItem";
			this.mnuReportsMenu.Text = "&Reports Menu";
			this.mnuReportsMenu.Click += new System.EventHandler(this.mnuReportsMenu_Click);
			// 
			// mnuAdmin
			// 
			this.mnuAdmin.Description = "MenuItem";
			this.mnuAdmin.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																							this.mnuAdminSettings,
																							this.mnuAdminUsers,
																							this.mnuAdminLetter,
																							this.mnuAdminMailMerge,
																							this.mnuAdminChangePassword});
			this.mnuAdmin.Text = "&Admin";
			// 
			// mnuAdminSettings
			// 
			this.mnuAdminSettings.Description = "MenuItem";
			this.mnuAdminSettings.Text = "&System Settings";
			this.mnuAdminSettings.Click += new System.EventHandler(this.mnuAdminSettings_Click);
			// 
			// mnuAdminUsers
			// 
			this.mnuAdminUsers.Description = "MenuItem";
			this.mnuAdminUsers.Text = "&User Management";
			this.mnuAdminUsers.Click += new System.EventHandler(this.mnuAdminUsers_Click);
			// 
			// mnuAdminLetter
			// 
			this.mnuAdminLetter.Description = "MenuItem";
			this.mnuAdminLetter.Text = "Setup &Letters";
			this.mnuAdminLetter.Click += new System.EventHandler(this.mnuAdminLetter_Click);
			// 
			// mnuAdminMailMerge
			// 
			this.mnuAdminMailMerge.Description = "MenuItem";
			this.mnuAdminMailMerge.Text = "&Bulk Mail Merge";
			this.mnuAdminMailMerge.Click += new System.EventHandler(this.mnuAdminMailMerge_Click);
			// 
			// mnuAdminChangePassword
			// 
			this.mnuAdminChangePassword.Description = "MenuItem";
			this.mnuAdminChangePassword.Text = "&Change My Password";
			this.mnuAdminChangePassword.Click += new System.EventHandler(this.mnuAdminChangePassword_Click);
			// 
			// mnuHelp
			// 
			this.mnuHelp.Description = "MenuItem";
			this.mnuHelp.MenuCommands.AddRange(new Crownwood.Magic.Menus.MenuCommand[] {
																						   this.mnuHelpAbout});
			this.mnuHelp.Text = "&Help";
			// 
			// mnuHelpAbout
			// 
			this.mnuHelpAbout.Description = "MenuItem";
			this.mnuHelpAbout.Text = "&About V4 Arrears Manager";
			this.mnuHelpAbout.Click += new System.EventHandler(this.mnuHelpAbout_Click);
			// 
			// sbarMain
			// 
			this.sbarMain.Location = new System.Drawing.Point(0, 485);
			this.sbarMain.Name = "sbarMain";
			this.sbarMain.Panels.AddRange(new System.Windows.Forms.StatusBarPanel[] {
																						this.sbarPanel1,
																						this.sbarPanel3,
																						this.sbarPanel2});
			this.sbarMain.ShowPanels = true;
			this.sbarMain.Size = new System.Drawing.Size(741, 20);
			this.sbarMain.TabIndex = 2;
			// 
			// sbarPanel1
			// 
			this.sbarPanel1.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbarPanel1.Text = "Ready";
			this.sbarPanel1.Width = 317;
			// 
			// sbarPanel3
			// 
			this.sbarPanel3.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Contents;
			this.sbarPanel3.Text = "Not Logged On";
			this.sbarPanel3.Width = 91;
			// 
			// sbarPanel2
			// 
			this.sbarPanel2.AutoSize = System.Windows.Forms.StatusBarPanelAutoSize.Spring;
			this.sbarPanel2.Width = 317;
			// 
			// imgsToolbar
			// 
			this.imgsToolbar.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imgsToolbar.ImageSize = new System.Drawing.Size(16, 16);
			this.imgsToolbar.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imgsToolbar.ImageStream")));
			this.imgsToolbar.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// panel1
			// 
			this.panel1.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.diaryMain,
																				 this.splitter1,
																				 this.tabsMenu});
			this.panel1.Dock = System.Windows.Forms.DockStyle.Left;
			this.panel1.Location = new System.Drawing.Point(0, 25);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(239, 460);
			this.panel1.TabIndex = 5;
			// 
			// diaryMain
			// 
			this.diaryMain.AllowDrop = true;
			this.diaryMain.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.diaryMain.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.diaryMain.CheckBookLookEnabled = false;
			this.diaryMain.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.diaryMain.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.diaryMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diaryMain.FullRowSelect = true;
			this.diaryMain.HeaderColor = System.Drawing.Color.Empty;
			this.diaryMain.HeaderImageList = null;
			this.diaryMain.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.diaryMain.Location = new System.Drawing.Point(0, 290);
			this.diaryMain.MultiSelect = false;
			this.diaryMain.Name = "diaryMain";
			this.diaryMain.PaintSortedColumnBackground = true;
			this.diaryMain.PendingEntriesOnly = true;
			this.diaryMain.Size = new System.Drawing.Size(239, 170);
			this.diaryMain.Sorting = System.Windows.Forms.SortOrder.Descending;
			this.diaryMain.SortingEnabled = true;
			this.diaryMain.SortOrder = System.Windows.Forms.SortOrder.Descending;
			this.diaryMain.TabIndex = 3;
			this.diaryMain.View = System.Windows.Forms.View.Details;
			// 
			// splitter1
			// 
			this.splitter1.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter1.Location = new System.Drawing.Point(0, 284);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(239, 6);
			this.splitter1.TabIndex = 1;
			this.splitter1.TabStop = false;
			// 
			// tabsMenu
			// 
			this.tabsMenu.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.tabTree,
																				   this.tabFind});
			this.tabsMenu.Dock = System.Windows.Forms.DockStyle.Top;
			this.tabsMenu.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabsMenu.Name = "tabsMenu";
			this.tabsMenu.PositionTop = true;
			this.tabsMenu.SelectedIndex = 0;
			this.tabsMenu.SelectedTab = this.tabTree;
			this.tabsMenu.Size = new System.Drawing.Size(239, 284);
			this.tabsMenu.TabIndex = 1;
			this.tabsMenu.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																					   this.tabTree,
																					   this.tabFind});
			// 
			// tabTree
			// 
			this.tabTree.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.tvwIndex});
			this.tabTree.Location = new System.Drawing.Point(0, 25);
			this.tabTree.Name = "tabTree";
			this.tabTree.Size = new System.Drawing.Size(239, 259);
			this.tabTree.TabIndex = 3;
			this.tabTree.TabStop = true;
			this.tabTree.Title = "Index";
			// 
			// tvwIndex
			// 
			this.tvwIndex.AllowDrop = true;
			this.tvwIndex.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tvwIndex.HideSelection = false;
			this.tvwIndex.Name = "tvwIndex";
			this.tvwIndex.ShowRootLines = false;
			this.tvwIndex.Size = new System.Drawing.Size(239, 259);
			this.tvwIndex.TabIndex = 2;
			this.tvwIndex.DeleteCase += new DebtManagerTest.CaseEventHandler(this.tvwIndex_DeleteCase);
			this.tvwIndex.NewCase += new DebtManagerTest.CaseEventHandler(this.tvwIndex_NewCase);
			this.tvwIndex.ReactivateCase += new DebtManagerTest.CaseEventHandler(this.tvwIndex_ReactivateCase);
			this.tvwIndex.ArchiveCase += new DebtManagerTest.CaseEventHandler(this.tvwIndex_ArchiveCase);
			// 
			// tabFind
			// 
			this.tabFind.Controls.AddRange(new System.Windows.Forms.Control[] {
																				  this.findCase1});
			this.tabFind.Location = new System.Drawing.Point(0, 25);
			this.tabFind.Name = "tabFind";
			this.tabFind.Selected = false;
			this.tabFind.Size = new System.Drawing.Size(239, 259);
			this.tabFind.TabIndex = 4;
			this.tabFind.TabStop = true;
			this.tabFind.Title = "Find";
			// 
			// findCase1
			// 
			this.findCase1.Dock = System.Windows.Forms.DockStyle.Fill;
			this.findCase1.Name = "findCase1";
			this.findCase1.Size = new System.Drawing.Size(239, 259);
			this.findCase1.TabIndex = 5;
			// 
			// splitter2
			// 
			this.splitter2.Location = new System.Drawing.Point(239, 25);
			this.splitter2.Name = "splitter2";
			this.splitter2.Size = new System.Drawing.Size(6, 460);
			this.splitter2.TabIndex = 6;
			this.splitter2.TabStop = false;
			// 
			// tabsMain
			// 
			this.tabsMain.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.tabGeneral,
																				   this.tabAccount,
																				   this.tabPossession,
																				   this.tabOther,
																				   this.tabJournal});
			this.tabsMain.Dock = System.Windows.Forms.DockStyle.Fill;
			this.tabsMain.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabsMain.Location = new System.Drawing.Point(245, 25);
			this.tabsMain.Name = "tabsMain";
			this.tabsMain.PositionTop = true;
			this.tabsMain.SelectedIndex = 0;
			this.tabsMain.SelectedTab = this.tabGeneral;
			this.tabsMain.Size = new System.Drawing.Size(496, 460);
			this.tabsMain.TabIndex = 7;
			this.tabsMain.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																					   this.tabGeneral,
																					   this.tabAccount,
																					   this.tabPossession,
																					   this.tabOther,
																					   this.tabJournal});
			this.tabsMain.Visible = false;
			// 
			// tabGeneral
			// 
			this.tabGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.panel4,
																					 this.tabsGeneral});
			this.tabGeneral.DockPadding.All = 10;
			this.tabGeneral.Location = new System.Drawing.Point(0, 25);
			this.tabGeneral.Name = "tabGeneral";
			this.tabGeneral.Size = new System.Drawing.Size(496, 435);
			this.tabGeneral.TabIndex = 3;
			this.tabGeneral.TabStop = true;
			this.tabGeneral.Title = "General Case Details";
			// 
			// panel4
			// 
			this.panel4.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel4.AutoScroll = true;
			this.panel4.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.dtpLastContact,
																				 this.cboPropertyType,
																				 this.txtTelephoneNo,
																				 this.txtPostCode,
																				 this.txtPropertyAddress,
																				 this.txtSalutation,
																				 this.txtTitle,
																				 this.txtAcc,
																				 this.label10,
																				 this.label9,
																				 this.label8,
																				 this.label7,
																				 this.label6,
																				 this.label5,
																				 this.cboBranch,
																				 this.label4,
																				 this.label3,
																				 this.label2});
			this.panel4.Location = new System.Drawing.Point(2, 5);
			this.panel4.Name = "panel4";
			this.panel4.Size = new System.Drawing.Size(482, 279);
			this.panel4.TabIndex = 9;
			// 
			// dtpLastContact
			// 
			this.dtpLastContact.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpLastContact.Location = new System.Drawing.Point(129, 229);
			this.dtpLastContact.Name = "dtpLastContact";
			this.dtpLastContact.ShowCheckBox = true;
			this.dtpLastContact.Size = new System.Drawing.Size(133, 21);
			this.dtpLastContact.TabIndex = 18;
			// 
			// cboPropertyType
			// 
			this.cboPropertyType.AllowUpdates = true;
			this.cboPropertyType.ComboValue = null;
			this.cboPropertyType.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.PropertyType"));
			this.cboPropertyType.DataBound = true;
			this.cboPropertyType.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPropertyType.ExtraRefreshes = true;
			this.cboPropertyType.Location = new System.Drawing.Point(129, 104);
			this.cboPropertyType.LookupID = "PropertyType";
			this.cboPropertyType.Name = "cboPropertyType";
			this.cboPropertyType.Nullable = false;
			this.cboPropertyType.Size = new System.Drawing.Size(136, 21);
			this.cboPropertyType.TabIndex = 14;
			// 
			// dsCases1
			// 
			this.dsCases1.DataSetName = "dsCases";
			this.dsCases1.Locale = new System.Globalization.CultureInfo("en-GB");
			this.dsCases1.Namespace = "http://www.tempuri.org/dsCases.xsd";
			// 
			// txtTelephoneNo
			// 
			this.txtTelephoneNo.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.PropertyTelephone"));
			this.txtTelephoneNo.Location = new System.Drawing.Point(129, 205);
			this.txtTelephoneNo.Name = "txtTelephoneNo";
			this.txtTelephoneNo.Size = new System.Drawing.Size(132, 21);
			this.txtTelephoneNo.TabIndex = 17;
			this.txtTelephoneNo.Text = "";
			// 
			// txtPostCode
			// 
			this.txtPostCode.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.PropertyPostCode"));
			this.txtPostCode.Location = new System.Drawing.Point(129, 181);
			this.txtPostCode.MaxLength = 12;
			this.txtPostCode.Name = "txtPostCode";
			this.txtPostCode.TabIndex = 16;
			this.txtPostCode.Text = "";
			// 
			// txtPropertyAddress
			// 
			this.txtPropertyAddress.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.PropertyAddress"));
			this.txtPropertyAddress.Location = new System.Drawing.Point(129, 128);
			this.txtPropertyAddress.Multiline = true;
			this.txtPropertyAddress.Name = "txtPropertyAddress";
			this.txtPropertyAddress.Size = new System.Drawing.Size(191, 50);
			this.txtPropertyAddress.TabIndex = 15;
			this.txtPropertyAddress.Text = "";
			// 
			// txtSalutation
			// 
			this.txtSalutation.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.AccountSalutation"));
			this.txtSalutation.Location = new System.Drawing.Point(129, 56);
			this.txtSalutation.Name = "txtSalutation";
			this.txtSalutation.Size = new System.Drawing.Size(189, 21);
			this.txtSalutation.TabIndex = 12;
			this.txtSalutation.Text = "";
			// 
			// txtTitle
			// 
			this.txtTitle.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.AccountTitle"));
			this.txtTitle.Location = new System.Drawing.Point(129, 32);
			this.txtTitle.Name = "txtTitle";
			this.txtTitle.Size = new System.Drawing.Size(189, 21);
			this.txtTitle.TabIndex = 11;
			this.txtTitle.Text = "";
			// 
			// txtAcc
			// 
			this.txtAcc.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.AccountNumber"));
			this.txtAcc.Location = new System.Drawing.Point(129, 8);
			this.txtAcc.MaxLength = 8;
			this.txtAcc.Name = "txtAcc";
			this.txtAcc.TabIndex = 10;
			this.txtAcc.Text = "";
			// 
			// label10
			// 
			this.label10.Location = new System.Drawing.Point(10, 232);
			this.label10.Name = "label10";
			this.label10.Size = new System.Drawing.Size(99, 13);
			this.label10.TabIndex = 28;
			this.label10.Text = "Last Contact Date";
			// 
			// label9
			// 
			this.label9.Location = new System.Drawing.Point(10, 208);
			this.label9.Name = "label9";
			this.label9.Size = new System.Drawing.Size(99, 13);
			this.label9.TabIndex = 27;
			this.label9.Text = "Telephone No";
			// 
			// label8
			// 
			this.label8.Location = new System.Drawing.Point(10, 184);
			this.label8.Name = "label8";
			this.label8.Size = new System.Drawing.Size(99, 13);
			this.label8.TabIndex = 26;
			this.label8.Text = "Post Code";
			// 
			// label7
			// 
			this.label7.Location = new System.Drawing.Point(10, 128);
			this.label7.Name = "label7";
			this.label7.Size = new System.Drawing.Size(99, 13);
			this.label7.TabIndex = 25;
			this.label7.Text = "Property Address";
			// 
			// label6
			// 
			this.label6.Location = new System.Drawing.Point(10, 105);
			this.label6.Name = "label6";
			this.label6.Size = new System.Drawing.Size(99, 13);
			this.label6.TabIndex = 24;
			this.label6.Text = "Property Type";
			// 
			// label5
			// 
			this.label5.Location = new System.Drawing.Point(10, 82);
			this.label5.Name = "label5";
			this.label5.Size = new System.Drawing.Size(99, 13);
			this.label5.TabIndex = 23;
			this.label5.Text = "Branch";
			// 
			// cboBranch
			// 
			this.cboBranch.AllowUpdates = true;
			this.cboBranch.ComboValue = null;
			this.cboBranch.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.BranchRef"));
			this.cboBranch.DataBound = true;
			this.cboBranch.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboBranch.ExtraRefreshes = true;
			this.cboBranch.Location = new System.Drawing.Point(129, 80);
			this.cboBranch.LookupID = "Branch";
			this.cboBranch.Name = "cboBranch";
			this.cboBranch.Nullable = true;
			this.cboBranch.Size = new System.Drawing.Size(135, 21);
			this.cboBranch.TabIndex = 13;
			// 
			// label4
			// 
			this.label4.Location = new System.Drawing.Point(10, 59);
			this.label4.Name = "label4";
			this.label4.Size = new System.Drawing.Size(99, 13);
			this.label4.TabIndex = 21;
			this.label4.Text = "Salutation";
			// 
			// label3
			// 
			this.label3.Location = new System.Drawing.Point(10, 36);
			this.label3.Name = "label3";
			this.label3.Size = new System.Drawing.Size(99, 13);
			this.label3.TabIndex = 20;
			this.label3.Text = "Title";
			// 
			// label2
			// 
			this.label2.Location = new System.Drawing.Point(10, 13);
			this.label2.Name = "label2";
			this.label2.Size = new System.Drawing.Size(99, 13);
			this.label2.TabIndex = 19;
			this.label2.Text = "Account Number";
			// 
			// tabsGeneral
			// 
			this.tabsGeneral.Anchor = ((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.tabsGeneral.Controls.AddRange(new System.Windows.Forms.Control[] {
																					  this.tabBorrowers,
																					  this.tabGuaruntors,
																					  this.tabTenants});
			this.tabsGeneral.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.tabsGeneral.InsetBorderPagesOnly = true;
			this.tabsGeneral.InsetPlain = false;
			this.tabsGeneral.Location = new System.Drawing.Point(10, 289);
			this.tabsGeneral.Name = "tabsGeneral";
			this.tabsGeneral.PositionTop = true;
			this.tabsGeneral.SelectedIndex = 0;
			this.tabsGeneral.SelectedTab = this.tabBorrowers;
			this.tabsGeneral.Size = new System.Drawing.Size(476, 136);
			this.tabsGeneral.Style = Crownwood.Magic.Common.VisualStyle.Plain;
			this.tabsGeneral.TabIndex = 19;
			this.tabsGeneral.TabPages.AddRange(new Crownwood.Magic.Controls.TabPage[] {
																						  this.tabBorrowers,
																						  this.tabGuaruntors,
																						  this.tabTenants});
			// 
			// tabBorrowers
			// 
			this.tabBorrowers.Controls.AddRange(new System.Windows.Forms.Control[] {
																					   this.lvwBorrowers});
			this.tabBorrowers.Location = new System.Drawing.Point(0, 30);
			this.tabBorrowers.Name = "tabBorrowers";
			this.tabBorrowers.Size = new System.Drawing.Size(476, 106);
			this.tabBorrowers.TabIndex = 3;
			this.tabBorrowers.TabStop = true;
			this.tabBorrowers.Title = "Borrowers";
			// 
			// lvwBorrowers
			// 
			this.lvwBorrowers.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwBorrowers.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwBorrowers.CheckBookLookEnabled = false;
			this.lvwBorrowers.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwBorrowers.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwBorrowers.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvwBorrowers.FullRowSelect = true;
			this.lvwBorrowers.HeaderColor = System.Drawing.Color.Empty;
			this.lvwBorrowers.HeaderImageList = null;
			this.lvwBorrowers.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwBorrowers.MultiSelect = false;
			this.lvwBorrowers.Name = "lvwBorrowers";
			this.lvwBorrowers.PaintSortedColumnBackground = true;
			this.lvwBorrowers.Size = new System.Drawing.Size(476, 106);
			this.lvwBorrowers.SortingEnabled = true;
			this.lvwBorrowers.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwBorrowers.TabIndex = 0;
			this.lvwBorrowers.Tag = "B";
			this.lvwBorrowers.View = System.Windows.Forms.View.Details;
			this.lvwBorrowers.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwBorrowers_MouseUp);
			// 
			// tabGuaruntors
			// 
			this.tabGuaruntors.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.lvwGuaruntors});
			this.tabGuaruntors.Location = new System.Drawing.Point(0, 30);
			this.tabGuaruntors.Name = "tabGuaruntors";
			this.tabGuaruntors.Selected = false;
			this.tabGuaruntors.Size = new System.Drawing.Size(476, 106);
			this.tabGuaruntors.TabIndex = 4;
			this.tabGuaruntors.TabStop = true;
			this.tabGuaruntors.Title = "Guarantors";
			// 
			// lvwGuaruntors
			// 
			this.lvwGuaruntors.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwGuaruntors.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwGuaruntors.CheckBookLookEnabled = false;
			this.lvwGuaruntors.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwGuaruntors.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwGuaruntors.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvwGuaruntors.FullRowSelect = true;
			this.lvwGuaruntors.HeaderColor = System.Drawing.Color.Empty;
			this.lvwGuaruntors.HeaderImageList = null;
			this.lvwGuaruntors.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwGuaruntors.MultiSelect = false;
			this.lvwGuaruntors.Name = "lvwGuaruntors";
			this.lvwGuaruntors.PaintSortedColumnBackground = true;
			this.lvwGuaruntors.Size = new System.Drawing.Size(476, 106);
			this.lvwGuaruntors.SortingEnabled = true;
			this.lvwGuaruntors.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwGuaruntors.TabIndex = 0;
			this.lvwGuaruntors.Tag = "G";
			this.lvwGuaruntors.View = System.Windows.Forms.View.Details;
			this.lvwGuaruntors.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwBorrowers_MouseUp);
			// 
			// tabTenants
			// 
			this.tabTenants.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.lvwTenants});
			this.tabTenants.Location = new System.Drawing.Point(0, 30);
			this.tabTenants.Name = "tabTenants";
			this.tabTenants.Selected = false;
			this.tabTenants.Size = new System.Drawing.Size(476, 106);
			this.tabTenants.TabIndex = 5;
			this.tabTenants.TabStop = true;
			this.tabTenants.Title = "Tenants";
			// 
			// lvwTenants
			// 
			this.lvwTenants.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwTenants.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwTenants.CheckBookLookEnabled = false;
			this.lvwTenants.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwTenants.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwTenants.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvwTenants.FullRowSelect = true;
			this.lvwTenants.HeaderColor = System.Drawing.Color.Empty;
			this.lvwTenants.HeaderImageList = null;
			this.lvwTenants.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwTenants.MultiSelect = false;
			this.lvwTenants.Name = "lvwTenants";
			this.lvwTenants.PaintSortedColumnBackground = true;
			this.lvwTenants.Size = new System.Drawing.Size(476, 106);
			this.lvwTenants.SortingEnabled = true;
			this.lvwTenants.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwTenants.TabIndex = 0;
			this.lvwTenants.Tag = "T";
			this.lvwTenants.View = System.Windows.Forms.View.Details;
			this.lvwTenants.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwBorrowers_MouseUp);
			// 
			// tabAccount
			// 
			this.tabAccount.AutoScroll = true;
			this.tabAccount.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.label18,
																					 this.lblRegularPayment,
																					 this.lblDegree,
																					 this.lblCapitalBalance,
																					 this.cmdPaymentHistory,
																					 this.cmdBalanceHistory,
																					 this.cmdDegreeHistory,
																					 this.lvwAccounts,
																					 this.cboHousingAssociation,
																					 this.lblPaymentDate,
																					 this.label24,
																					 this.label23,
																					 this.txtShare,
																					 this.lblShare,
																					 this.txtPercentageAdvance,
																					 this.label21,
																					 this.lblHousingAssociation,
																					 this.chkSharedOwnership,
																					 this.txtDSS,
																					 this.lblDSS,
																					 this.chkDSS,
																					 this.lblBalanceDate,
																					 this.label17,
																					 this.label16,
																					 this.chkPaymentProtection,
																					 this.chkEarlyRepayment,
																					 this.chkOtherDebts,
																					 this.chkBancruptcy,
																					 this.cboCauseOfArrears,
																					 this.label15,
																					 this.label14,
																					 this.txtAmountofArrears,
																					 this.lblDegreeDate,
																					 this.label12,
																					 this.label11});
			this.tabAccount.Location = new System.Drawing.Point(0, 25);
			this.tabAccount.Name = "tabAccount";
			this.tabAccount.Selected = false;
			this.tabAccount.Size = new System.Drawing.Size(496, 435);
			this.tabAccount.TabIndex = 4;
			this.tabAccount.TabStop = true;
			this.tabAccount.Title = "Account/Arrears";
			// 
			// label18
			// 
			this.label18.Location = new System.Drawing.Point(14, 312);
			this.label18.Name = "label18";
			this.label18.Size = new System.Drawing.Size(157, 13);
			this.label18.TabIndex = 39;
			this.label18.Text = "Mortgage Account Breakdown";
			// 
			// lblRegularPayment
			// 
			this.lblRegularPayment.Location = new System.Drawing.Point(131, 282);
			this.lblRegularPayment.Name = "lblRegularPayment";
			this.lblRegularPayment.Size = new System.Drawing.Size(96, 18);
			this.lblRegularPayment.TabIndex = 38;
			this.lblRegularPayment.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblDegree
			// 
			this.lblDegree.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.Degree"));
			this.lblDegree.Location = new System.Drawing.Point(133, 17);
			this.lblDegree.Name = "lblDegree";
			this.lblDegree.Size = new System.Drawing.Size(92, 14);
			this.lblDegree.TabIndex = 37;
			this.lblDegree.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// lblCapitalBalance
			// 
			this.lblCapitalBalance.Location = new System.Drawing.Point(132, 186);
			this.lblCapitalBalance.Name = "lblCapitalBalance";
			this.lblCapitalBalance.Size = new System.Drawing.Size(91, 16);
			this.lblCapitalBalance.TabIndex = 36;
			this.lblCapitalBalance.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// cmdPaymentHistory
			// 
			this.cmdPaymentHistory.Location = new System.Drawing.Point(344, 280);
			this.cmdPaymentHistory.Name = "cmdPaymentHistory";
			this.cmdPaymentHistory.Size = new System.Drawing.Size(47, 20);
			this.cmdPaymentHistory.TabIndex = 34;
			this.cmdPaymentHistory.Text = "Update ";
			this.cmdPaymentHistory.Click += new System.EventHandler(this.cmdPaymentHistory_Click);
			// 
			// cmdBalanceHistory
			// 
			this.cmdBalanceHistory.Location = new System.Drawing.Point(344, 185);
			this.cmdBalanceHistory.Name = "cmdBalanceHistory";
			this.cmdBalanceHistory.Size = new System.Drawing.Size(47, 20);
			this.cmdBalanceHistory.TabIndex = 27;
			this.cmdBalanceHistory.Text = "Update ";
			this.cmdBalanceHistory.Click += new System.EventHandler(this.cmdBalanceHistory_Click);
			// 
			// cmdDegreeHistory
			// 
			this.cmdDegreeHistory.Location = new System.Drawing.Point(343, 14);
			this.cmdDegreeHistory.Name = "cmdDegreeHistory";
			this.cmdDegreeHistory.Size = new System.Drawing.Size(48, 20);
			this.cmdDegreeHistory.TabIndex = 20;
			this.cmdDegreeHistory.Text = "Update ";
			this.cmdDegreeHistory.Click += new System.EventHandler(this.cmdDegreeHistory_Click);
			// 
			// lvwAccounts
			// 
			this.lvwAccounts.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.lvwAccounts.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwAccounts.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwAccounts.CheckBookLookEnabled = false;
			this.lvwAccounts.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwAccounts.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwAccounts.FullRowSelect = true;
			this.lvwAccounts.HeaderColor = System.Drawing.Color.Empty;
			this.lvwAccounts.HeaderImageList = null;
			this.lvwAccounts.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwAccounts.Location = new System.Drawing.Point(16, 328);
			this.lvwAccounts.MultiSelect = false;
			this.lvwAccounts.Name = "lvwAccounts";
			this.lvwAccounts.PaintSortedColumnBackground = true;
			this.lvwAccounts.Size = new System.Drawing.Size(464, 93);
			this.lvwAccounts.SortingEnabled = true;
			this.lvwAccounts.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwAccounts.TabIndex = 35;
			this.lvwAccounts.Tag = "ACC";
			this.lvwAccounts.View = System.Windows.Forms.View.Details;
			this.lvwAccounts.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwBorrowers_MouseUp);
			// 
			// cboHousingAssociation
			// 
			this.cboHousingAssociation.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.HousingAssociation"));
			this.cboHousingAssociation.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboHousingAssociation.Location = new System.Drawing.Point(268, 231);
			this.cboHousingAssociation.Name = "cboHousingAssociation";
			this.cboHousingAssociation.Size = new System.Drawing.Size(123, 21);
			this.cboHousingAssociation.TabIndex = 31;
			this.cboHousingAssociation.ValidForCreditor = false;
			this.cboHousingAssociation.ValidForEmployer = false;
			this.cboHousingAssociation.ValidForEndowmentCompany = false;
			this.cboHousingAssociation.ValidForEstateAgent = false;
			this.cboHousingAssociation.ValidForHousingAssociation = true;
			this.cboHousingAssociation.ValidForIndemnityCompany = false;
			this.cboHousingAssociation.ValidForInvoiceSource = false;
			this.cboHousingAssociation.ValidForSecondCharge = false;
			this.cboHousingAssociation.ValidForValuer = false;
			this.cboHousingAssociation.Visible = false;
			this.cboHousingAssociation.zDataBound = true;
			this.cboHousingAssociation.ListUpdated += new System.EventHandler(this.cboHousingAssociation_ListUpdated);
			// 
			// lblPaymentDate
			// 
			this.lblPaymentDate.Location = new System.Drawing.Point(272, 284);
			this.lblPaymentDate.Name = "lblPaymentDate";
			this.lblPaymentDate.Size = new System.Drawing.Size(63, 14);
			this.lblPaymentDate.TabIndex = 29;
			// 
			// label24
			// 
			this.label24.Location = new System.Drawing.Point(235, 284);
			this.label24.Name = "label24";
			this.label24.Size = new System.Drawing.Size(34, 14);
			this.label24.TabIndex = 28;
			this.label24.Text = "As At";
			// 
			// label23
			// 
			this.label23.Location = new System.Drawing.Point(14, 284);
			this.label23.Name = "label23";
			this.label23.Size = new System.Drawing.Size(100, 15);
			this.label23.TabIndex = 26;
			this.label23.Text = "Regular Payment";
			// 
			// txtShare
			// 
			this.txtShare.Location = new System.Drawing.Point(291, 255);
			this.txtShare.Name = "txtShare";
			this.txtShare.TabIndex = 33;
			this.txtShare.Text = "";
			this.txtShare.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtShare.Visible = false;
			// 
			// lblShare
			// 
			this.lblShare.Location = new System.Drawing.Point(233, 257);
			this.lblShare.Name = "lblShare";
			this.lblShare.Size = new System.Drawing.Size(55, 17);
			this.lblShare.TabIndex = 24;
			this.lblShare.Text = "% Share";
			this.lblShare.Visible = false;
			// 
			// txtPercentageAdvance
			// 
			this.txtPercentageAdvance.Location = new System.Drawing.Point(131, 255);
			this.txtPercentageAdvance.Name = "txtPercentageAdvance";
			this.txtPercentageAdvance.Size = new System.Drawing.Size(96, 21);
			this.txtPercentageAdvance.TabIndex = 32;
			this.txtPercentageAdvance.Text = "";
			this.txtPercentageAdvance.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// label21
			// 
			this.label21.Location = new System.Drawing.Point(14, 259);
			this.label21.Name = "label21";
			this.label21.Size = new System.Drawing.Size(108, 15);
			this.label21.TabIndex = 22;
			this.label21.Text = "Percentage Advance";
			// 
			// lblHousingAssociation
			// 
			this.lblHousingAssociation.Location = new System.Drawing.Point(155, 235);
			this.lblHousingAssociation.Name = "lblHousingAssociation";
			this.lblHousingAssociation.Size = new System.Drawing.Size(110, 15);
			this.lblHousingAssociation.TabIndex = 20;
			this.lblHousingAssociation.Text = "Housing Association";
			this.lblHousingAssociation.Visible = false;
			// 
			// chkSharedOwnership
			// 
			this.chkSharedOwnership.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkSharedOwnership.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.SharedOwnership"));
			this.chkSharedOwnership.Location = new System.Drawing.Point(14, 235);
			this.chkSharedOwnership.Name = "chkSharedOwnership";
			this.chkSharedOwnership.Size = new System.Drawing.Size(131, 15);
			this.chkSharedOwnership.TabIndex = 30;
			this.chkSharedOwnership.Text = "Shared Ownership?";
			this.chkSharedOwnership.CheckedChanged += new System.EventHandler(this.chkSharedOwnership_CheckedChanged);
			// 
			// txtDSS
			// 
			this.txtDSS.Location = new System.Drawing.Point(291, 207);
			this.txtDSS.Name = "txtDSS";
			this.txtDSS.TabIndex = 29;
			this.txtDSS.Text = "";
			this.txtDSS.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtDSS.Visible = false;
			// 
			// lblDSS
			// 
			this.lblDSS.Location = new System.Drawing.Point(160, 210);
			this.lblDSS.Name = "lblDSS";
			this.lblDSS.Size = new System.Drawing.Size(114, 15);
			this.lblDSS.TabIndex = 17;
			this.lblDSS.Text = "Weekly DSS Payment";
			this.lblDSS.Visible = false;
			// 
			// chkDSS
			// 
			this.chkDSS.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkDSS.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.DSS"));
			this.chkDSS.Location = new System.Drawing.Point(14, 211);
			this.chkDSS.Name = "chkDSS";
			this.chkDSS.Size = new System.Drawing.Size(131, 15);
			this.chkDSS.TabIndex = 28;
			this.chkDSS.Text = "DSS Case?";
			this.chkDSS.CheckedChanged += new System.EventHandler(this.chkDSS_CheckedChanged);
			// 
			// lblBalanceDate
			// 
			this.lblBalanceDate.Location = new System.Drawing.Point(264, 184);
			this.lblBalanceDate.Name = "lblBalanceDate";
			this.lblBalanceDate.Size = new System.Drawing.Size(81, 20);
			this.lblBalanceDate.TabIndex = 15;
			this.lblBalanceDate.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// label17
			// 
			this.label17.Location = new System.Drawing.Point(233, 187);
			this.label17.Name = "label17";
			this.label17.Size = new System.Drawing.Size(33, 13);
			this.label17.TabIndex = 14;
			this.label17.Text = "As At";
			// 
			// label16
			// 
			this.label16.Location = new System.Drawing.Point(14, 187);
			this.label16.Name = "label16";
			this.label16.Size = new System.Drawing.Size(100, 15);
			this.label16.TabIndex = 13;
			this.label16.Text = "Capital Balance";
			// 
			// chkPaymentProtection
			// 
			this.chkPaymentProtection.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkPaymentProtection.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.PaymentProtection"));
			this.chkPaymentProtection.Location = new System.Drawing.Point(14, 162);
			this.chkPaymentProtection.Name = "chkPaymentProtection";
			this.chkPaymentProtection.Size = new System.Drawing.Size(212, 15);
			this.chkPaymentProtection.TabIndex = 26;
			this.chkPaymentProtection.Text = "Payment Protection policy in place?";
			// 
			// chkEarlyRepayment
			// 
			this.chkEarlyRepayment.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkEarlyRepayment.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.WithinEarlyRepaymentPeriod"));
			this.chkEarlyRepayment.Location = new System.Drawing.Point(14, 137);
			this.chkEarlyRepayment.Name = "chkEarlyRepayment";
			this.chkEarlyRepayment.Size = new System.Drawing.Size(212, 15);
			this.chkEarlyRepayment.TabIndex = 25;
			this.chkEarlyRepayment.Text = "Within early repayment period?";
			// 
			// chkOtherDebts
			// 
			this.chkOtherDebts.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkOtherDebts.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.OtherDebts"));
			this.chkOtherDebts.Location = new System.Drawing.Point(14, 112);
			this.chkOtherDebts.Name = "chkOtherDebts";
			this.chkOtherDebts.Size = new System.Drawing.Size(212, 15);
			this.chkOtherDebts.TabIndex = 24;
			this.chkOtherDebts.Text = "Borrowers have other debts?";
			// 
			// chkBancruptcy
			// 
			this.chkBancruptcy.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkBancruptcy.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.BancruptcyOrder"));
			this.chkBancruptcy.Location = new System.Drawing.Point(14, 87);
			this.chkBancruptcy.Name = "chkBancruptcy";
			this.chkBancruptcy.Size = new System.Drawing.Size(212, 15);
			this.chkBancruptcy.TabIndex = 23;
			this.chkBancruptcy.Text = "Bancruptcy Order?";
			// 
			// cboCauseOfArrears
			// 
			this.cboCauseOfArrears.AllowUpdates = true;
			this.cboCauseOfArrears.ComboValue = null;
			this.cboCauseOfArrears.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.CauseOfArrears"));
			this.cboCauseOfArrears.DataBound = true;
			this.cboCauseOfArrears.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboCauseOfArrears.ExtraRefreshes = true;
			this.cboCauseOfArrears.Location = new System.Drawing.Point(131, 61);
			this.cboCauseOfArrears.LookupID = "CauseOfArrears";
			this.cboCauseOfArrears.Name = "cboCauseOfArrears";
			this.cboCauseOfArrears.Nullable = true;
			this.cboCauseOfArrears.TabIndex = 22;
			// 
			// label15
			// 
			this.label15.Location = new System.Drawing.Point(14, 65);
			this.label15.Name = "label15";
			this.label15.Size = new System.Drawing.Size(100, 15);
			this.label15.TabIndex = 6;
			this.label15.Text = "Cause of Arrears";
			// 
			// label14
			// 
			this.label14.Location = new System.Drawing.Point(14, 42);
			this.label14.Name = "label14";
			this.label14.Size = new System.Drawing.Size(100, 15);
			this.label14.TabIndex = 5;
			this.label14.Text = "Amount of Arrears";
			// 
			// txtAmountofArrears
			// 
			this.txtAmountofArrears.Location = new System.Drawing.Point(131, 37);
			this.txtAmountofArrears.Name = "txtAmountofArrears";
			this.txtAmountofArrears.Size = new System.Drawing.Size(96, 21);
			this.txtAmountofArrears.TabIndex = 21;
			this.txtAmountofArrears.Text = "";
			this.txtAmountofArrears.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblDegreeDate
			// 
			this.lblDegreeDate.Location = new System.Drawing.Point(268, 17);
			this.lblDegreeDate.Name = "lblDegreeDate";
			this.lblDegreeDate.Size = new System.Drawing.Size(67, 14);
			this.lblDegreeDate.TabIndex = 3;
			// 
			// label12
			// 
			this.label12.Location = new System.Drawing.Point(233, 17);
			this.label12.Name = "label12";
			this.label12.Size = new System.Drawing.Size(45, 15);
			this.label12.TabIndex = 2;
			this.label12.Text = "As At";
			// 
			// label11
			// 
			this.label11.Location = new System.Drawing.Point(14, 18);
			this.label11.Name = "label11";
			this.label11.Size = new System.Drawing.Size(100, 15);
			this.label11.TabIndex = 0;
			this.label11.Text = "Degree of Arrears";
			// 
			// tabPossession
			// 
			this.tabPossession.AutoScroll = true;
			this.tabPossession.Controls.AddRange(new System.Windows.Forms.Control[] {
																						this.lblIndemnityClaimDate,
																						this.cboIndemnityClaimDate,
																						this.lblMarketPrice,
																						this.chkArchived,
																						this.cboPossessionOrder,
																						this.lblPossessionOrder,
																						this.cboIndemnityScheme,
																						this.lblIndemnityScheme,
																						this.txtIndemnityClaimed,
																						this.lblIndemnityClaimed,
																						this.txtWrittenOff,
																						this.lblWrittenOff,
																						this.txtLossProvision,
																						this.lblLossProvision,
																						this.txtDeferredInterest,
																						this.lblDeferredInterest,
																						this.txtDebtOnSale,
																						this.lblDebtOnSale,
																						this.lblSalePrice,
																						this.dtpDateSold,
																						this.txtSalePrice,
																						this.lblDateSold,
																						this.dtpPayoutDate,
																						this.lblPayoutDate,
																						this.txtIndemnityPayout,
																						this.lblIndemnityPayout,
																						this.txtIndemnityAmount,
																						this.lblIndemnityAmount,
																						this.lblIndemnityCompany,
																						this.cboIndemnityCompany,
																						this.chkIndemnityInsurance,
																						this.cmdMarketPriceHistory,
																						this.lblMarketPriceDate,
																						this.lblMarketPriceAsAt,
																						this.lblMarketPriceLabel,
																						this.lblDateMarketed,
																						this.lblDateInstructed,
																						this.dtpDateMarketed,
																						this.dtpDateInstructed,
																						this.cboEstateAgent,
																						this.lblEstateAgent,
																						this.dtpPossessionDate,
																						this.lblPossessionDate});
			this.tabPossession.Location = new System.Drawing.Point(0, 25);
			this.tabPossession.Name = "tabPossession";
			this.tabPossession.Selected = false;
			this.tabPossession.Size = new System.Drawing.Size(496, 435);
			this.tabPossession.TabIndex = 5;
			this.tabPossession.TabStop = true;
			this.tabPossession.Title = "Possession";
			// 
			// lblIndemnityClaimDate
			// 
			this.lblIndemnityClaimDate.Location = new System.Drawing.Point(247, 326);
			this.lblIndemnityClaimDate.Name = "lblIndemnityClaimDate";
			this.lblIndemnityClaimDate.Size = new System.Drawing.Size(29, 14);
			this.lblIndemnityClaimDate.TabIndex = 47;
			this.lblIndemnityClaimDate.Text = "Date";
			// 
			// cboIndemnityClaimDate
			// 
			this.cboIndemnityClaimDate.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.cboIndemnityClaimDate.Location = new System.Drawing.Point(283, 323);
			this.cboIndemnityClaimDate.Name = "cboIndemnityClaimDate";
			this.cboIndemnityClaimDate.ShowCheckBox = true;
			this.cboIndemnityClaimDate.Size = new System.Drawing.Size(118, 21);
			this.cboIndemnityClaimDate.TabIndex = 51;
			this.cboIndemnityClaimDate.Visible = false;
			// 
			// lblMarketPrice
			// 
			this.lblMarketPrice.Location = new System.Drawing.Point(138, 134);
			this.lblMarketPrice.Name = "lblMarketPrice";
			this.lblMarketPrice.Size = new System.Drawing.Size(100, 17);
			this.lblMarketPrice.TabIndex = 45;
			this.lblMarketPrice.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// chkArchived
			// 
			this.chkArchived.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkArchived.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.Archived"));
			this.chkArchived.Location = new System.Drawing.Point(264, 379);
			this.chkArchived.Name = "chkArchived";
			this.chkArchived.Size = new System.Drawing.Size(139, 14);
			this.chkArchived.TabIndex = 55;
			this.chkArchived.Text = "Archived Case?";
			// 
			// cboPossessionOrder
			// 
			this.cboPossessionOrder.AllowUpdates = true;
			this.cboPossessionOrder.ComboValue = null;
			this.cboPossessionOrder.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.PossessionOrder"));
			this.cboPossessionOrder.DataBound = true;
			this.cboPossessionOrder.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboPossessionOrder.ExtraRefreshes = true;
			this.cboPossessionOrder.Location = new System.Drawing.Point(138, 13);
			this.cboPossessionOrder.LookupID = "PossessionOrder";
			this.cboPossessionOrder.Name = "cboPossessionOrder";
			this.cboPossessionOrder.Nullable = true;
			this.cboPossessionOrder.Size = new System.Drawing.Size(118, 21);
			this.cboPossessionOrder.TabIndex = 36;
			// 
			// lblPossessionOrder
			// 
			this.lblPossessionOrder.Location = new System.Drawing.Point(11, 18);
			this.lblPossessionOrder.Name = "lblPossessionOrder";
			this.lblPossessionOrder.Size = new System.Drawing.Size(101, 15);
			this.lblPossessionOrder.TabIndex = 42;
			this.lblPossessionOrder.Text = "Possession Order";
			// 
			// cboIndemnityScheme
			// 
			this.cboIndemnityScheme.AllowUpdates = true;
			this.cboIndemnityScheme.ComboValue = null;
			this.cboIndemnityScheme.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.IndemnityScheme"));
			this.cboIndemnityScheme.DataBound = true;
			this.cboIndemnityScheme.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboIndemnityScheme.ExtraRefreshes = true;
			this.cboIndemnityScheme.Location = new System.Drawing.Point(138, 299);
			this.cboIndemnityScheme.LookupID = "IndemnityScheme";
			this.cboIndemnityScheme.Name = "cboIndemnityScheme";
			this.cboIndemnityScheme.Nullable = true;
			this.cboIndemnityScheme.TabIndex = 48;
			this.cboIndemnityScheme.Visible = false;
			// 
			// lblIndemnityScheme
			// 
			this.lblIndemnityScheme.Location = new System.Drawing.Point(20, 302);
			this.lblIndemnityScheme.Name = "lblIndemnityScheme";
			this.lblIndemnityScheme.Size = new System.Drawing.Size(100, 15);
			this.lblIndemnityScheme.TabIndex = 40;
			this.lblIndemnityScheme.Text = "Indemnity Scheme";
			this.lblIndemnityScheme.Visible = false;
			// 
			// txtIndemnityClaimed
			// 
			this.txtIndemnityClaimed.Location = new System.Drawing.Point(138, 323);
			this.txtIndemnityClaimed.Name = "txtIndemnityClaimed";
			this.txtIndemnityClaimed.Size = new System.Drawing.Size(104, 21);
			this.txtIndemnityClaimed.TabIndex = 50;
			this.txtIndemnityClaimed.Text = "";
			this.txtIndemnityClaimed.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtIndemnityClaimed.Visible = false;
			// 
			// lblIndemnityClaimed
			// 
			this.lblIndemnityClaimed.Location = new System.Drawing.Point(20, 325);
			this.lblIndemnityClaimed.Name = "lblIndemnityClaimed";
			this.lblIndemnityClaimed.Size = new System.Drawing.Size(104, 14);
			this.lblIndemnityClaimed.TabIndex = 38;
			this.lblIndemnityClaimed.Text = "Indemnity Claim";
			this.lblIndemnityClaimed.Visible = false;
			// 
			// txtWrittenOff
			// 
			this.txtWrittenOff.Location = new System.Drawing.Point(138, 376);
			this.txtWrittenOff.Name = "txtWrittenOff";
			this.txtWrittenOff.Size = new System.Drawing.Size(106, 21);
			this.txtWrittenOff.TabIndex = 54;
			this.txtWrittenOff.Text = "";
			this.txtWrittenOff.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblWrittenOff
			// 
			this.lblWrittenOff.Location = new System.Drawing.Point(10, 380);
			this.lblWrittenOff.Name = "lblWrittenOff";
			this.lblWrittenOff.Size = new System.Drawing.Size(108, 13);
			this.lblWrittenOff.TabIndex = 36;
			this.lblWrittenOff.Text = "Amount Written Off";
			// 
			// txtLossProvision
			// 
			this.txtLossProvision.Location = new System.Drawing.Point(138, 229);
			this.txtLossProvision.Name = "txtLossProvision";
			this.txtLossProvision.TabIndex = 46;
			this.txtLossProvision.Text = "";
			this.txtLossProvision.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblLossProvision
			// 
			this.lblLossProvision.Location = new System.Drawing.Point(20, 233);
			this.lblLossProvision.Name = "lblLossProvision";
			this.lblLossProvision.Size = new System.Drawing.Size(100, 13);
			this.lblLossProvision.TabIndex = 34;
			this.lblLossProvision.Text = "Loss Provision";
			// 
			// txtDeferredInterest
			// 
			this.txtDeferredInterest.Location = new System.Drawing.Point(138, 205);
			this.txtDeferredInterest.Name = "txtDeferredInterest";
			this.txtDeferredInterest.TabIndex = 45;
			this.txtDeferredInterest.Text = "";
			this.txtDeferredInterest.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblDeferredInterest
			// 
			this.lblDeferredInterest.Location = new System.Drawing.Point(20, 209);
			this.lblDeferredInterest.Name = "lblDeferredInterest";
			this.lblDeferredInterest.Size = new System.Drawing.Size(100, 13);
			this.lblDeferredInterest.TabIndex = 32;
			this.lblDeferredInterest.Text = "Deferred Interest";
			// 
			// txtDebtOnSale
			// 
			this.txtDebtOnSale.Location = new System.Drawing.Point(138, 181);
			this.txtDebtOnSale.Name = "txtDebtOnSale";
			this.txtDebtOnSale.TabIndex = 44;
			this.txtDebtOnSale.Text = "";
			this.txtDebtOnSale.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblDebtOnSale
			// 
			this.lblDebtOnSale.Location = new System.Drawing.Point(20, 185);
			this.lblDebtOnSale.Name = "lblDebtOnSale";
			this.lblDebtOnSale.Size = new System.Drawing.Size(100, 13);
			this.lblDebtOnSale.TabIndex = 30;
			this.lblDebtOnSale.Text = "Debt On Sale";
			// 
			// lblSalePrice
			// 
			this.lblSalePrice.Location = new System.Drawing.Point(262, 161);
			this.lblSalePrice.Name = "lblSalePrice";
			this.lblSalePrice.Size = new System.Drawing.Size(53, 13);
			this.lblSalePrice.TabIndex = 29;
			this.lblSalePrice.Text = "Sale Price";
			// 
			// dtpDateSold
			// 
			this.dtpDateSold.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpDateSold.Location = new System.Drawing.Point(138, 157);
			this.dtpDateSold.Name = "dtpDateSold";
			this.dtpDateSold.ShowCheckBox = true;
			this.dtpDateSold.Size = new System.Drawing.Size(118, 21);
			this.dtpDateSold.TabIndex = 32;
			// 
			// txtSalePrice
			// 
			this.txtSalePrice.Location = new System.Drawing.Point(318, 157);
			this.txtSalePrice.Name = "txtSalePrice";
			this.txtSalePrice.Size = new System.Drawing.Size(83, 21);
			this.txtSalePrice.TabIndex = 43;
			this.txtSalePrice.Text = "";
			this.txtSalePrice.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			// 
			// lblDateSold
			// 
			this.lblDateSold.Location = new System.Drawing.Point(20, 161);
			this.lblDateSold.Name = "lblDateSold";
			this.lblDateSold.Size = new System.Drawing.Size(100, 13);
			this.lblDateSold.TabIndex = 26;
			this.lblDateSold.Text = "Date Sold";
			// 
			// dtpPayoutDate
			// 
			this.dtpPayoutDate.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpPayoutDate.Location = new System.Drawing.Point(138, 347);
			this.dtpPayoutDate.Name = "dtpPayoutDate";
			this.dtpPayoutDate.ShowCheckBox = true;
			this.dtpPayoutDate.Size = new System.Drawing.Size(121, 21);
			this.dtpPayoutDate.TabIndex = 52;
			this.dtpPayoutDate.Visible = false;
			// 
			// lblPayoutDate
			// 
			this.lblPayoutDate.Location = new System.Drawing.Point(20, 350);
			this.lblPayoutDate.Name = "lblPayoutDate";
			this.lblPayoutDate.Size = new System.Drawing.Size(100, 13);
			this.lblPayoutDate.TabIndex = 24;
			this.lblPayoutDate.Text = "Payout Date";
			this.lblPayoutDate.Visible = false;
			// 
			// txtIndemnityPayout
			// 
			this.txtIndemnityPayout.Location = new System.Drawing.Point(318, 347);
			this.txtIndemnityPayout.Name = "txtIndemnityPayout";
			this.txtIndemnityPayout.Size = new System.Drawing.Size(83, 21);
			this.txtIndemnityPayout.TabIndex = 53;
			this.txtIndemnityPayout.Text = "";
			this.txtIndemnityPayout.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtIndemnityPayout.Visible = false;
			// 
			// lblIndemnityPayout
			// 
			this.lblIndemnityPayout.Location = new System.Drawing.Point(263, 349);
			this.lblIndemnityPayout.Name = "lblIndemnityPayout";
			this.lblIndemnityPayout.Size = new System.Drawing.Size(42, 13);
			this.lblIndemnityPayout.TabIndex = 22;
			this.lblIndemnityPayout.Text = "Payout";
			this.lblIndemnityPayout.Visible = false;
			// 
			// txtIndemnityAmount
			// 
			this.txtIndemnityAmount.Location = new System.Drawing.Point(318, 299);
			this.txtIndemnityAmount.Name = "txtIndemnityAmount";
			this.txtIndemnityAmount.Size = new System.Drawing.Size(83, 21);
			this.txtIndemnityAmount.TabIndex = 49;
			this.txtIndemnityAmount.Text = "";
			this.txtIndemnityAmount.TextAlign = System.Windows.Forms.HorizontalAlignment.Right;
			this.txtIndemnityAmount.Visible = false;
			// 
			// lblIndemnityAmount
			// 
			this.lblIndemnityAmount.Location = new System.Drawing.Point(263, 303);
			this.lblIndemnityAmount.Name = "lblIndemnityAmount";
			this.lblIndemnityAmount.Size = new System.Drawing.Size(52, 13);
			this.lblIndemnityAmount.TabIndex = 17;
			this.lblIndemnityAmount.Text = "Cover";
			this.lblIndemnityAmount.Visible = false;
			// 
			// lblIndemnityCompany
			// 
			this.lblIndemnityCompany.Location = new System.Drawing.Point(20, 279);
			this.lblIndemnityCompany.Name = "lblIndemnityCompany";
			this.lblIndemnityCompany.Size = new System.Drawing.Size(109, 13);
			this.lblIndemnityCompany.TabIndex = 16;
			this.lblIndemnityCompany.Text = "Indemnity Company";
			this.lblIndemnityCompany.Visible = false;
			// 
			// cboIndemnityCompany
			// 
			this.cboIndemnityCompany.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.IndemnityCo"));
			this.cboIndemnityCompany.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboIndemnityCompany.Location = new System.Drawing.Point(138, 275);
			this.cboIndemnityCompany.Name = "cboIndemnityCompany";
			this.cboIndemnityCompany.TabIndex = 47;
			this.cboIndemnityCompany.ValidForCreditor = false;
			this.cboIndemnityCompany.ValidForEmployer = false;
			this.cboIndemnityCompany.ValidForEndowmentCompany = false;
			this.cboIndemnityCompany.ValidForEstateAgent = false;
			this.cboIndemnityCompany.ValidForHousingAssociation = false;
			this.cboIndemnityCompany.ValidForIndemnityCompany = true;
			this.cboIndemnityCompany.ValidForInvoiceSource = false;
			this.cboIndemnityCompany.ValidForSecondCharge = false;
			this.cboIndemnityCompany.ValidForValuer = false;
			this.cboIndemnityCompany.Visible = false;
			this.cboIndemnityCompany.zDataBound = true;
			this.cboIndemnityCompany.ListUpdated += new System.EventHandler(this.cboIndemnityCompany_ListUpdated);
			// 
			// chkIndemnityInsurance
			// 
			this.chkIndemnityInsurance.CheckAlign = System.Drawing.ContentAlignment.MiddleRight;
			this.chkIndemnityInsurance.DataBindings.Add(new System.Windows.Forms.Binding("Checked", this.dsCases1, "Cases.IndemnityInsurance"));
			this.chkIndemnityInsurance.Location = new System.Drawing.Point(10, 257);
			this.chkIndemnityInsurance.Name = "chkIndemnityInsurance";
			this.chkIndemnityInsurance.Size = new System.Drawing.Size(142, 14);
			this.chkIndemnityInsurance.TabIndex = 46;
			this.chkIndemnityInsurance.Text = "Indemnity Insurance?";
			this.chkIndemnityInsurance.CheckedChanged += new System.EventHandler(this.chkIndemnityInsurance_CheckedChanged);
			// 
			// cmdMarketPriceHistory
			// 
			this.cmdMarketPriceHistory.Location = new System.Drawing.Point(352, 134);
			this.cmdMarketPriceHistory.Name = "cmdMarketPriceHistory";
			this.cmdMarketPriceHistory.Size = new System.Drawing.Size(49, 19);
			this.cmdMarketPriceHistory.TabIndex = 41;
			this.cmdMarketPriceHistory.Text = "Update ";
			this.cmdMarketPriceHistory.Click += new System.EventHandler(this.cmdMarketPriceHistory_Click);
			// 
			// lblMarketPriceDate
			// 
			this.lblMarketPriceDate.Font = new System.Drawing.Font("Tahoma", 11F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.World, ((System.Byte)(0)));
			this.lblMarketPriceDate.Location = new System.Drawing.Point(278, 133);
			this.lblMarketPriceDate.Name = "lblMarketPriceDate";
			this.lblMarketPriceDate.Size = new System.Drawing.Size(67, 19);
			this.lblMarketPriceDate.TabIndex = 12;
			this.lblMarketPriceDate.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblMarketPriceAsAt
			// 
			this.lblMarketPriceAsAt.Location = new System.Drawing.Point(243, 135);
			this.lblMarketPriceAsAt.Name = "lblMarketPriceAsAt";
			this.lblMarketPriceAsAt.Size = new System.Drawing.Size(35, 16);
			this.lblMarketPriceAsAt.TabIndex = 11;
			this.lblMarketPriceAsAt.Text = "As At";
			// 
			// lblMarketPriceLabel
			// 
			this.lblMarketPriceLabel.Location = new System.Drawing.Point(20, 137);
			this.lblMarketPriceLabel.Name = "lblMarketPriceLabel";
			this.lblMarketPriceLabel.Size = new System.Drawing.Size(100, 13);
			this.lblMarketPriceLabel.TabIndex = 9;
			this.lblMarketPriceLabel.Text = "Market Price";
			// 
			// lblDateMarketed
			// 
			this.lblDateMarketed.Location = new System.Drawing.Point(20, 113);
			this.lblDateMarketed.Name = "lblDateMarketed";
			this.lblDateMarketed.Size = new System.Drawing.Size(100, 13);
			this.lblDateMarketed.TabIndex = 8;
			this.lblDateMarketed.Text = "Date Marketed";
			// 
			// lblDateInstructed
			// 
			this.lblDateInstructed.Location = new System.Drawing.Point(20, 89);
			this.lblDateInstructed.Name = "lblDateInstructed";
			this.lblDateInstructed.Size = new System.Drawing.Size(100, 13);
			this.lblDateInstructed.TabIndex = 7;
			this.lblDateInstructed.Text = "Date Instructed";
			// 
			// dtpDateMarketed
			// 
			this.dtpDateMarketed.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpDateMarketed.Location = new System.Drawing.Point(138, 109);
			this.dtpDateMarketed.Name = "dtpDateMarketed";
			this.dtpDateMarketed.ShowCheckBox = true;
			this.dtpDateMarketed.Size = new System.Drawing.Size(118, 21);
			this.dtpDateMarketed.TabIndex = 40;
			// 
			// dtpDateInstructed
			// 
			this.dtpDateInstructed.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpDateInstructed.Location = new System.Drawing.Point(138, 85);
			this.dtpDateInstructed.Name = "dtpDateInstructed";
			this.dtpDateInstructed.ShowCheckBox = true;
			this.dtpDateInstructed.Size = new System.Drawing.Size(118, 21);
			this.dtpDateInstructed.TabIndex = 39;
			// 
			// cboEstateAgent
			// 
			this.cboEstateAgent.DataBindings.Add(new System.Windows.Forms.Binding("SelectedValue", this.dsCases1, "Cases.EstateAgent"));
			this.cboEstateAgent.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.cboEstateAgent.Location = new System.Drawing.Point(138, 61);
			this.cboEstateAgent.Name = "cboEstateAgent";
			this.cboEstateAgent.Size = new System.Drawing.Size(118, 21);
			this.cboEstateAgent.TabIndex = 38;
			this.cboEstateAgent.ValidForCreditor = false;
			this.cboEstateAgent.ValidForEmployer = false;
			this.cboEstateAgent.ValidForEndowmentCompany = false;
			this.cboEstateAgent.ValidForEstateAgent = true;
			this.cboEstateAgent.ValidForHousingAssociation = false;
			this.cboEstateAgent.ValidForIndemnityCompany = false;
			this.cboEstateAgent.ValidForInvoiceSource = false;
			this.cboEstateAgent.ValidForSecondCharge = false;
			this.cboEstateAgent.ValidForValuer = false;
			this.cboEstateAgent.zDataBound = true;
			this.cboEstateAgent.ListUpdated += new System.EventHandler(this.cboEstateAgent_ListUpdated);
			// 
			// lblEstateAgent
			// 
			this.lblEstateAgent.Location = new System.Drawing.Point(20, 65);
			this.lblEstateAgent.Name = "lblEstateAgent";
			this.lblEstateAgent.Size = new System.Drawing.Size(100, 13);
			this.lblEstateAgent.TabIndex = 3;
			this.lblEstateAgent.Text = "Estate Agent";
			// 
			// dtpPossessionDate
			// 
			this.dtpPossessionDate.Format = System.Windows.Forms.DateTimePickerFormat.Short;
			this.dtpPossessionDate.Location = new System.Drawing.Point(138, 36);
			this.dtpPossessionDate.Name = "dtpPossessionDate";
			this.dtpPossessionDate.ShowCheckBox = true;
			this.dtpPossessionDate.Size = new System.Drawing.Size(118, 21);
			this.dtpPossessionDate.TabIndex = 37;
			this.dtpPossessionDate.ValueChanged += new System.EventHandler(this.dtpPossessionDate_ValueChanged);
			// 
			// lblPossessionDate
			// 
			this.lblPossessionDate.Location = new System.Drawing.Point(11, 40);
			this.lblPossessionDate.Name = "lblPossessionDate";
			this.lblPossessionDate.Size = new System.Drawing.Size(85, 14);
			this.lblPossessionDate.TabIndex = 1;
			this.lblPossessionDate.Text = "Possession Date";
			// 
			// tabOther
			// 
			this.tabOther.Controls.AddRange(new System.Windows.Forms.Control[] {
																				   this.panel2});
			this.tabOther.Location = new System.Drawing.Point(0, 25);
			this.tabOther.Name = "tabOther";
			this.tabOther.Selected = false;
			this.tabOther.Size = new System.Drawing.Size(496, 435);
			this.tabOther.TabIndex = 6;
			this.tabOther.TabStop = true;
			this.tabOther.Title = "Other";
			// 
			// panel2
			// 
			this.panel2.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel2.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.lvwOther,
																				 this.splitter3,
																				 this.tvwOther});
			this.panel2.Location = new System.Drawing.Point(7, 8);
			this.panel2.Name = "panel2";
			this.panel2.Size = new System.Drawing.Size(483, 421);
			this.panel2.TabIndex = 0;
			// 
			// lvwOther
			// 
			this.lvwOther.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.lvwOther.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.lvwOther.CheckBookLookEnabled = false;
			this.lvwOther.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.lvwOther.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.lvwOther.Dock = System.Windows.Forms.DockStyle.Fill;
			this.lvwOther.FullRowSelect = true;
			this.lvwOther.HeaderColor = System.Drawing.Color.Empty;
			this.lvwOther.HeaderImageList = null;
			this.lvwOther.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.lvwOther.Location = new System.Drawing.Point(0, 255);
			this.lvwOther.MultiSelect = false;
			this.lvwOther.Name = "lvwOther";
			this.lvwOther.PaintSortedColumnBackground = true;
			this.lvwOther.Size = new System.Drawing.Size(483, 166);
			this.lvwOther.SortingEnabled = true;
			this.lvwOther.SortOrder = System.Windows.Forms.SortOrder.Ascending;
			this.lvwOther.TabIndex = 57;
			this.lvwOther.Tag = "OTHER";
			this.lvwOther.View = System.Windows.Forms.View.Details;
			this.lvwOther.MouseUp += new System.Windows.Forms.MouseEventHandler(this.lvwBorrowers_MouseUp);
			// 
			// splitter3
			// 
			this.splitter3.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter3.Location = new System.Drawing.Point(0, 252);
			this.splitter3.Name = "splitter3";
			this.splitter3.Size = new System.Drawing.Size(483, 3);
			this.splitter3.TabIndex = 1;
			this.splitter3.TabStop = false;
			// 
			// tvwOther
			// 
			this.tvwOther.Dock = System.Windows.Forms.DockStyle.Top;
			this.tvwOther.HideSelection = false;
			this.tvwOther.ImageList = this.imagesTreeView;
			this.tvwOther.Name = "tvwOther";
			this.tvwOther.Size = new System.Drawing.Size(483, 252);
			this.tvwOther.TabIndex = 56;
			this.tvwOther.MouseUp += new System.Windows.Forms.MouseEventHandler(this.tvwOther_MouseUp);
			this.tvwOther.AfterSelect += new System.Windows.Forms.TreeViewEventHandler(this.tvwOther_AfterSelect);
			// 
			// imagesTreeView
			// 
			this.imagesTreeView.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
			this.imagesTreeView.ImageSize = new System.Drawing.Size(16, 16);
			this.imagesTreeView.ImageStream = ((System.Windows.Forms.ImageListStreamer)(resources.GetObject("imagesTreeView.ImageStream")));
			this.imagesTreeView.TransparentColor = System.Drawing.Color.Transparent;
			// 
			// tabJournal
			// 
			this.tabJournal.Controls.AddRange(new System.Windows.Forms.Control[] {
																					 this.panel3});
			this.tabJournal.Location = new System.Drawing.Point(0, 25);
			this.tabJournal.Name = "tabJournal";
			this.tabJournal.Selected = false;
			this.tabJournal.Size = new System.Drawing.Size(496, 435);
			this.tabJournal.TabIndex = 7;
			this.tabJournal.TabStop = true;
			this.tabJournal.Title = "Diary/Journal & Notes";
			// 
			// panel3
			// 
			this.panel3.Anchor = (((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right);
			this.panel3.Controls.AddRange(new System.Windows.Forms.Control[] {
																				 this.diaryCase,
																				 this.splitter4,
																				 this.txtNotes,
																				 this.label1});
			this.panel3.Location = new System.Drawing.Point(5, 6);
			this.panel3.Name = "panel3";
			this.panel3.Size = new System.Drawing.Size(485, 423);
			this.panel3.TabIndex = 0;
			// 
			// diaryCase
			// 
			this.diaryCase.AllowDrop = true;
			this.diaryCase.CheckBookEvenRowBackColor = System.Drawing.Color.Empty;
			this.diaryCase.CheckBookEvenRowForeColor = System.Drawing.Color.Empty;
			this.diaryCase.CheckBookLookEnabled = false;
			this.diaryCase.CheckBookOddRowBackColor = System.Drawing.Color.Empty;
			this.diaryCase.CheckBookOddRowForeColor = System.Drawing.Color.Empty;
			this.diaryCase.Dock = System.Windows.Forms.DockStyle.Fill;
			this.diaryCase.FullRowSelect = true;
			this.diaryCase.HeaderColor = System.Drawing.Color.Empty;
			this.diaryCase.HeaderImageList = null;
			this.diaryCase.HeaderStyle = System.Windows.Forms.ColumnHeaderStyle.Nonclickable;
			this.diaryCase.Location = new System.Drawing.Point(0, 177);
			this.diaryCase.MultiSelect = false;
			this.diaryCase.Name = "diaryCase";
			this.diaryCase.PaintSortedColumnBackground = true;
			this.diaryCase.PendingEntriesOnly = false;
			this.diaryCase.Size = new System.Drawing.Size(485, 246);
			this.diaryCase.Sorting = System.Windows.Forms.SortOrder.Descending;
			this.diaryCase.SortingEnabled = true;
			this.diaryCase.SortOrder = System.Windows.Forms.SortOrder.Descending;
			this.diaryCase.TabIndex = 59;
			this.diaryCase.View = System.Windows.Forms.View.Details;
			// 
			// splitter4
			// 
			this.splitter4.Dock = System.Windows.Forms.DockStyle.Top;
			this.splitter4.Location = new System.Drawing.Point(0, 174);
			this.splitter4.Name = "splitter4";
			this.splitter4.Size = new System.Drawing.Size(485, 3);
			this.splitter4.TabIndex = 2;
			this.splitter4.TabStop = false;
			// 
			// txtNotes
			// 
			this.txtNotes.DataBindings.Add(new System.Windows.Forms.Binding("Text", this.dsCases1, "Cases.Notes"));
			this.txtNotes.Dock = System.Windows.Forms.DockStyle.Top;
			this.txtNotes.Location = new System.Drawing.Point(0, 18);
			this.txtNotes.Multiline = true;
			this.txtNotes.Name = "txtNotes";
			this.txtNotes.Size = new System.Drawing.Size(485, 156);
			this.txtNotes.TabIndex = 58;
			this.txtNotes.Text = "";
			// 
			// label1
			// 
			this.label1.Dock = System.Windows.Forms.DockStyle.Top;
			this.label1.Name = "label1";
			this.label1.Size = new System.Drawing.Size(485, 18);
			this.label1.TabIndex = 0;
			this.label1.Text = "Notes";
			// 
			// tbarMain
			// 
			this.tbarMain.BarType = UtilityLibrary.CommandBars.BarType.ToolBar;
			this.tbarMain.Dock = System.Windows.Forms.DockStyle.Top;
			this.tbarMain.ImageList = null;
			this.tbarMain.Location = new System.Drawing.Point(0, 25);
			this.tbarMain.Name = "tbarMain";
			this.tbarMain.Size = new System.Drawing.Size(741, 0);
			this.tbarMain.TabIndex = 8;
			this.tbarMain.TabStop = false;
			// 
			// daCases
			// 
			this.daCases.DeleteCommand = this.cmdDeleteCases;
			this.daCases.InsertCommand = this.cmdInsertCases;
			this.daCases.SelectCommand = this.cmdSelectCases;
			this.daCases.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																							  new System.Data.Common.DataTableMapping("Table", "Cases", new System.Data.Common.DataColumnMapping[] {
																																																	   new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																	   new System.Data.Common.DataColumnMapping("AccountNumber", "AccountNumber"),
																																																	   new System.Data.Common.DataColumnMapping("AccountTitle", "AccountTitle"),
																																																	   new System.Data.Common.DataColumnMapping("AccountSalutation", "AccountSalutation"),
																																																	   new System.Data.Common.DataColumnMapping("BranchRef", "BranchRef"),
																																																	   new System.Data.Common.DataColumnMapping("PropertyAddress", "PropertyAddress"),
																																																	   new System.Data.Common.DataColumnMapping("PropertyPostCode", "PropertyPostCode"),
																																																	   new System.Data.Common.DataColumnMapping("PropertyType", "PropertyType"),
																																																	   new System.Data.Common.DataColumnMapping("PropertyTelephone", "PropertyTelephone"),
																																																	   new System.Data.Common.DataColumnMapping("LastContactDate", "LastContactDate"),
																																																	   new System.Data.Common.DataColumnMapping("Degree", "Degree"),
																																																	   new System.Data.Common.DataColumnMapping("DegreeDate", "DegreeDate"),
																																																	   new System.Data.Common.DataColumnMapping("AmountOfArrears", "AmountOfArrears"),
																																																	   new System.Data.Common.DataColumnMapping("CauseOfArrears", "CauseOfArrears"),
																																																	   new System.Data.Common.DataColumnMapping("BancruptcyOrder", "BancruptcyOrder"),
																																																	   new System.Data.Common.DataColumnMapping("OtherDebts", "OtherDebts"),
																																																	   new System.Data.Common.DataColumnMapping("PaymentProtection", "PaymentProtection"),
																																																	   new System.Data.Common.DataColumnMapping("WithinEarlyRepaymentPeriod", "WithinEarlyRepaymentPeriod"),
																																																	   new System.Data.Common.DataColumnMapping("CapitalBalance", "CapitalBalance"),
																																																	   new System.Data.Common.DataColumnMapping("CapitalBalanceDate", "CapitalBalanceDate"),
																																																	   new System.Data.Common.DataColumnMapping("PaymentAmount", "PaymentAmount"),
																																																	   new System.Data.Common.DataColumnMapping("PaymentAmountDate", "PaymentAmountDate"),
																																																	   new System.Data.Common.DataColumnMapping("DSS", "DSS"),
																																																	   new System.Data.Common.DataColumnMapping("WeeklyDSS", "WeeklyDSS"),
																																																	   new System.Data.Common.DataColumnMapping("SharedOwnership", "SharedOwnership"),
																																																	   new System.Data.Common.DataColumnMapping("HousingAssociation", "HousingAssociation"),
																																																	   new System.Data.Common.DataColumnMapping("PercentageAdvance", "PercentageAdvance"),
																																																	   new System.Data.Common.DataColumnMapping("PercentageShare", "PercentageShare"),
																																																	   new System.Data.Common.DataColumnMapping("PossessionOrder", "PossessionOrder"),
																																																	   new System.Data.Common.DataColumnMapping("PossessionDate", "PossessionDate"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityInsurance", "IndemnityInsurance"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityCo", "IndemnityCo"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityScheme", "IndemnityScheme"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityAmount", "IndemnityAmount"),
																																																	   new System.Data.Common.DataColumnMapping("EstateAgent", "EstateAgent"),
																																																	   new System.Data.Common.DataColumnMapping("DateInstructed", "DateInstructed"),
																																																	   new System.Data.Common.DataColumnMapping("DateMarketed", "DateMarketed"),
																																																	   new System.Data.Common.DataColumnMapping("MarketPrice", "MarketPrice"),
																																																	   new System.Data.Common.DataColumnMapping("MarketPriceDate", "MarketPriceDate"),
																																																	   new System.Data.Common.DataColumnMapping("DateSold", "DateSold"),
																																																	   new System.Data.Common.DataColumnMapping("SalePrice", "SalePrice"),
																																																	   new System.Data.Common.DataColumnMapping("DebtOnSale", "DebtOnSale"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityClaimed", "IndemnityClaimed"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityPayout", "IndemnityPayout"),
																																																	   new System.Data.Common.DataColumnMapping("IndemnityPayoutDate", "IndemnityPayoutDate"),
																																																	   new System.Data.Common.DataColumnMapping("AmountWrittenOff", "AmountWrittenOff"),
																																																	   new System.Data.Common.DataColumnMapping("DeferredInterest", "DeferredInterest"),
																																																	   new System.Data.Common.DataColumnMapping("ManualProvision", "ManualProvision"),
																																																	   new System.Data.Common.DataColumnMapping("Provision", "Provision"),
																																																	   new System.Data.Common.DataColumnMapping("Created", "Created"),
																																																	   new System.Data.Common.DataColumnMapping("CreateUser", "CreateUser"),
																																																	   new System.Data.Common.DataColumnMapping("LastUpdated", "LastUpdated"),
																																																	   new System.Data.Common.DataColumnMapping("LastUser", "LastUser"),
																																																	   new System.Data.Common.DataColumnMapping("Notes", "Notes")})});
			this.daCases.UpdateCommand = this.cmdUpdateCases;
			this.daCases.RowUpdated += new System.Data.OleDb.OleDbRowUpdatedEventHandler(this.daCases_RowUpdated);
			// 
			// cmdDeleteCases
			// 
			this.cmdDeleteCases.CommandText = "DELETE FROM Cases WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND " +
				"? IS NULL)";
			this.cmdDeleteCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.cmdDeleteCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.cmdDeleteCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Orig_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// cmdInsertCases
			// 
			this.cmdInsertCases.CommandText = @"INSERT INTO Cases (AccountNumber, AccountSalutation, AccountTitle, AmountOfArrears, AmountWrittenOff, BancruptcyOrder, BranchRef, CapitalBalance, CapitalBalanceDate, CauseOfArrears, Created, CreateUser, DateInstructed, DateMarketed, DateSold, DebtOnSale, DeferredInterest, Degree, DegreeDate, DSS, EstateAgent, HousingAssociation, IndemnityAmount, IndemnityClaimed, IndemnityCo, IndemnityInsurance, IndemnityPayout, IndemnityPayoutDate, IndemnityScheme, LastContactDate, LastUpdated, LastUser, ManualProvision, MarketPrice, MarketPriceDate, Notes, OtherDebts, PaymentAmount, PaymentAmountDate, PaymentProtection, PercentageAdvance, PercentageShare, PossessionDate, PossessionOrder, PropertyAddress, PropertyPostCode, PropertyTelephone, PropertyType, Provision, SalePrice, SharedOwnership, WeeklyDSS, WithinEarlyRepaymentPeriod, Archived, IndemnityClaimDate) VALUES (?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?, ?)";
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountNumber", System.Data.OleDb.OleDbType.VarWChar, 8, "AccountNumber"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountSalutation", System.Data.OleDb.OleDbType.VarWChar, 50, "AccountSalutation"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountTitle", System.Data.OleDb.OleDbType.VarWChar, 50, "AccountTitle"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountOfArrears", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountOfArrears", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountWrittenOff", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountWrittenOff", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("BancruptcyOrder", System.Data.OleDb.OleDbType.Boolean, 2, "BancruptcyOrder"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("BranchRef", System.Data.OleDb.OleDbType.VarWChar, 5, "BranchRef"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CapitalBalance", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "CapitalBalance", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CapitalBalanceDate", System.Data.OleDb.OleDbType.DBDate, 0, "CapitalBalanceDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CauseOfArrears", System.Data.OleDb.OleDbType.VarWChar, 20, "CauseOfArrears"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateInstructed", System.Data.OleDb.OleDbType.DBDate, 0, "DateInstructed"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateMarketed", System.Data.OleDb.OleDbType.DBDate, 0, "DateMarketed"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateSold", System.Data.OleDb.OleDbType.DBDate, 0, "DateSold"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DebtOnSale", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "DebtOnSale", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DeferredInterest", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "DeferredInterest", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Degree", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Degree", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DegreeDate", System.Data.OleDb.OleDbType.DBDate, 0, "DegreeDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DSS", System.Data.OleDb.OleDbType.Boolean, 2, "DSS"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("EstateAgent", System.Data.OleDb.OleDbType.VarWChar, 10, "EstateAgent"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("HousingAssociation", System.Data.OleDb.OleDbType.VarWChar, 10, "HousingAssociation"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityAmount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityAmount", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityClaimed", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityClaimed", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityCo", System.Data.OleDb.OleDbType.VarWChar, 10, "IndemnityCo"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityInsurance", System.Data.OleDb.OleDbType.Boolean, 2, "IndemnityInsurance"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityPayout", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityPayout", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityPayoutDate", System.Data.OleDb.OleDbType.DBDate, 0, "IndemnityPayoutDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityScheme", System.Data.OleDb.OleDbType.VarWChar, 10, "IndemnityScheme"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastContactDate", System.Data.OleDb.OleDbType.DBDate, 0, "LastContactDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("ManualProvision", System.Data.OleDb.OleDbType.Boolean, 2, "ManualProvision"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("MarketPrice", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "MarketPrice", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("MarketPriceDate", System.Data.OleDb.OleDbType.DBDate, 0, "MarketPriceDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("OtherDebts", System.Data.OleDb.OleDbType.Boolean, 2, "OtherDebts"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentAmount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "PaymentAmount", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentAmountDate", System.Data.OleDb.OleDbType.DBDate, 0, "PaymentAmountDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentProtection", System.Data.OleDb.OleDbType.Boolean, 2, "PaymentProtection"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PercentageAdvance", System.Data.OleDb.OleDbType.Single, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(7)), ((System.Byte)(0)), "PercentageAdvance", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PercentageShare", System.Data.OleDb.OleDbType.Single, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(7)), ((System.Byte)(0)), "PercentageShare", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PossessionDate", System.Data.OleDb.OleDbType.DBDate, 0, "PossessionDate"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PossessionOrder", System.Data.OleDb.OleDbType.VarWChar, 12, "PossessionOrder"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyAddress", System.Data.OleDb.OleDbType.VarWChar, 255, "PropertyAddress"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyPostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PropertyPostCode"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyTelephone", System.Data.OleDb.OleDbType.VarWChar, 20, "PropertyTelephone"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyType", System.Data.OleDb.OleDbType.VarWChar, 1, "PropertyType"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Provision", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Provision", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("SalePrice", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "SalePrice", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("SharedOwnership", System.Data.OleDb.OleDbType.Boolean, 2, "SharedOwnership"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("WeeklyDSS", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "WeeklyDSS", System.Data.DataRowVersion.Current, null));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("WithinEarlyRepaymentPeriod", System.Data.OleDb.OleDbType.Boolean, 2, "WithinEarlyRepaymentPeriod"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Archived", System.Data.OleDb.OleDbType.Boolean, 2, "Archived"));
			this.cmdInsertCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityClaimDate", System.Data.OleDb.OleDbType.DBDate, 0, "IndemnityClaimDate"));
			// 
			// cmdSelectCases
			// 
			this.cmdSelectCases.CommandText = @"SELECT AccountNumber, AccountSalutation, AccountTitle, AmountOfArrears, AmountWrittenOff, BancruptcyOrder, BranchRef, CapitalBalance, CapitalBalanceDate, CauseOfArrears, Created, CreateUser, DateInstructed, DateMarketed, DateSold, DebtOnSale, DeferredInterest, Degree, DegreeDate, DSS, EstateAgent, HousingAssociation, ID, IndemnityAmount, IndemnityClaimed, IndemnityCo, IndemnityInsurance, IndemnityPayout, IndemnityPayoutDate, IndemnityScheme, LastContactDate, LastUpdated, LastUser, ManualProvision, MarketPrice, MarketPriceDate, Notes, OtherDebts, PaymentAmount, PaymentAmountDate, PaymentProtection, PercentageAdvance, PercentageShare, PossessionDate, PossessionOrder, PropertyAddress, PropertyPostCode, PropertyTelephone, PropertyType, Provision, SalePrice, SharedOwnership, WeeklyDSS, WithinEarlyRepaymentPeriod, Archived, IndemnityClaimDate FROM Cases WHERE (ID = ?)";
			this.cmdSelectCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Current, null));
			// 
			// cmdUpdateCases
			// 
			this.cmdUpdateCases.CommandText = @"UPDATE Cases SET AccountNumber = ?, AccountSalutation = ?, AccountTitle = ?, AmountOfArrears = ?, AmountWrittenOff = ?, BancruptcyOrder = ?, BranchRef = ?, CapitalBalance = ?, CapitalBalanceDate = ?, CauseOfArrears = ?, Created = ?, CreateUser = ?, DateInstructed = ?, DateMarketed = ?, DateSold = ?, DebtOnSale = ?, DeferredInterest = ?, Degree = ?, DegreeDate = ?, DSS = ?, EstateAgent = ?, HousingAssociation = ?, IndemnityAmount = ?, IndemnityClaimed = ?, IndemnityCo = ?, IndemnityInsurance = ?, IndemnityPayout = ?, IndemnityPayoutDate = ?, IndemnityScheme = ?, LastContactDate = ?, LastUpdated = ?, LastUser = ?, ManualProvision = ?, MarketPrice = ?, MarketPriceDate = ?, Notes = ?, OtherDebts = ?, PaymentAmount = ?, PaymentAmountDate = ?, PaymentProtection = ?, PercentageAdvance = ?, PercentageShare = ?, PossessionDate = ?, PossessionOrder = ?, PropertyAddress = ?, PropertyPostCode = ?, PropertyTelephone = ?, PropertyType = ?, Provision = ?, SalePrice = ?, SharedOwnership = ?, WeeklyDSS = ?, WithinEarlyRepaymentPeriod = ?, Archived = ?, IndemnityClaimDate = ? WHERE (ID = ?) AND (LastUpdated = ? OR LastUpdated IS NULL AND ? IS NULL)";
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountNumber", System.Data.OleDb.OleDbType.VarWChar, 8, "AccountNumber"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountSalutation", System.Data.OleDb.OleDbType.VarWChar, 50, "AccountSalutation"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AccountTitle", System.Data.OleDb.OleDbType.VarWChar, 50, "AccountTitle"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountOfArrears", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountOfArrears", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("AmountWrittenOff", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "AmountWrittenOff", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("BancruptcyOrder", System.Data.OleDb.OleDbType.Boolean, 2, "BancruptcyOrder"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("BranchRef", System.Data.OleDb.OleDbType.VarWChar, 5, "BranchRef"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CapitalBalance", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "CapitalBalance", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CapitalBalanceDate", System.Data.OleDb.OleDbType.DBDate, 0, "CapitalBalanceDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CauseOfArrears", System.Data.OleDb.OleDbType.VarWChar, 20, "CauseOfArrears"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Created", System.Data.OleDb.OleDbType.DBDate, 0, "Created"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("CreateUser", System.Data.OleDb.OleDbType.VarWChar, 12, "CreateUser"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateInstructed", System.Data.OleDb.OleDbType.Date, 0, "DateInstructed"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateMarketed", System.Data.OleDb.OleDbType.Date, 0, "DateMarketed"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DateSold", System.Data.OleDb.OleDbType.Date, 0, "DateSold"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DebtOnSale", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "DebtOnSale", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DeferredInterest", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "DeferredInterest", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Degree", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "Degree", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DegreeDate", System.Data.OleDb.OleDbType.DBDate, 0, "DegreeDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("DSS", System.Data.OleDb.OleDbType.Boolean, 2, "DSS"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("EstateAgent", System.Data.OleDb.OleDbType.VarWChar, 10, "EstateAgent"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("HousingAssociation", System.Data.OleDb.OleDbType.VarWChar, 10, "HousingAssociation"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityAmount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityAmount", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityClaimed", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityClaimed", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityCo", System.Data.OleDb.OleDbType.VarWChar, 10, "IndemnityCo"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityInsurance", System.Data.OleDb.OleDbType.Boolean, 2, "IndemnityInsurance"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityPayout", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "IndemnityPayout", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityPayoutDate", System.Data.OleDb.OleDbType.Date, 0, "IndemnityPayoutDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityScheme", System.Data.OleDb.OleDbType.VarWChar, 10, "IndemnityScheme"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastContactDate", System.Data.OleDb.OleDbType.Date, 0, "LastContactDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date, 0, "LastUpdated"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar, 12, "LastUser"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("ManualProvision", System.Data.OleDb.OleDbType.Boolean, 2, "ManualProvision"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("MarketPrice", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "MarketPrice", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("MarketPriceDate", System.Data.OleDb.OleDbType.DBDate, 0, "MarketPriceDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Notes", System.Data.OleDb.OleDbType.VarWChar, 0, "Notes"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("OtherDebts", System.Data.OleDb.OleDbType.Boolean, 2, "OtherDebts"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentAmount", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "PaymentAmount", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentAmountDate", System.Data.OleDb.OleDbType.DBDate, 0, "PaymentAmountDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PaymentProtection", System.Data.OleDb.OleDbType.Boolean, 2, "PaymentProtection"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PercentageAdvance", System.Data.OleDb.OleDbType.Single, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(7)), ((System.Byte)(0)), "PercentageAdvance", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PercentageShare", System.Data.OleDb.OleDbType.Single, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(7)), ((System.Byte)(0)), "PercentageShare", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PossessionDate", System.Data.OleDb.OleDbType.Date, 0, "PossessionDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PossessionOrder", System.Data.OleDb.OleDbType.VarWChar, 12, "PossessionOrder"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyAddress", System.Data.OleDb.OleDbType.VarWChar, 255, "PropertyAddress"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyPostCode", System.Data.OleDb.OleDbType.VarWChar, 12, "PropertyPostCode"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyTelephone", System.Data.OleDb.OleDbType.VarWChar, 20, "PropertyTelephone"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("PropertyType", System.Data.OleDb.OleDbType.VarWChar, 1, "PropertyType"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Provision", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "Provision", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("SalePrice", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "SalePrice", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("SharedOwnership", System.Data.OleDb.OleDbType.Boolean, 2, "SharedOwnership"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("WeeklyDSS", System.Data.OleDb.OleDbType.Currency, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(19)), ((System.Byte)(0)), "WeeklyDSS", System.Data.DataRowVersion.Current, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("WithinEarlyRepaymentPeriod", System.Data.OleDb.OleDbType.Boolean, 2, "WithinEarlyRepaymentPeriod"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Archived", System.Data.OleDb.OleDbType.Boolean, 2, "Archived"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("IndemnityClaimDate", System.Data.OleDb.OleDbType.DBDate, 0, "IndemnityClaimDate"));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_ID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "ID", System.Data.DataRowVersion.Original, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Original_LastUpdated", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			this.cmdUpdateCases.Parameters.Add(new System.Data.OleDb.OleDbParameter("Param285", System.Data.OleDb.OleDbType.Date, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(0)), ((System.Byte)(0)), "LastUpdated", System.Data.DataRowVersion.Original, null));
			// 
			// daPersonLists
			// 
			this.daPersonLists.SelectCommand = this.oleDbSelectCommand1;
			this.daPersonLists.TableMappings.AddRange(new System.Data.Common.DataTableMapping[] {
																									new System.Data.Common.DataTableMapping("Table", "People", new System.Data.Common.DataColumnMapping[] {
																																																			  new System.Data.Common.DataColumnMapping("CaseID", "CaseID"),
																																																			  new System.Data.Common.DataColumnMapping("ID", "ID"),
																																																			  new System.Data.Common.DataColumnMapping("Initials", "Initials"),
																																																			  new System.Data.Common.DataColumnMapping("PersonType", "PersonType"),
																																																			  new System.Data.Common.DataColumnMapping("Surname", "Surname"),
																																																			  new System.Data.Common.DataColumnMapping("Title", "Title"),
																																																			  new System.Data.Common.DataColumnMapping("TelephoneWork", "TelephoneWork"),
																																																			  new System.Data.Common.DataColumnMapping("AddressAsProperty", "AddressAsProperty")})});
			// 
			// oleDbSelectCommand1
			// 
			this.oleDbSelectCommand1.CommandText = "SELECT CaseID, ID, Initials, PersonType, Surname, Title, TelephoneWork, AddressAs" +
				"Property, TelephoneHome FROM People WHERE (PersonType = ?) AND (CaseID = ?)";
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("PersonType", System.Data.OleDb.OleDbType.VarWChar, 1, "PersonType"));
			this.oleDbSelectCommand1.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			// 
			// mnuDelete
			// 
			this.mnuDelete.Description = "Delete";
			this.mnuDelete.Text = "&Delete";
			this.mnuDelete.Click += new System.EventHandler(this.mnuDelete_Click);
			// 
			// mnuEdit
			// 
			this.mnuEdit.Description = "Edit";
			this.mnuEdit.Text = "&Edit";
			this.mnuEdit.Click += new System.EventHandler(this.mnuEdit_Click);
			// 
			// mnuAdd
			// 
			this.mnuAdd.Description = "Add";
			this.mnuAdd.Text = "&Add New";
			this.mnuAdd.Click += new System.EventHandler(this.mnuAdd_Click);
			// 
			// mnuRefresh
			// 
			this.mnuRefresh.Description = "Refresh";
			this.mnuRefresh.Text = "&Refresh";
			this.mnuRefresh.Click += new System.EventHandler(this.mnuRefresh_Click);
			// 
			// label13
			// 
			this.label13.Dock = System.Windows.Forms.DockStyle.Fill;
			this.label13.Location = new System.Drawing.Point(245, 25);
			this.label13.Name = "label13";
			this.label13.Size = new System.Drawing.Size(496, 460);
			this.label13.TabIndex = 9;
			this.label13.Text = "No case selected.";
			this.label13.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// cmdSelectAccounts
			// 
			this.cmdSelectAccounts.CommandText = @"SELECT AccountTypeLookup.Description AS Type, LoanAccounts.AmountAdvanced, LoanAccounts.CaseID, LoanAccounts.StartDate, LoanAccounts.MaturityDate, LoanAccounts.ID FROM AccountTypeLookup RIGHT OUTER JOIN LoanAccounts ON AccountTypeLookup.ID = LoanAccounts.AccountType WHERE (LoanAccounts.CaseID = ?)";
			this.cmdSelectAccounts.Parameters.Add(new System.Data.OleDb.OleDbParameter("CaseID", System.Data.OleDb.OleDbType.Integer, 0, System.Data.ParameterDirection.Input, false, ((System.Byte)(10)), ((System.Byte)(0)), "CaseID", System.Data.DataRowVersion.Current, null));
			// 
			// cmdChangeArchiveStatus
			// 
			this.cmdChangeArchiveStatus.CommandText = "Update Cases Set Archived = ?, LastUpdated = ?, LastUser = ? Where ID = ?";
			this.cmdChangeArchiveStatus.Parameters.Add(new System.Data.OleDb.OleDbParameter("Archived", System.Data.OleDb.OleDbType.Boolean, 2));
			this.cmdChangeArchiveStatus.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUpdated", System.Data.OleDb.OleDbType.Date));
			this.cmdChangeArchiveStatus.Parameters.Add(new System.Data.OleDb.OleDbParameter("LastUser", System.Data.OleDb.OleDbType.VarWChar));
			this.cmdChangeArchiveStatus.Parameters.Add(new System.Data.OleDb.OleDbParameter("ID", System.Data.OleDb.OleDbType.Integer));
			// 
			// MainForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(741, 505);
			this.Controls.AddRange(new System.Windows.Forms.Control[] {
																		  this.tabsMain,
																		  this.label13,
																		  this.splitter2,
																		  this.panel1,
																		  this.tbarMain,
																		  this.mnuMain,
																		  this.sbarMain});
			this.Icon = ((System.Drawing.Icon)(resources.GetObject("$this.Icon")));
			this.Name = "MainForm";
			this.StartPosition = System.Windows.Forms.FormStartPosition.CenterScreen;
			this.Text = "V4 Solutions Arrears Manager";
			this.Closing += new System.ComponentModel.CancelEventHandler(this.MainForm_Closing);
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel1)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel3)).EndInit();
			((System.ComponentModel.ISupportInitialize)(this.sbarPanel2)).EndInit();
			this.panel1.ResumeLayout(false);
			this.tabsMenu.ResumeLayout(false);
			this.tabTree.ResumeLayout(false);
			this.tabFind.ResumeLayout(false);
			this.tabsMain.ResumeLayout(false);
			this.tabGeneral.ResumeLayout(false);
			this.panel4.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.dsCases1)).EndInit();
			this.tabsGeneral.ResumeLayout(false);
			this.tabBorrowers.ResumeLayout(false);
			this.tabGuaruntors.ResumeLayout(false);
			this.tabTenants.ResumeLayout(false);
			this.tabAccount.ResumeLayout(false);
			this.tabPossession.ResumeLayout(false);
			this.tabOther.ResumeLayout(false);
			this.panel2.ResumeLayout(false);
			this.tabJournal.ResumeLayout(false);
			this.panel3.ResumeLayout(false);
			this.ResumeLayout(false);

		}
		#endregion

		///
		///Toolbar Event Handlers
		///

		private void SetupToolbars()
		{
			//this.tbarMain.Items.Add(new ToolBarItem(imgsToolbar.Images[1],
			//	new EventHandler(Dummy_Click)));
		}
		private void Dummy_Click(object sender, System.EventArgs e)
		{
			frmOutputTest frm = new frmOutputTest();
			frm.ShowDialog();
			frm.Dispose();
		}

		///
		///Menu Functions
		///

		private void SetupMenus()
		{
			pm = new Crownwood.Magic.Menus.PopupMenu();
			pm.MenuCommands.Add(mnuAdd);
			pm.MenuCommands.Add(mnuEdit);
			pm.MenuCommands.Add(mnuDelete);
			pm.MenuCommands.Add(mnuRefresh);
		}
		private Int32 MenuSelection;
		private string MenuSelected;

		private void RefreshSelectedMenu()
		{
			switch (MenuSelected)
			{
				case "B":
					FillPeopleListView(lvwBorrowers);
					break;
				case "G":
					FillPeopleListView(lvwGuaruntors);
					break;
				case "T":
					FillPeopleListView(lvwTenants);
					break;
				case "ACC":
					FillAccountListView(lvwAccounts);
					break;
				case "OTHER":
				{		
					if (tvwOther.SelectedNode is OtherNode)
					{
						if (((OtherNode)tvwOther.SelectedNode).Manager!=null)
							((OtherNode)tvwOther.SelectedNode).Manager.FillList(lvwOther, CSession.CaseID);
						OtherNodes.UpdateNodeText((OtherNode)tvwOther.SelectedNode, CSession.CaseID);
					}
					break;
				}
			}
		}

		private void lvwBorrowers_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if( e.Button == MouseButtons.Right)
			{
				UtilityLibrary.WinControls.ListViewEx list = (UtilityLibrary.WinControls.ListViewEx) sender;
				MenuSelected = list.Tag.ToString();
				if (list.GetItemAt(e.X, e.Y)!=null)
				{
					mnuEdit.Visible = true;
					mnuDelete.Visible = true;					
					MenuSelection = (Int32)((ListViewItem)list.GetItemAt(e.X, e.Y)).Tag;
				}
				else
				{
					mnuEdit.Visible = false;
					mnuDelete.Visible = false;
					MenuSelection = 0;
				}
				if (MenuSelected == "OTHER")
				{
					if (tvwOther.SelectedNode is OtherNode)
					{
						if (((OtherNode)tvwOther.SelectedNode).Manager==null)
							return;
					}
					else
						return;
				}
				pm.TrackPopup(list.PointToScreen(new Point(e.X,e.Y)));
			}
		}
		private void tvwOther_MouseUp(object sender, System.Windows.Forms.MouseEventArgs e)
		{
			if(e.Button == MouseButtons.Right)
			{
				TreeNode x = tvwOther.GetNodeAt(e.X,e.Y);
				if (x!= null)
				{
					if (x != tvwOther.SelectedNode)
					{
						tvwOther.SelectedNode = x;
					}
				}
				if (tvwOther.SelectedNode is OtherNode)
				{
					if (((OtherNode)tvwOther.SelectedNode).Manager==null)
						return;
				}
				mnuEdit.Visible = false;
				mnuDelete.Visible = false;
				mnuAdd.Visible = true;
				MenuSelected = "OTHER";
				MenuSelection = 0;
				pm.TrackPopup(tvwOther.PointToScreen(new Point(e.X,e.Y)));
			}
		}

		private void mnuAdd_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID == 0)
				return;
			if (MenuSelected.Length == 1)
			{
				frmPerson frm = new frmPerson();
				frm.AddNew(CSession.CaseID, MenuSelected);
				frm.ShowDialog();
			}
			else if(MenuSelected == "ACC")
			{
				frmAccounts frm = new frmAccounts();
				frm.AddNew(CSession.CaseID);
				frm.ShowDialog();
			}
			else if(MenuSelected == "OTHER")
			{
				if (tvwOther.SelectedNode is OtherNode)
				{
					if (((OtherNode)tvwOther.SelectedNode).Manager!=null)
						((OtherNode)tvwOther.SelectedNode).Manager.Add(CSession.CaseID);
				}
			}			
			RefreshSelectedMenu();
		}

		private void mnuEdit_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID == 0)
				return;
			if (MenuSelected.Length == 1)
			{
				frmPerson frm = new frmPerson();
				frm.Edit(MenuSelection);
				frm.ShowDialog();
			}
			else if(MenuSelected == "ACC")
			{
				frmAccounts frm = new frmAccounts();
				frm.Edit(MenuSelection);
				frm.ShowDialog();
			}
			else if(MenuSelected == "OTHER")
			{
				if (tvwOther.SelectedNode is OtherNode)
				{
					if (((OtherNode)tvwOther.SelectedNode).Manager!=null)
						((OtherNode)tvwOther.SelectedNode).Manager.Edit(MenuSelection);
				}
			}
			
			RefreshSelectedMenu();
		}

		private void mnuDelete_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID == 0)
				return;
			if (MenuSelected.Length == 1)
			{		
				frmPerson frm = new frmPerson();
				frm.Delete(MenuSelection);
				frm.Dispose();
			}
			else if (MenuSelected == "ACC")
			{
				frmAccounts frm = new frmAccounts();
				frm.Delete(MenuSelection);
				frm.Dispose();
			}
			else if(MenuSelected == "OTHER")
			{
				if (tvwOther.SelectedNode is OtherNode)
				{
					if (((OtherNode)tvwOther.SelectedNode).Manager!=null)
						((OtherNode)tvwOther.SelectedNode).Manager.Delete(MenuSelection);
				}
			}			
			RefreshSelectedMenu();
		}

		private void mnuRefresh_Click(object sender, System.EventArgs e)
		{
			RefreshSelectedMenu();
		}

		///
		/// Binding Functions
		///

		private void SetupDateBindings()
		{
			dtpLastContact.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.LastContactDate"));
			dtpDateInstructed.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.DateInstructed"));
			dtpDateMarketed.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.DateMarketed"));
			dtpDateSold.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.DateSold"));
			dtpPayoutDate.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.IndemnityPayoutDate"));
			dtpPossessionDate.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.PossessionDate"));
			cboIndemnityClaimDate.DataBindings.Add(new DTPBinding("Checked", dsCases1, "Cases.IndemnityClaimDate"));			
		}
		
		private void chkSharedOwnership_CheckedChanged(object sender, System.EventArgs e)
		{
			if (chkSharedOwnership.Checked)
			{
				this.lblHousingAssociation.Visible = true;
				this.cboHousingAssociation.Visible = true;
				this.lblShare.Visible = true;
				this.txtShare.Visible = true;
			}
			else
			{
				this.lblHousingAssociation.Visible = false;
				this.cboHousingAssociation.Visible = false;
				this.lblShare.Visible = false;
				this.txtShare.Visible = false;
			}
		}

		private void chkDSS_CheckedChanged(object sender, System.EventArgs e)
		{
			if (chkDSS.Checked)
			{
				this.lblDSS.Visible = true;
				this.txtDSS.Visible = true;
			}
			else
			{
				this.lblDSS.Visible = false;
				this.txtDSS.Visible = false;
			}
		}

		private void chkIndemnityInsurance_CheckedChanged(object sender, System.EventArgs e)
		{
			if (chkIndemnityInsurance.Checked)
			{
				this.lblIndemnityCompany.Visible =			true;
				this.lblIndemnityScheme.Visible =			true;
				this.lblIndemnityAmount.Visible =			true;
				this.lblIndemnityClaimed.Visible =			true;
				this.lblIndemnityPayout.Visible =			true;
				this.lblPayoutDate.Visible =				true;
				this.cboIndemnityCompany.Visible =			true;
				this.cboIndemnityScheme.Visible =			true;
				this.txtIndemnityAmount.Visible =			true;
				this.txtIndemnityClaimed.Visible =			true;
				this.lblIndemnityClaimDate.Visible =		true;
				this.cboIndemnityClaimDate.Visible =		true;
				this.txtIndemnityPayout.Visible =			true;
				this.dtpPayoutDate.Visible =				true;
			}
			else
			{
				this.lblIndemnityCompany.Visible =			false;
				this.lblIndemnityScheme.Visible =			false;
				this.lblIndemnityAmount.Visible =			false;
				this.lblIndemnityClaimed.Visible =			false;
				this.lblIndemnityPayout.Visible =			false;
				this.lblPayoutDate.Visible =				false;
				this.cboIndemnityCompany.Visible =			false;
				this.cboIndemnityScheme.Visible =			false;
				this.txtIndemnityAmount.Visible =			false;
				this.txtIndemnityClaimed.Visible =			false;
				this.lblIndemnityClaimDate.Visible =		false;
				this.cboIndemnityClaimDate.Visible =		false;
				this.txtIndemnityPayout.Visible =			false;
				this.dtpPayoutDate.Visible =				false;
			}
		}

		private void SwitchPossessionDate(bool theValue)
		{
			if (theValue)
			{
				this.lblEstateAgent.Visible =				true;
				this.lblDateInstructed.Visible =			true;
				this.lblDateMarketed.Visible =				true;
				this.lblMarketPriceLabel.Visible =			true;
				this.lblMarketPriceAsAt.Visible =			true;
				this.lblMarketPriceDate.Visible =			true;
				this.lblDateSold.Visible =					true;
				this.lblSalePrice.Visible =					true;
				this.lblDebtOnSale.Visible =				true;
				this.lblDeferredInterest.Visible =			true;
				this.lblLossProvision.Visible =				true;
				this.cboEstateAgent.Visible =				true;
				this.dtpDateInstructed.Visible =			true;
				this.dtpDateMarketed.Visible =				true;
				this.lblMarketPrice.Visible =				true;
				this.dtpDateSold.Visible =					true;
				this.txtSalePrice.Visible =					true;
				this.txtDebtOnSale.Visible =				true;
				this.txtDeferredInterest.Visible =			true;
				this.txtLossProvision.Visible =				true;
				this.cmdMarketPriceHistory.Visible =		true;
			}
			else
			{
				this.lblEstateAgent.Visible =				false;
				this.lblDateInstructed.Visible =			false;
				this.lblDateMarketed.Visible =				false;
				this.lblMarketPriceLabel.Visible =			false;
				this.lblMarketPriceAsAt.Visible =			false;
				this.lblMarketPriceDate.Visible =			false;
				this.lblDateSold.Visible =					false;
				this.lblSalePrice.Visible =					false;
				this.lblDebtOnSale.Visible =				false;
				this.lblDeferredInterest.Visible =			false;
				this.lblLossProvision.Visible =				false;
				this.cboEstateAgent.Visible =				false;
				this.dtpDateInstructed.Visible =			false;
				this.dtpDateMarketed.Visible =				false;
				this.lblMarketPrice.Visible =				false;
				this.dtpDateSold.Visible =					false;
				this.txtSalePrice.Visible =					false;
				this.txtDebtOnSale.Visible =				false;
				this.txtDeferredInterest.Visible =			false;
				this.txtLossProvision.Visible =				false;
				this.cmdMarketPriceHistory.Visible =		false;
			}
		}

		private void dtpPossessionDate_ValueChanged(object sender, System.EventArgs e)
		{
			if (SupressValueEvent == false)
				SwitchPossessionDate(dtpPossessionDate.Checked);
		}

		private void tvwOther_AfterSelect(object sender, System.Windows.Forms.TreeViewEventArgs e)
		{
			if (tvwOther.SelectedNode is OtherNode)
			{
				OtherNode n = (OtherNode)tvwOther.SelectedNode;
				if (n.Manager!=null)
				{
					n.Manager.SetupColums(lvwOther);
					n.Manager.FillList(lvwOther,CSession.CaseID);
				}
				else
				{
					lvwOther.Clear();
				}
			}
			else
			{
				lvwOther.Clear();
			}
		}

		private void MainForm_Closing(object sender, System.ComponentModel.CancelEventArgs e)
		{
			if(!CloseCase())
				e.Cancel = true;
		}

		private void cmdBalanceHistory_Click(object sender, System.EventArgs e)
		{
			frmCapitalBalanceHistory frm = new frmCapitalBalanceHistory();
			frm.SetupForm(CSession.CaseID);
			frm.ShowDialog();
			try
			{
				ArrayList temp = cMyDB.GetFirstRow("Select CapitalBalance, AsAtDate From CapitalBalanceHistory Where CaseID = " + CSession.CaseID.ToString() + " AND AsAtDate = (Select Max(AsAtDate) From CapitalBalanceHistory Where CaseID = " + CSession.CaseID.ToString() + ")");
				if (temp.Count == 0)
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["CapitalBalance"] = DBNull.Value;
					dsCases1.Cases.Rows[0]["CapitalBalanceDate"] = DBNull.Value;
					dsCases1.Cases.Rows[0].EndEdit();
				}
				else
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["CapitalBalance"] = temp[0];
					dsCases1.Cases.Rows[0]["CapitalBalanceDate"] = temp[1];
					dsCases1.Cases.Rows[0].EndEdit();
				}
			}
			catch	{}
			finally
			{
				frm.Dispose();
			}
		}

		private void cmdDegreeHistory_Click(object sender, System.EventArgs e)
		{
			frmDegreeHistory frm = new frmDegreeHistory();
			frm.SetupForm(CSession.CaseID);
			frm.ShowDialog();
			try
			{
				ArrayList temp = cMyDB.GetFirstRow("Select Degree, AsAtDate From ArrearsHistory Where CaseID = " + CSession.CaseID.ToString() + " AND AsAtDate = (Select Max(AsAtDate) From ArrearsHistory Where CaseID = " + CSession.CaseID.ToString() + ")");
				if (temp.Count == 0)
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["Degree"] = DBNull.Value;
					dsCases1.Cases.Rows[0]["DegreeDate"] = DBNull.Value;
					dsCases1.Cases.Rows[0].EndEdit();
				}
				else
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["Degree"] = temp[0];
					dsCases1.Cases.Rows[0]["DegreeDate"] = temp[1];
					dsCases1.Cases.Rows[0].EndEdit();
				}
			}
			catch	{}
			finally
			{
				frm.Dispose();
			}
		}

		private void cmdPaymentHistory_Click(object sender, System.EventArgs e)
		{
			frmPaymentHistory frm = new frmPaymentHistory();
			frm.SetupForm(CSession.CaseID);
			frm.ShowDialog();
			try
			{
				ArrayList temp = cMyDB.GetFirstRow("Select Amount, AsAtDate From PaymentAmountHistory Where CaseID = " + CSession.CaseID.ToString() + " AND AsAtDate = (Select Max(AsAtDate) From PaymentAmountHistory Where CaseID = " + CSession.CaseID.ToString() + ")");
				if (temp.Count == 0)
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["PaymentAmount"] = DBNull.Value;
					dsCases1.Cases.Rows[0]["PaymentAmountDate"] = DBNull.Value;
					dsCases1.Cases.Rows[0].EndEdit();
				}
				else
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["PaymentAmount"] = temp[0];
					dsCases1.Cases.Rows[0]["PaymentAmountDate"] = temp[1];
					dsCases1.Cases.Rows[0].EndEdit();
				}
			}
			catch	{}
			finally
			{
				frm.Dispose();
			}
		}

		private void cmdMarketPriceHistory_Click(object sender, System.EventArgs e)
		{
			frmMarketPriceHistory frm = new frmMarketPriceHistory();
			frm.SetupForm(CSession.CaseID);
			frm.ShowDialog();
			try
			{
				ArrayList temp = cMyDB.GetFirstRow("Select MarketPrice, AsAtDate From MarketPriceHistory Where CaseID = " + CSession.CaseID.ToString() + " AND AsAtDate = (Select Max(AsAtDate) From MarketPriceHistory Where CaseID = " + CSession.CaseID.ToString() + ")");
				if (temp.Count == 0)
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["MarketPrice"] = DBNull.Value;
					dsCases1.Cases.Rows[0]["MarketPriceDate"] = DBNull.Value;
					dsCases1.Cases.Rows[0].EndEdit();
				}
				else
				{
					dsCases1.Cases.Rows[0].BeginEdit();
					dsCases1.Cases.Rows[0]["MarketPrice"] = temp[0];
					dsCases1.Cases.Rows[0]["MarketPriceDate"] = temp[1];
					dsCases1.Cases.Rows[0].EndEdit();
				}
			}
			catch	{}
			finally
			{
				frm.Dispose();
			}
		}

		private void tvwIndex_NewCase(object sender, DebtManagerTest.CaseEventArgs e)
		{
			mnuFileNew_Click(sender, e);
		}

		private void tvwIndex_ReactivateCase(object sender, DebtManagerTest.CaseEventArgs e)
		{
			ArchiveCase(e.CaseID,false);
		}

		private void ArchiveCase(Int32 CaseID, bool Archived)
		{
			if (CaseID == CSession.CaseID && dsCases1.Cases.Rows.Count > 0)
			{
				dsCases1.Cases.Rows[0].BeginEdit();
				dsCases1.Cases.Rows[0]["Archived"] = Archived;
				dsCases1.Cases.Rows[0].EndEdit();
				SaveCase(false);
			}
			else if (CaseID > 0)
			{
				cmdChangeArchiveStatus.Parameters["ID"].Value = CaseID;
				cmdChangeArchiveStatus.Parameters["Archived"].Value = Archived;
				cmdChangeArchiveStatus.Parameters["LastUser"].Value = CSession.User.Username;
				cmdChangeArchiveStatus.Parameters["LastUpdated"].Value = DateTime.Now;

				cMyDB.Execute(cmdChangeArchiveStatus);

				tvwIndex.FillDefaultDebtTree();
				if (CSession.CaseID > 0)
				{
					HoldCaseTransition = true;
					tvwIndex.ShowCase(CSession.CaseID);
					HoldCaseTransition = false;
				}
			}
		}

		private void tvwIndex_ArchiveCase(object sender, DebtManagerTest.CaseEventArgs e)
		{
			ArchiveCase(e.CaseID, true);
		}

		private void DeleteCase(Int32 CaseID)
		{
			if (CaseID<=0)
				return;
			if (CaseID == CSession.CaseID && dsCases1.Cases.Rows.Count > 0)
			{
				dsCases1.Cases.Rows[0].Delete();
				daCases.Update(dsCases1, "Cases");
				dsCases1.Clear();
				CSession.SelectCase(0);
				tvwIndex.FillDefaultDebtTree();
			}
			else
			{
				dsCases tempDS = new dsCases();
				daCases.SelectCommand.Parameters["ID"].Value = CaseID;
				daCases.Fill(tempDS, "Cases");
				if (tempDS.Cases.Rows.Count > 0)
				{
					tempDS.Cases.Rows[0].Delete();
				}
				daCases.Update(tempDS, "Cases");
				tempDS.Dispose();
				tvwIndex.FillDefaultDebtTree();
				if (CSession.CaseID > 0)
				{
					HoldCaseTransition= true;
					tvwIndex.ShowCase(CSession.CaseID);
					HoldCaseTransition = false;
				}
			}
		}

		private void tvwIndex_DeleteCase(object sender, DebtManagerTest.CaseEventArgs e)
		{
			DeleteCase(e.CaseID);
		}

		private void mnuFileNew_Click(object sender, System.EventArgs e)
		{
			dsCases tempDS = new dsCases();
			dsCases.CasesRow cdr = tempDS.Cases.NewCasesRow();
			cdr.Created = DateTime.Today;
			cdr.CreateUser = CSession.User.Username;
			cdr.LastUser = CSession.User.Username;
			cdr.LastUpdated = DateTime.Now;
			cdr.PropertyType = "R";
			cdr.EndEdit();
			tempDS.Cases.Rows.Add(cdr);
			try
			{
				daCases.Update(tempDS, "Cases");
			}
			catch
			{
				MessageBox.Show("An unexpected error occured when trying to add the new record. If this problem persists please contact support.","System Error");
				return;
			}
			tvwIndex.FillDefaultDebtTree();
			CSession.SelectCase((Int32) tempDS.Cases.Rows[0]["ID"]);
			tempDS.Dispose();
		}

		private void mnuFileSave_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID > 0 && dsCases1.Cases.Rows.Count > 0)
				this.SaveCase(false);
		}

		private void mnuFileClose_Click(object sender, System.EventArgs e)
		{
			CSession.SelectCase(0);
		}

		private void mnuFileDelete_Click(object sender, System.EventArgs e)
		{
			DeleteCase(CSession.CaseID);
		}

		private void mnuFilePrint_Click(object sender, System.EventArgs e)
		{
		
		}

		private void mnuFileExit_Click(object sender, System.EventArgs e)
		{
			this.Close();
		}

		private void mnuCaseBorrower_Click(object sender, System.EventArgs e)
		{
			MenuSelected = "B";
			frmPerson frm = new frmPerson();
			frm.AddNew(CSession.CaseID, MenuSelected);
			frm.ShowDialog();
			RefreshSelectedMenu();
		}

		private void mnuCaseGuarantor_Click(object sender, System.EventArgs e)
		{
			MenuSelected = "G";
			frmPerson frm = new frmPerson();
			frm.AddNew(CSession.CaseID, MenuSelected);
			frm.ShowDialog();
			RefreshSelectedMenu();
		}

		private void mnuCaseTenant_Click(object sender, System.EventArgs e)
		{
			MenuSelected = "T";
			frmPerson frm = new frmPerson();
			frm.AddNew(CSession.CaseID, MenuSelected);
			frm.ShowDialog();
			RefreshSelectedMenu();
		}

		private void mnuCaseAccount_Click(object sender, System.EventArgs e)
		{
			MenuSelected = "ACC";
			frmAccounts frm = new frmAccounts();
			frm.AddNew(CSession.CaseID);
			frm.ShowDialog();
			RefreshSelectedMenu();
		}

		private void mnuCaseJournal_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID > 0)
				CDiary.NewJournal(CSession.CaseID);
			else
				CDiary.NewJournal();
		}

		private void mnuCaseDiary_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID > 0)
				CDiary.Diarise(CSession.CaseID);
			else
				CDiary.Diarise();
		}

		private void mnuFileAddFav_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID > 0)
			{
				try
				{
					tvwIndex.AddFavourite(CSession.CaseID);
				}
				catch {}
			}
		}

		private void mnuFileDelFav_Click(object sender, System.EventArgs e)
		{
			if (CSession.CaseID > 0)
				tvwIndex.DeleteFavourite(CSession.CaseID);
		}

		private void mnuFileArchive_Click(object sender, System.EventArgs e)
		{
			ArchiveCase(CSession.CaseID, true);
		}

		private void mnuFileReactivate_Click(object sender, System.EventArgs e)
		{
			ArchiveCase(CSession.CaseID, false);
		}

		private void addToOtherMenu(OtherNode n)
		{
			n.Manager.Add(CSession.CaseID);
			if (tvwOther.SelectedNode == n)
			{
				MenuSelected = "OTHER";
				RefreshSelectedMenu();
			}
			else
			{
				OtherNodes.UpdateNodeText(n, CSession.CaseID);
			}
		}

		private void mnuCaseLetter_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu((OtherNode)OtherNodes.OtherNodes[0].Nodes[0]);
		}

		private void mnuCaseValuation_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[1]);
		}

		private void mnuCaseOffer_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[4]);
		}

		private void mnuCaseHoldCode_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[5]);
		}

		private void mnuCaseInvoice_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu((OtherNode)OtherNodes.OtherNodes[2].Nodes[0]);
		}

		private void mnuCaseExpense_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu((OtherNode)OtherNodes.OtherNodes[2].Nodes[1]);		
		}

		private void mnuCaseEndowment_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[3]);
		}

		private void mnuCaseVisit_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[8]);
		}

		private void mnuAdminUsers_Click(object sender, System.EventArgs e)
		{
			(new frmUsers()).ShowDialog();
		}

		private void mnuHelpAbout_Click(object sender, System.EventArgs e)
		{
			(new frmAbout()).ShowDialog();
		}

		private void daCases_RowUpdated(object sender, System.Data.OleDb.OleDbRowUpdatedEventArgs e)
		{
			if (e.RecordsAffected == 0)
			{
				if (e.Errors is System.Data.OleDb.OleDbException)
					throw e.Errors;

				DataSet ds	= new DataSet();
				
				daCases.SelectCommand.Parameters["ID"].Value = e.Row["ID"];
				daCases.Fill(ds);

				if (ds.Tables[0].Rows.Count > 0)
					CUtil.RowUpdatedHandler(e, ds, daCases);
				else
				{
					MessageBox.Show("Required record not available. It may have been deleted by another user.","Update Error");
					e.Status = UpdateStatus.SkipCurrentRow;
				}
				ds.Dispose();
			}
			if (e.StatementType == StatementType.Insert)
			{
				System.Data.OleDb.OleDbCommand getKey = new System.Data.OleDb.OleDbCommand("SELECT @@IDENTITY", e.Command.Connection);
				e.Row["ID"] = getKey.ExecuteScalar();
				getKey.Dispose();
			}
		}

		private void MainForm_Load(object sender, System.EventArgs e)
		{
			if (LoadError)
				this.Close();
		}

		private void mnuReportsMenu_Click(object sender, System.EventArgs e)
		{
			frmReports frm = new frmReports();
			frm.ShowDialog();
			frm.Dispose();
		}

		private void mnuAdminMailMerge_Click(object sender, System.EventArgs e)
		{
			MessageBox.Show("This feature has not been implemented yet. It will allow the creation of ad-hoc, bulk mail merges.", "Under Construction");
		}

		private void mnuAdminLetter_Click(object sender, System.EventArgs e)
		{
			frmCreateLetter frm = new frmCreateLetter();
			frm.ShowDialog();
			frm.Dispose();
		}

		private void mnuAdminSettings_Click(object sender, System.EventArgs e)
		{
			frmConfig frm = new frmConfig(true);
			frm.ShowDialog();
			frm.Dispose();
		}

		private void mnuMain_PopupStart(Crownwood.Magic.Menus.MenuCommand item)
		{
			if (item==mnuFile)
			{
				if (!CSession.AddCases)
					mnuFileNew.Enabled = false;

				if (CSession.CaseID <= 0)
				{
					mnuFileDelete.Enabled = false;
					mnuFileArchive.Enabled = false;
					mnuFileReactivate.Enabled = false;
					mnuFileAddFav.Enabled = false;
					mnuFileDelFav.Enabled = false;
					mnuFileSave.Enabled = false;
					mnuFileClose.Enabled = false;
				}
				else
				{
					if (CSession.DeleteCases)
						mnuFileDelete.Enabled = true;
					else
						mnuFileDelete.Enabled = false;
					if (CSession.ArchiveCases)
					{
						if (tvwIndex.FindNode("AR", CSession.CaseID)== null)
						{
							mnuFileReactivate.Enabled = false;
							mnuFileArchive.Enabled = true;
						}
						else
						{
							mnuFileReactivate.Enabled = true;
							mnuFileArchive.Enabled = false;
						}						
					}
					else
					{
						mnuFileArchive.Enabled = false;
						mnuFileReactivate.Enabled = false;
					}
					
					if (tvwIndex.FindNode("FV", CSession.CaseID)== null)
					{
						mnuFileAddFav.Enabled = true;
						mnuFileDelFav.Enabled = false;
					}
					else
					{
						mnuFileAddFav.Enabled = false;
						mnuFileDelFav.Enabled = true;
					}
					mnuFileSave.Enabled = true;
					mnuFileClose.Enabled = true;
				}
			}
			else if(item == mnuCase)
			{
				foreach (Crownwood.Magic.Menus.MenuCommand m in item.MenuCommands)
				{
					m.Enabled = (CSession.CaseID > 0);
				}
			}
			else if(item == mnuAdmin)
			{
				if (!CSession.AccessSettings)
					mnuAdminSettings.Enabled = false;
				if (!CSession.AccessUserEditor)
					mnuAdminUsers.Enabled = false;
				if (!CSession.BulkMailMerge)
					mnuAdminMailMerge.Enabled = false;
				if (CSession.DisallowEdits)
					mnuAdminLetter.Enabled = false;
			}
			else if(item == mnuReports)
			{
				foreach (Crownwood.Magic.Menus.MenuCommand m in item.MenuCommands)
				{
					m.Enabled = CSession.Reports;
				}
			}
		}

		private void mnuAdminChangePassword_Click(object sender, System.EventArgs e)
		{
			CSession.ChangePassword(CSession.User.UserID);
		}

		private void cboHousingAssociation_ListUpdated(object sender, System.EventArgs e)
		{
			cboEstateAgent.RefreshData();
			cboIndemnityCompany.RefreshData();
			CompanyState = cMyDB.GetFirstRow("Select Count(*) as cnt, Max(LastUpdated) as maxDate from Companies");
			cboHousingAssociation.Focus();
		}

		private void cboEstateAgent_ListUpdated(object sender, System.EventArgs e)
		{
			cboHousingAssociation.RefreshData();
			cboIndemnityCompany.RefreshData();		
			CompanyState = cMyDB.GetFirstRow("Select Count(*) as cnt, Max(LastUpdated) as maxDate from Companies");
			cboEstateAgent.Focus();
		}

		private void cboIndemnityCompany_ListUpdated(object sender, System.EventArgs e)
		{
			cboEstateAgent.RefreshData();
			cboHousingAssociation.RefreshData();
			CompanyState = cMyDB.GetFirstRow("Select Count(*) as cnt, Max(LastUpdated) as maxDate from Companies");
			cboIndemnityCompany.Focus();
		}

		private void mnuCaseInvAcc_Click(object sender, System.EventArgs e)
		{
			addToOtherMenu(OtherNodes.OtherNodes[10]);
		}
	}
}
